 /* atts.c */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/atts.c,v 9.3 1993/03/19 22:53:19 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/atts.c,v 9.3 1993/03/19 22:53:19 isode Exp isode $
 *
 *
 * $Log: atts.c,v $
 * Revision 9.3  1993/03/19  22:53:19  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.2  1992/12/15  07:05:26  awy
 * Update and fixes
 *
 * Revision 8.1  1991/09/13  14:36:41  isode
 * PARADISE Upgrade release
 *
 * Revision 8.0  91/07/17  13:18:34  isode
 * Release 7.0
 *
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#define atts_c
#ifdef DOS
#include <stdlib.h>
#include "proto-de.h"
#endif DOS
#include "messages.h"
#ifdef USELDAP
#ifdef IC
#include <ldap/lber.h>
#include <ldap/ldap.h>
#else
#include <lber.h>
#include <ldap.h>
#endif /* IC */
#include <stdio.h>
#include <string.h>
#include "isomanifest.h"
#else
#include "quipu/util.h"
#include "quipu/attrvalue.h"
#include "quipu/ds_search.h"
#endif USELDAP
#include "demanifest.h"
#include "destrings.h"
#include "namelist.h"
#include "mapatts.h"

#define PADCHARS 22
#define SPACES "        "

#ifdef USELDAP
char * mailDomains();
#else
/* extern char * deTidyString();*/
/*extern int soundex_match();*/
/*extern int sfree();*/
/*extern int dn_cmp();*/
/*extern int dn_free();*/
/*extern PE dn_enc();
extern DN dn_dec();
extern DN str2dnX();
extern char * octparse ();
extern char * prtparse ();*/
extern char * mapPhone ();
extern int ch_set;
extern int telcmp();
#endif USELDAP



int greyBook = FALSE;
char padding[20];
extern int ufnDNs;

#ifdef USELDAP
extern LDAP * ldap_ld;
#endif USELDAP

#ifndef USELDAP
static PS ps = NULLPS;

char *
val2str (av)
AttributeValue  av;
{
char       *cp;

  if (ps == NULL
         && ((ps = ps_alloc (str_open)) == NULLPS)
		  || str_setup (ps, NULLCP, BUFSIZ, 0) == NOTOK) {
      if (ps)
          ps_free (ps), ps = NULLPS;

      return NULLCP;
  }
  AttrV_print(ps, av, READOUT);
  ps_print (ps, " ");
  *--ps -> ps_ptr = NULL, ps -> ps_cnt++;

  cp = ps -> ps_base;

  ps -> ps_base = NULL, ps -> ps_cnt = 0;
  ps -> ps_ptr = NULL, ps -> ps_bufsiz = 0;

  return cp;
}
#endif USELDAP


void
printDetails(objectType, lp)
int objectType;
struct namelist * lp;
{
#ifdef USELDAP
BerElement *cookie;
char * at;
char ** avp;
int i;
#else
Attr_Sequence at;
AV_Sequence av;
char * cp;
#endif USELDAP
int attsPrinted;

  attsPrinted = 0;
  linewrapOn();
#ifdef USELDAP
  for (at = ldap_first_attribute(ldap_ld, lp->ats, &cookie);
                at != NULL; at = ldap_next_attribute(ldap_ld, lp->ats, cookie))
  {
    if ((strcmp(at, DE_DS_OBJECT_CLASS) == 0) ||
	(strcmp(at, DE_OBJECT_CLASS) == 0))
      continue; /* we don't print object classes */
#else
  for (at = lp->ats; at != NULLATTR; at = at->attr_link)
  {
    if (strcmp(attr2name(at->attr_type, OIDPART), DE_OBJECT_CLASS) == 0)
      continue; /* we don't print object classes */
#endif USELDAP
    switch (objectType)
    {
      case PERSON:
        (void) strncpy(padding, SPACES, 8);
	break;
      case ORGUNIT:
        (void) strncpy(padding, SPACES, 6);
	break;
      case ORG:
        (void) strncpy(padding, SPACES, 4);
	break;
      case LOCALITY:
        (void) strncpy(padding, SPACES, 3);
        break;
      case COUNTRY:
        (void) strncpy(padding, SPACES, 2);
	break;
    }
#ifdef USELDAP
    avp = ldap_get_values(ldap_ld, lp->ats, at);
    pageprint("%s%-*s", padding, PADCHARS, 
                mapAttName(at));
    printAttValue(at, avp[0]);
    for (i=1; avp[i] != NULL; i++)
    {
      pageprint("%s%*s", padding, PADCHARS, "");
      printAttValue(at, avp[i]);
    }
    ldap_value_free(avp);
#else
    pageprint("%s%-*s", padding, PADCHARS, 
    		mapAttName(attr2name(at->attr_type, OIDPART)));
    for (av = at->attr_value; av != NULLAV; av = av->avseq_next)
    {
      if (av != at->attr_value)
        pageprint("%s%*s", padding, PADCHARS, "");
      cp = val2str(&(av->avseq_av));
      pageprint("%s\n", cp);
      free(cp);
    }
#endif USELDAP
    attsPrinted++;
  }
  linewrapOff();

  if (attsPrinted == 0)
  {
    switch (objectType)
    {
      case PERSON:
        (void) strncpy(padding, SPACES, 8);
	break;
      case ORGUNIT:
        (void) strncpy(padding, SPACES, 6);
	break;
      case ORG:
        (void) strncpy(padding, SPACES, 4);
	break;
      case LOCALITY:
        (void) strncpy(padding, SPACES, 3);
	break;
      case COUNTRY:
        (void) strncpy(padding, SPACES, 2);
	break;
    }
    pageprint(NODETAILS, padding);
    printOrgOUDetails(objectType);
  }
}

void
printPersonOneLiner(lp, number)
struct namelist * lp;
int number;
{
#ifdef USELDAP
BerElement *cookie;
char * at;
char **av;
#else
Attr_Sequence at;
#endif USELDAP
char mail[LINESIZE], phone[LINESIZE];
char * cp;

  mail[0] = phone[0] = '\0';
  pageprint("       %3d ", number);
  cp = lastComponent(lp->name, PERSON);
  pageprint(" %-19s ", cp);
  free(cp);
#ifdef USELDAP
  for (at = ldap_first_attribute(ldap_ld, lp->ats, &cookie);
                at != NULL; at = ldap_next_attribute(ldap_ld, lp->ats, cookie))
  {
    if (strcmp(at, DE_MAILBOX) == 0)
    {
      av = ldap_get_values(ldap_ld, lp->ats, at);
      (void) strcpy(mail, av[0]);
      ldap_value_free(av);
      continue;
    }
    if (strcmp(at, DE_TELEPHONE) == 0)
    {
      av = ldap_get_values(ldap_ld, lp->ats, at);
      (void) strcpy(phone, av[0]);
      ldap_value_free(av);
      continue;
    }
  }
  pageprint("%-20s  %s\n", mapPhone(phone), mailDomains(mail));
#else
  for (at = lp->ats; at != NULLATTR; at = at->attr_link)
  {
    if (strcmp(attr2name(at->attr_type, OIDPART), DE_MAILBOX) == 0)
    {
      cp = val2str(&(at->attr_value->avseq_av));
      (void) strcpy(mail, cp);
      free(cp);
      continue;
    }
    if (strcmp(attr2name(at->attr_type, OIDPART), DE_TELEPHONE) == 0)
    {
      cp = val2str(&(at->attr_value->avseq_av));
      (void) strcpy(phone, cp);
      free(cp);
      continue;
    }
  }
  pageprint("%-20s  %s\n", phone, mail);
#endif USELDAP
}

#ifdef USELDAP

#ifdef DOS
void
#endif DOS
printAttValue(type, value)
char * type, * value;
{
char *cp, *cp2;

  if (strcmp(type, "postalAddress") == 0)
    for (cp = value; cp != NULLCP; cp = cp2)
    {
      cp2 = index(cp, '$');
      if (cp2 != NULLCP)
        *cp2++ = '\0';
      if (cp != value)
        pageprint("%s%*s", padding, PADCHARS, "");
      pageprint("%s\n", cp);
      if (cp2 != NULLCP)
        while (*cp2 == ' ')
          cp2++;
    }
  else if (strcmp(type, DE_MAILBOX) == 0)
      pageprint("%s\n", mailDomains(value));
  else if (strcmp(type, DE_TELEPHONE) == 0)
    pageprint("%s\n", mapPhone(value));
  else if (strcmp(type, DE_FAX) == 0)
    pageprint("%s\n", mapPhone(value));
  else
    pageprint("%s\n", value);
}

char *
mailDomains(mstr)
char * mstr;
{
char *cp, *cp2;
static char    buf[BUFSIZ];
char workbuf[BUFSIZ];
char    *ptr = buf;

    if ((greyBook == TRUE) && (index(mstr, '@') != NULLCP))
    {
      (void) strcpy(workbuf, mstr);
      for (cp = workbuf; *cp != '@'; *ptr++ = *cp++) {};
      *ptr++ = *cp++;
      *ptr = '\0';
      while (TRUE)
      {
        cp2 = rindex(cp, '.');
        if (cp2 != NULLCP)
        {
          (void) strcat(buf, cp2 + 1);
          (void) strcat(buf, ".");
          *cp2 = '\0';
        }
        else
        {
          (void) strcat(buf, cp);
          break;
        }
      }
      return buf;
    }
    else
      return mstr;
}

#else

/* special functions for printing attributes with certain syntaxes */

extern int postal_indent;

static de_addrprint (xps,addr,format)
PS xps;
struct postaddr * addr;
int format;
{
char * prefix = NULLCP;
char prefbuff[100];

	for (; addr != (struct postaddr *) NULL; addr = addr->pa_next) 
	{
                if (prefix != NULLCP)
                        if (format != READOUT || postal_indent < 0)
                            ps_print (xps,prefix);
                        else 
			{
				ps_print (xps, "\n");
				if (postal_indent > 0)
				    ps_printf (xps, "%*s", postal_indent, "");
			}
		if (addr->addrtype == 1) 
		{
			if (format != READOUT) {
			    ps_print (xps,"{T.61}");
			    octprint (xps,addr->addrcomp,format);
			} else if (ch_set == 1)
			    iso8859print(xps, addr->addrcomp);
			else
			    octprint (xps,addr->addrcomp,format);
		}
		else
			ps_print (xps,addr->addrcomp);
		if (format == READOUT) 
		{
			if (postal_indent == 0)
				postal_indent = 2;
			(void) sprintf(prefbuff, "\n%s%*s", padding, PADCHARS, "");
			prefix = prefbuff;
		}
	}
}

/* special functions for handling email addresses */

de_mailprint (xps,str)
PS xps;
char * str;
{
char	buf[BUFSIZ], workbuf[BUFSIZ];
char	*ptr = buf;
char	* cp, * cp2;

  if ((greyBook == TRUE) && (index(str, '@') != NULLCP))
  {
    (void) strcpy(workbuf, str);
    for (cp = workbuf; *cp != '@'; *ptr++ = *cp++) {};
    *ptr++ = *cp++;
    *ptr = '\0';
    while (TRUE)
    {
      cp2 = rindex(cp, '.');
      if (cp2 != NULLCP)
      {
        (void) strcat(buf, cp2 + 1);
	(void) strcat(buf, ".");
	*cp2 = '\0';
      }
      else
      {
        (void) strcat(buf, cp);
	break;
      }
    }
    ps_print(xps, buf);
  }
  else
    ps_print(xps, str);
}

/* modified version of dn_print to give appropriately formatted DNs
   the code should only alter the print format for READOUT */
   
de_dn_print (xps,dn,format)
PS   xps;
DN  dn;
int  format;
{
register DN eptr;
int pad;
char padstr[100];

	if (dn == NULLDN) {
		return ;
	}

	if (ufnDNs == TRUE) {
	    ufn_dn_print (xps, dn, 0);
	    return;
	}

	if (format == READOUT)
	{
		pad = PADCHARS + strlen(padding) + 2;
		AttrV_print(xps, &(dn->dn_rdn->rdn_av), format);
		for (eptr = dn->dn_parent; eptr != NULLDN; eptr = eptr->dn_parent)
		{
			(void) sprintf(padstr, ",\n%*s", pad, "");
			ps_print(xps, padstr);
			AttrV_print(xps, &(eptr->dn_rdn->rdn_av), format);
			pad += 2;
		}
	}
	else
	{
		dn_comp_print (xps,dn,format);
		for (eptr = dn->dn_parent; eptr != NULLDN; eptr = eptr->dn_parent) {
			switch (format) {
				case DIROUT:  ps_print (xps,"/"); break;
				case FILEOUT:
				case RDNOUT:
				case EDBOUT:  ps_print (xps,"@"); break;
				case READOUT: ps_print (xps,"\n\t\t\t"); break;
			}
			dn_comp_print (xps,eptr,format);
		}
	}
}


de_phone_print (xps,str,format)
PS xps;
char * str;
int format;
{
  if (*str == T61_MARK) 
  {
    if (format != READOUT) 
    {
      ps_print (xps,"{T.61}");
      octprint (xps,mapPhone(++str),format);
    } 
    else 
      if (ch_set == 1)
        iso8859print(xps,mapPhone(++str));
      else
        octprint(xps,mapPhone(++str),format);
  } 
  else 
  {
    if ((*str == ' ') && (*(str+1) == 0))
      if (format == READOUT)
        ps_print (xps," (single space)");
      else
        ps_print (xps,"\\20");
    else
        ps_print (xps,mapPhone(str));
  }
}


struct pair {
    char   *p_name;
    int     p_value;
};


static struct pair pairs[] = {
    "twoDimensional", 8,
    "fineResolution", 9,
    "unlimitedLength", 20,
    "b4Length", 21,
    "a3Width", 22,
    "b4Width", 23,
    "uncompressed", 30,
    NULL
};

static	de_fax_print (xps, f, format)
register PS xps;
register struct fax *f;
int	format;
{
    register int   i;
    register struct pair *p;
    register PE    pe;

    if (format == READOUT) {
	ps_printf (xps, "%s", mapPhone(f -> number));

	if ((pe = f -> bits) && (i = pe -> pe_nbits) > 0) {
	    char    *cp = " {";

	    while (i-- >= 0)
		if (bit_test (pe, i) > OK) {
		    for (p = pairs; p -> p_name; p++)
			if (p -> p_value == i)
			    break;
		    if (p -> p_name)
			ps_printf (xps, "%s %s", cp, p -> p_name);
		    else
			ps_printf (xps, "%s %d", cp, i);
		    cp = ",";
		}

	    if (*cp == ',')
		ps_print (xps, " }");
	}
    }
    else {
	ps_printf (xps, "%s", mapPhone(f -> number));

	if ((pe = f -> bits) && (i = pe -> pe_nbits) > 0) {
	    char    *cp = " $";

	    while (i-- >= 0)
		if (bit_test (pe, i) > OK) {
		    for (p = pairs; p -> p_name; p++)
			if (p -> p_value == i)
			    break;
		    if (p -> p_name)
			ps_printf (xps, "%s %s", cp, p -> p_name);
		    else
			ps_printf (xps, "%s %d", cp, i);
		    cp = "";
		}
	}
    }
}


specialSyntaxHandlers()
{
  set_av_printer (str2syntax("PostalAddress"), (IFP) de_addrprint);
  set_av_printer (str2syntax("DN"), (IFP) de_dn_print);
  set_av_printer (str2syntax("TelephoneNumber"), de_phone_print);
  set_av_printer (str2syntax("FacsimileTelephoneNumber"), de_fax_print);

  /* modify syntax handler for rfc822 mail attribute 
     to allow for JNT ordering */
  modify_av_printer(str2AttrT(DE_MAILBOX), str2syntax(DE_MAILBOX),
			de_mailprint);
}

#endif USELDAP

#ifdef BOTTOM
void foo_dn_print (ps,dn,format)
DN  dn;
PS   ps;
int  format;
{
register DN eptr;

        if (dn == NULLDN) {
                if (format == READOUT)
                        ps_print (ps,"NULL DN");
                return ;
        }

        if (format == UFNOUT) {
            ufn_dn_print (ps, dn, 1);
            return;
        }

	if (dn != NULLDN) foo_rdn_print(ps,dn->dn_rdn,format);
/*        dn_comp_print (ps,dn,format); */

        for (eptr = dn->dn_parent; eptr != NULLDN; eptr = eptr->dn_parent) {
                switch (format) {
                        case DIROUT:  ps_print (ps,"/"); break;
                        case FILEOUT:
                        case RDNOUT:
                        case EDBOUT:  ps_print (ps,"@"); break;
                        case READOUT: ps_print (ps,"\n\t\t\t"); break;
                }
/*                dn_comp_print (ps,eptr,format); */
		  if (eptr != NULLDN) foo_rdn_print(ps, eptr->dn_rdn,format);
        }
}


#include "quipu/name.h"

foo_rdn_comp_print (ps,rdn,format)
PS   ps;
RDN  rdn;
int  format;
{

	if (rdn!=NULLRDN) {
		AttrT_print (ps,rdn->rdn_at,format);
		ps_print (ps,"=");
		AttrV_print (ps,&rdn->rdn_av,format);
	}
	return;
}

foo_rdn_print (ps,rdn,format)
RDN  rdn;
PS   ps;
int  format;
{
register RDN eptr;

	if (rdn ==  NULLRDN) {
		if (format == READOUT)
			ps_print  (ps,"NULL RDN");
		return;
	}

	foo_rdn_comp_print (ps,rdn,format);

		for (eptr=rdn->rdn_next; eptr!=NULLRDN; eptr=eptr->rdn_next) {
			ps_print (ps,"%"); 
			foo_rdn_comp_print (ps,eptr,format);
		}

}

#endif
