/* bind.c */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/bind.c,v 9.3 1993/03/19 22:53:23 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/bind.c,v 9.3 1993/03/19 22:53:23 isode Exp isode $
 *
 *
 * $Log: bind.c,v $
 * Revision 9.3  1993/03/19  22:53:23  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.2  1992/12/15  07:05:26  awy
 * Update and fixes
 *
 * Revision 8.1  1991/09/13  14:36:41  isode
 * PARADISE Upgrade release
 *
 * Revision 8.0  91/07/17  13:18:35  isode
 * Release 7.0
 *
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */


/*****************************************************************************

  bind.c -

*****************************************************************************/

#define bind_c
#include "messages.h"
#include <stdio.h>
#include "bind.h"
#include "util.h"
#include "demanifest.h"
#ifdef DOS
#include "proto-de.h"
#include <stdlib.h>
#include "msdos.h"
#endif DOS
#ifdef USELDAP
#include <string.h>
#ifdef IC
#include <ldap/lber.h>
#include <ldap/ldap.h>
#else
#include <lber.h>
#include <ldap.h>
#endif /* IC */
#include "isomanifest.h"
#else
#include "quipu/common.h"
#include "quipu/bind.h"
#include "quipu/dap2.h"
#ifdef IC
#include "compat/logger.h"
#else
#include "logger.h"
#endif /* IC */
#ifdef OSISEC
#include "osisec/osisec.h"
#endif
#include "osisec-stub.h"
#endif USELDAP

/* OSISEC */
char * dsa_name;

extern char *dsa_address;
extern char *backup_dsa_address;
extern char *username;
extern char *password;
extern char callingDteNumber[];
extern struct SecurityServices *dsap_security;

extern int boundToDSA;
extern int deLogLevel;
extern int authLevel;

#ifdef USELDAP
extern LDAP * ldap_ld;
extern char *ldapServer;
extern int ldapPort;
extern char * logfilename;
#ifndef DOS
extern FILE *de_log;
extern int depid;
#endif DOS
#else
extern LLog *de_log;

/* this is not the way to do it */
extern int dsap_ad;

struct DAPconnect         dc;
struct DAPindication      di;

static int bindres;
static int triedBackup = FALSE;
static int bindStarted = FALSE;
#endif USELDAP
static int boundOnce = FALSE;
static int connMessDisplayed = FALSE;

#ifndef USELDAP

int tryBackup()
{

/* OSISEC */
  if (authLevel == AUTH_STRONG)
  {
    (void)printf(CANTUSEBACKUP);
    return NOTOK;
  }
  if (triedBackup == TRUE)
    return NOTOK;
  if (backup_dsa_address == NULLCP)
    return NOTOK;
  else
  {
    free(dsa_address);
    dsa_address = copy_string(backup_dsa_address);
    triedBackup = TRUE;
    return OK;
  }
}

/*
 * bind_to_ds - Bind to directory
 *
 */
int init_bind_to_ds(assoc)
int * assoc;
{
struct ds_bind_arg bind_arg;
struct PSAPaddr             *addr;
void exit();

#ifdef OSISEC
  if (authLevel == AUTH_STRONG)
  {
    if (boundOnce == FALSE)
    {
      osisec_tailor(OSISECUSERTAILORFILE, log_osisec);
      (void)use_sig_rSAMD2withRSAENCRYPTION();
    }
  }
#endif

  if (dsa_address == NULLCP)
  {
    (void) fprintf(stderr, NOADDRESS);
    exit(-1);
  }

  if (triedBackup == FALSE)
    if (connMessDisplayed == FALSE)
    {
        (void)printf(CONNECTING);
	connMessDisplayed = TRUE;
    }

  bind_arg.dba_version = DBA_VERSION_V1988;
  switch (authLevel)
  {
    case AUTH_STRONG:
#ifdef OSISEC
      bind_arg.dba_auth_type = DBA_AUTH_STRONG;
      bind_arg.dba_toauthdn = str2dn(username);
      bind_arg.dba_dn = str2dn(dsa_name);
      if (bind_arg.dba_dn == NULLDN)
      {
        (void)fprintf(stderr, BADDSANAME);
	de_exit(-1);
      }
      if (DSAP_MKBIND(dsap_security, &bind_arg) != OK) 
      {
      		if (strcmp(dsap_security->serv_name, 
		           "quipusecurityservices") == 0)
			(void)fprintf(stderr, NEEDOSISEC);
		else
			(void)fprintf(stderr, FAILSTRONGCREDS);
		de_exit(-1);
      }
      if (!bind_arg.dba_cpath || !bind_arg.dba_cpath->cert) 
      {
	(void)fprintf(stderr, INSUFFCERTCREDS);
	de_exit(-1);
      }
      if (dn_cmp(bind_arg.dba_cpath->cert->subject, bind_arg.dba_toauthdn)) 
      {
	(void)fprintf(stderr, CERTMATCHPROBLEM);
	de_exit(-1);
      }
      break;
#else
      (void)fprintf(stderr, NOOSISECLIBS);
      de_exit(-1);
#endif
    default:			
      bind_arg.dba_auth_type = DBA_AUTH_SIMPLE;

      bind_arg.dba_dn = str2dn(username);

      if (password == NULLCP)
      {
        bind_arg.dba_passwd[0] = '\0';
        bind_arg.dba_passwd_len = 0;
      }
      else
      {
        (void)strcpy(bind_arg.dba_passwd, password);
        bind_arg.dba_passwd_len = strlen(password);
      }
  }

try_bind:

  if ((addr = str2paddr (dsa_address)) == NULLPA) {
    (void) fprintf(stderr, BADADDRESS);
    exit(-1);
  }
  bindres = DapAsynBindRequest(addr, &bind_arg, &dc, &di, ROS_ASYNC);
  if (bindres == NOTOK)
  {
    (void) fprintf(stderr, TEMPUNAVAIL);
    if (tryBackup() == OK)
    {
      (void) fprintf(stderr, TRYANOTHER);
      goto try_bind;
    }
    return NOTOK;
  }
  *assoc = dc.dc_sd;
  dsap_ad = dc.dc_sd;
  return OK;
}


int wait_bind_to_ds(assoc, wantToBlock, authProblem)
int assoc;
int wantToBlock;
int * authProblem;
{
  struct PSAPindication   pi_s;
  struct PSAPindication   * pi = &(pi_s);
  int     nfds = 0, nevents;
  fd_set  rfds;
  fd_set  wfds;
  * authProblem = FALSE;

  while ((bindres == CONNECTING_1) || (bindres == CONNECTING_2)) 
  {

    FD_ZERO (&rfds);
    FD_ZERO (&wfds);

    if ((bindres == CONNECTING_2) && (wantToBlock == FALSE))
      return CONNECTING_2;

    if (bindres == CONNECTING_1) 
    {
      if (PSelectMask (assoc, &wfds, &nfds, pi) == NOTOK) 
      {
         (void) fprintf(stderr, "PSelectMask (write) failed\n");
         return NOTOK;
      }
    }

    if (bindres == CONNECTING_2) 
    {
      if (PSelectMask (assoc, &rfds, &nfds, pi) == NOTOK) 
      {
        (void) fprintf(stderr, "PSelectMask (read) failed\n");
        return NOTOK;
      }
    }

    nevents = xselect (nfds, &rfds, &wfds, NULLFD, NOTOK);
  
    if (nevents == NOTOK) 
    {
      (void) fprintf(stderr, "xselect failed\n");
      return NOTOK;
    } 
    else 
    {
      /*
       * Hack coming up: nevents is number of events, we only asked for
       * one event, so unless there are no events we go ahead without
       * checking those horrid fd things, which would be safer.
       */
       if (nevents != OK) 
         bindres = DapAsynBindRetry(assoc, 0, &dc, &di);
    }
  
    if (bindres == DONE)
    {
      if (dc.dc_result != DC_RESULT)
      {
        if (dc.dc_un.dc_bind_err.dbe_type == DBE_TYPE_SECURITY)
 	{
	  if (dc.dc_un.dc_bind_err.dbe_value == DSE_SC_INVALIDCREDENTIALS)
	  {
	    (void)fprintf(stderr, NOBIND1);
	    * authProblem = TRUE;
	  }
	  else if (dc.dc_un.dc_bind_err.dbe_value == DSE_SC_AUTHENTICATION)
            (void)fprintf(stderr, NOBIND2);
	}
        else
	  (void)fprintf(stderr, NOBIND3, 
	    dc.dc_un.dc_bind_err.dbe_type, dc.dc_un.dc_bind_err.dbe_value);
        return NOTOK;
      }
      boundToDSA = TRUE;
      boundOnce = TRUE;
      if (deLogLevel)
        (void) ll_log (de_log, LLOG_NOTICE, NULLCP, "Bound: %s", callingDteNumber);
      return OK;
    }
  }
  if (tryBackup() == OK)
    if (init_bind_to_ds(&assoc) == OK)
      return OK;
  if (authLevel != AUTH_STRONG) /* if auth = strong, user should get another message */
    (void)fprintf(stderr, BINDFAIL);
  return NOTOK; /* exit this way if can't talk to access point(s) */
} /* bind_to_ds */

#endif USELDAP

int
rebind()
{
  if (boundToDSA == FALSE)
    return(de_bind(TRUE));
  else
    return OK;
}

int 
de_bind(wantToBlock)
int wantToBlock;
{
int tries;
char pwstr[BUFSIZ];
extern char * quipuDN2DS23DN();
#ifdef USELDAP
#ifndef DOS
char * getpass();
#endif
#else
char * getpassword();
static int assoc;
int authProblem;
#endif

#ifdef USELDAP
  if (ldapServer == NULLCP)
  {
    (void) fprintf(stderr, NOLDAPSERV);
    exit(-1);
  }
  if (connMessDisplayed == FALSE)
  {
      (void)printf(CONNECTING);
      connMessDisplayed = TRUE;
  }
  if ((ldap_ld = ldap_open(ldapServer, ldapPort)) == NULL )
  {
    (void) printf(NOLDAPCONN, ldapServer);
    (void) de_exit(-1);
  }

/* THIS NEEDS FIXING - THE BEHAVIOUR DIFFERS BETWEEN THE DAP AND LDAP 
   VERSIONS - THE DAP VERSION DERERFS NEAR THE LEAVES, BUT NOT NEAR
   THE TREE ROOT */
  ldap_ld->ld_deref = LDAP_DEREF_NEVER;

  if (authLevel == AUTH_SIMPLE)
    if (username == NULLCP)
    {
      (void) fprintf(stderr,NONAME);
      (void) de_exit(-1);
    }
  (void)sprintf(pwstr, "%s%s\n:-", PASSWORDPROMPT, username);
  for (tries = 1;;tries++)
  {
    if (authLevel == AUTH_SIMPLE)
    {
#ifndef DOS
      if (password == NULLCP)
        password = getpass(pwstr);
#endif DOS
      if (password == NULLCP)
        (void) fprintf(stderr, NOAUTHBIND);
    }
    else 
    {
      if (password != NULLCP)
      {
        free(password);
        password = NULLCP;
      }
      if (authLevel == AUTH_NONE)
      {
        free(username);
        username = NULLCP;
      }
    }
    if (ldap_bind_s(ldap_ld, username, password, LDAP_AUTH_SIMPLE)
                == LDAP_SUCCESS)
	break;
    else
    {
      if (authLevel == AUTH_SIMPLE)
      {
        (void) fprintf(stderr, PASSPROB);
        password = NULLCP;
	if (tries < 3)
	  continue; 
	/* else drop through and exit */
	(void) fprintf(stderr, THREETRIES);
      }
      (void) printf(NOLDAPCONN, ldapServer);
      ldap_perror(ldap_ld, LDREASON);
      (void) de_exit(-1);
    }
  }
#ifndef DOS
  if (deLogLevel)
    (void) fprintf (de_log, "%5d:Bound:\n", depid);
#endif DOS
  boundToDSA = TRUE;
  boundOnce = TRUE;
#else
  if ((authLevel == AUTH_SIMPLE) || (authLevel == AUTH_STRONG))
  {
    if (username == NULLCP)
    {
      (void) fprintf(stderr, NONAME);
      (void) de_exit(-1);
    }
    wantToBlock = TRUE; /* force synchronous bind - so can correct password
                           if in error */
  }
  if (authLevel == AUTH_SIMPLE)
    (void)sprintf(pwstr, "%s%s\n:-", PASSWORDPROMPT, quipuDN2DS23DN(username));
  for (tries = 1;;tries++)
  {
    if (authLevel == AUTH_SIMPLE)
    {
      if (password == NULLCP)
        password = getpassword(pwstr);
      if (strlen(password) == 0)
        (void) fprintf(stderr, NOAUTHBIND);
    }
    else if ((authLevel == AUTH_NONE) || (authLevel == AUTH_NAME))
    {
      if (password != NULLCP)
      {
        free(password);
        password = NULLCP;
      }
      if (authLevel == AUTH_NONE)
      {
        free(username);
        username = NULLCP;
      }
    }
    if (bindStarted == FALSE)
    {
      if (init_bind_to_ds(&assoc) != OK)
        return NOTOK;
      bindStarted = TRUE;
      if (wantToBlock == FALSE)
        return OK;
    }
    if (wait_bind_to_ds(assoc, wantToBlock, &authProblem) != NOTOK)
      break;
    else
    {
      if (authLevel == AUTH_SIMPLE)
      {
        if (authProblem == TRUE)
        {
          bindStarted = FALSE;
          (void) fprintf(stderr, PASSPROB);
	  password = NULLCP;
	  if (tries < 3)
	    continue;
	  /* else drop through and exit */
	  (void) fprintf(stderr, THREETRIES);
        }
      }
      return NOTOK;
    }
  }
#endif USELDAP
  if (authLevel == AUTH_STRONG)
    (void)printf(STRONGBINDOK);
  return OK;
}

void
de_unbind()
{
#ifdef USELDAP
#ifndef DOS
  if (deLogLevel)
    (void) fprintf (de_log, "%5d:Unbind:\n", depid);
#endif DOS
  ldap_unbind(ldap_ld);
  boundToDSA = FALSE;
#else
  if (deLogLevel)
    (void) ll_log (de_log, LLOG_NOTICE, NULLCP, "Unbind:");
  (void) ds_unbind();
  boundToDSA = FALSE;
  bindStarted = FALSE;
#endif USELDAP
}

