/* browse.c */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/browse.c,v 9.2 1993/03/19 22:53:30 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/browse.c,v 9.2 1993/03/19 22:53:30 isode Exp isode $
 *
 *
 * $Log: browse.c,v $
 * Revision 9.2  1993/03/19  22:53:30  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.1  1992/12/15  07:03:01  awy
 * IC-R1 base
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#ifndef DOS
#define browse_c

#include <stdio.h>
#ifdef USELDAP
#include "isomanifest.h"
#include "demanifest.h"
#else
#include "quipu/util.h"
#endif USELDAP
#include "util.h"
#include "messages.h"

extern char term[];
extern int lines, cols;
extern int browserAvail;
extern char * browserPath;
#ifndef USELDAP
extern char *isodebinpath;
#endif
	
doBrowse()
{
char * args[4];
char buf[80];
char execPath[LINESIZE];

  if (browserAvail != TRUE)
  {
    (void)printf(NOBROWSER);
    return;
  }
  switch(fork())
  {
    case -1:
      (void)fprintf(stderr, "Fork failure\n");
      de_exit(-1);
    case 0: /* child */
      (void) sprintf(buf, "%dx%d", lines, cols);
      args[0] = copy_string("DEbrowser"); /* the form of this partly
                                             capitalised string is important
                                             as it is used by the browser to
                                             to determine whether it has been
                                             started from DE */
      args[1] = copy_string("-term");
      args[2] = copy_string(term);
      args[3] = copy_string("-size");
      args[4] = copy_string(buf);
      args[5] = (char *)NULL;
      if (browserPath != NULLCP)
        (void)strcpy(execPath, browserPath);
      else
#ifdef USELDAP
	(void)sprintf(execPath,"%s/debrowser", BINPATH);
#else	
        (void)sprintf(execPath,"%s/debrowser", isodebinpath);
#endif USELDAP
      (void)execvp(execPath, args);
      (void)fprintf(stderr, BROWSERPROBLEM);
      de_exit(-1);
    default: /* parent */
      (void)printf(BROWSEWAIT);
      if (wait(NULLIP) == -1)
      {
        (void)fprintf(stderr, "Wait failure\n");
	de_exit(-1);
      }
  }
}
#endif DOS
