/* country.c - search for a country */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/country.c,v 9.3 1993/03/19 22:53:46 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/country.c,v 9.3 1993/03/19 22:53:46 isode Exp isode $
 *
 *
 * $Log: country.c,v $
 * Revision 9.3  1993/03/19  22:53:46  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.2  1992/12/15  07:05:26  awy
 * Update and fixes
 *
 * Revision 8.1  1991/09/13  14:36:41  isode
 * PARADISE Upgrade release
 *
 * Revision 8.0  91/07/17  13:18:38  isode
 * Release 7.0
 *
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#define country_c
#ifdef DOS
#include <stdlib.h>
#include "proto-de.h"
#endif DOS
#include "messages.h"
#include <signal.h>
#ifdef USELDAP
#ifdef IC
#include <ldap/lber.h>
#include <ldap/ldap.h>
#else
#include <lber.h>
#include <ldap.h>
#endif /* IC */
#include <string.h>
#include "isomanifest.h"
#ifdef DOS
#include <msdos.h>
#else
#include <sys/time.h>
#endif DOS
#else
#include "quipu/util.h"
#include "quipu/read.h"
#include "quipu/list.h"
#include "quipu/ds_search.h"
#include "quipu/dua.h"
#endif USELDAP
#include "demanifest.h"
#include "namelist.h"
#include "filter.h"
#include "destrings.h"

#ifndef USELDAP
extern char filbuf[];
struct ds_read_arg rarg;
struct ds_read_result rresult;

struct ds_list_arg larg;
struct ds_list_result lresult;

struct ds_search_arg sarg;
struct ds_search_result sresult;
struct DSError serror;
#endif USELDAP

extern int abandoned;
extern int highNumber;
extern int exactMatch;
extern int fuzzyMatching;
extern int gotFuzzyMatch;
extern char exactString[];
extern int searchAlias;
extern char searchVal[];

extern struct namelist * atts[];

int listAtRoot = TRUE;

#ifdef USELDAP
extern LDAP * ldap_ld;
extern char * ldap_base;
extern int ldap_scope;
extern char ldap_filter[BUFSIZ];
extern char ** ldap_attrs;
extern char ldap_attrsonly;
extern int ldap_msgid;
extern int ldap_all;
extern struct timeval ldap_timeout;
extern LDAPMessage * ldap_res;
LDAPMessage * ldap_delete_result_entry();
void fillMostCountryReadArgs();
void fillMostCountryListArgs();
void fillMostCountrySearchArgs();
#else
struct ds_read_arg *fillMostCountryReadArgs();
struct ds_list_arg *fillMostCountryListArgs();
struct ds_search_arg *fillMostCountrySearchArgs();
Filter get_filter();
#endif USELDAP

void makeExplicitCoFilter();
void coFilter1(), coFilter2(), coFilter3(), coFilter4();

VFP explicitCo[] = {makeExplicitCoFilter, NULLVFP};
VFP normalCo[] = {coFilter1, coFilter2, coFilter3, coFilter4, NULLVFP};

int
makeRootCountry(clistp)
struct namelist ** clistp;
{
	*clistp = list_alloc();
	(*clistp)->name = copy_string("root");
#ifdef USELDAP
        (*clistp)->ats = NULLMSG;
#else
	(*clistp)->ats = NULLATTR;
#endif USELDAP
	(*clistp)->next = NULLLIST;
	return OK;
}
		
int
listCos(cstr, clistp)
char * cstr;
struct namelist ** clistp;
{
	return (listEntries("", cstr, clistp, COUNTRY));
}

void
printListCos(cstr, clistp)
char * cstr;
struct namelist * clistp;
{
struct namelist * x;
int i;

	if (clistp == NULLLIST)
		pageprint(NOCOSMATCH);
	else
	{
		for (i =1, x = clistp; x != NULLLIST; i++, x = x->next)
			printLastComponent(INDENTON, x->name, COUNTRY, i);
		showAnyProblems(cstr);
	}
}

/*
reallyMakeListCountries(clistp)
struct namelist ** clistp;
{
	return(reallyMakeListEntries(clistp, COUNTRY));
}

makeListCountries(clistp)
struct namelist ** clistp;
{
	makeListEntries(clistp);
}

void
fillMostCountryReadArgs(objectstr)
char * objectstr;
{
	fillMostReadArgs(objectstr, COUNTRY, DE_UNSIGNED);
}

void
fillMostCountryListArgs()
{
	fillMostListArgs("", COUNTRY);
}

void
fillMostCountrySearchArgs(objectstr, searchdepth)
char * objectstr;
int searchdepth;
{
	fillMostSearchArgs(objectstr, searchdepth, COUNTRY);
}
*/

#ifdef USELDAP
#ifdef DOS
void
#endif DOS
makeAllCoFilter()
{
        gotFuzzyMatch = FALSE;
        (void)strcpy(ldap_filter, "(|(objectclass=country)(objectclass=locality))");
}
#else
makeAllCoFilter(fpp)
struct s_filter ** fpp;
{
        gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "(%s=%s) | (%s=%s)", DE_OBJECT_CLASS, 
		DE_COUNTRY, DE_OBJECT_CLASS, DE_LOCALITY);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
makeExplicitCoFilter(cstr, junk1, junk2)
char * cstr, * junk1, * junk2;
{
        gotFuzzyMatch = FALSE;
        (void)sprintf(ldap_filter, "(&(|(objectclass=country)(objectclass=locality))");
        (void)sprintf(ldap_filter, "%s (|(c=%s)(co=%s))",
                     ldap_filter, cstr, cstr);
        (void)sprintf(ldap_filter, "%s(localityName=%s)", ldap_filter, cstr);
}
#else
void
makeExplicitCoFilter(cstr, junk1, junk2, fpp)
char * cstr, * junk1, * junk2;
struct s_filter ** fpp;
{
        gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "((%s=%s)|(%s=%s)) & ((%s=%s)|(%s=%s)|(%s=%s))",
		DE_OBJECT_CLASS, DE_COUNTRY, DE_OBJECT_CLASS, DE_LOCALITY,
		DE_COUNTRY_NAME, cstr, DE_FRIENDLY_COUNTRY, cstr,
		DE_LOCALITY_NAME, cstr);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
coFilter1(cstr, junk1, junk2)
char * cstr, * junk1, * junk2;
{
        gotFuzzyMatch = FALSE;
        (void)sprintf(ldap_filter, "(|(&(objectclass=country)");
        if (strlen(cstr) == 2)
                (void)sprintf(ldap_filter,  "%s(c=%s))", ldap_filter, cstr);
        else
                (void)sprintf(ldap_filter,  "%s(co=%s))", ldap_filter, cstr);
        (void)sprintf(ldap_filter,  "%s(&(objectclass=locality)(l=%s)))",
                ldap_filter, cstr);
}
#else
void
coFilter1(cstr, junk1, junk2, fpp)
char * cstr, * junk1, * junk2;
struct s_filter ** fpp;
{

        gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "((%s=%s)&", DE_OBJECT_CLASS, DE_COUNTRY);
	if ((strlen(cstr) == 2) && (check_3166(cstr)))
		(void)sprintf(filbuf, "%s(%s=%s))", filbuf, DE_COUNTRY_NAME, cstr);
	else
		(void)sprintf(filbuf, "%s(%s=%s))", filbuf, DE_FRIENDLY_COUNTRY, cstr);
	(void)sprintf(filbuf, "%s|((%s=%s)&(%s=%s))", filbuf,
		DE_OBJECT_CLASS, DE_LOCALITY, DE_LOCALITY_NAME, cstr);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
coFilter2(cstr, junk1, junk2)
char * cstr, * junk1, * junk2;
{
        gotFuzzyMatch = FALSE;
        (void)sprintf(ldap_filter, "(|(&(objectclass=country)");
        (void)sprintf(ldap_filter,  "%s(co=%s*))", ldap_filter, cstr);
        (void)sprintf(ldap_filter,  "%s(&(objectclass=locality)(l=%s*)))",
                ldap_filter, cstr);
}
#else
void
coFilter2(cstr, junk1, junk2, fpp)
char * cstr, * junk1, * junk2;
struct s_filter ** fpp;
{
        gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "((%s=%s)|(%s=%s)) & ((%s=%s*)|(%s=%s*))",
		DE_OBJECT_CLASS, DE_COUNTRY, DE_OBJECT_CLASS, DE_LOCALITY,
		DE_FRIENDLY_COUNTRY, cstr,
		DE_LOCALITY_NAME, cstr);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
coFilter3(cstr, junk1, junk2)
char * cstr, * junk1, * junk2;
{
        gotFuzzyMatch = FALSE;
        (void)sprintf(ldap_filter, "(|(&(objectclass=country)");
        (void)sprintf(ldap_filter,  "%s(co=*%s*))", ldap_filter, cstr);
        (void)sprintf(ldap_filter,  "%s(&(objectclass=locality)(l=*%s*)))",
                ldap_filter, cstr);
}
#else
void
coFilter3(cstr, junk1, junk2, fpp)
char * cstr, * junk1, * junk2;
struct s_filter ** fpp;
{
        gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "((%s=%s)|(%s=%s)) & ((%s=*%s*)|(%s=*%s*))",
		DE_OBJECT_CLASS, DE_COUNTRY, DE_OBJECT_CLASS, DE_LOCALITY,
		DE_FRIENDLY_COUNTRY, cstr,
		DE_LOCALITY_NAME, cstr);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
coFilter4(cstr, junk1, junk2)
char * cstr, * junk1, * junk2;
{
	if (fuzzyMatching == FALSE)
	{
		(void)strcpy(ldap_filter, "");
		return;
	}
        gotFuzzyMatch = TRUE;
        (void)sprintf(ldap_filter, "(|(&(objectclass=country)");
        (void)sprintf(ldap_filter,  "%s(co~=%s))", ldap_filter, cstr);
        (void)sprintf(ldap_filter,  "%s(&(objectclass=locality)(l~=%s)))",
                ldap_filter, cstr);
}
#else
void
coFilter4(cstr, junk1, junk2, fpp)
char * cstr, * junk1, * junk2;
struct s_filter ** fpp;
{
	if (fuzzyMatching == FALSE)
	{
		*fpp = NULLFILTER;
		return;
	}
        gotFuzzyMatch = TRUE;
	(void)sprintf(filbuf, "((%s=%s)|(%s=%s)) & ((%s~=%s)|(%s~=%s))",
		DE_OBJECT_CLASS, DE_COUNTRY, DE_OBJECT_CLASS, DE_LOCALITY,
		DE_FRIENDLY_COUNTRY, cstr,
		DE_LOCALITY_NAME, cstr);
	*fpp = get_filter(filbuf);
}
#endif USELDAP
