/* de.c */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/de.c,v 9.3 1993/03/19 22:53:50 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/de.c,v 9.3 1993/03/19 22:53:50 isode Exp isode $
 *
 *
 * $Log: de.c,v $
 * Revision 9.3  1993/03/19  22:53:50  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.2  1992/12/15  07:05:26  awy
 * Update and fixes
 *
 * Revision 8.1  1991/09/13  14:36:41  isode
 * PARADISE Upgrade release
 *
 * Revision 8.0  91/07/17  13:18:38  isode
 * Release 7.0
 *
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

/*****************************************************************************

  main.c

*****************************************************************************/
#define de_c
#define helpscreens

#ifdef DOS
#define searchFail srchFail
#endif DOS

#ifdef QOS
#include"qos.h"
static struct qosentry qosrec = {ERRQOSREC};
                /* global to allow update on interrupt */
extern char waitMessage[];
#endif QOS

#include <stdio.h>
#include <ctype.h>
#include <pwd.h>
#include <signal.h>
#include <setjmp.h>
#include <sys/types.h>
#ifdef DOS
#include "proto-de.h"
#include <stdlib.h>
#include <graph.h>
#include "msdos.h"
#else
#include <sys/time.h>
#include <sys/socket.h>
#endif DOS

#ifdef USELDAP
#ifdef IC
#include <ldap/lber.h>
#include <ldap/ldap.h>
#else
#include <lber.h>
#include <ldap.h>
#endif /* IC */
#include <string.h>
#include "isomanifest.h"
/*#include "config.h" */
#else
#include "quipu/ufn.h"
#include "quipu/util.h"
#include "quipu/dap2.h"
#endif USELDAP

#include "messages.h"
#include "demanifest.h"
#include "destrings.h"
#include "bind.h"
#include "namelist.h"
#include "cnamelist.h"
#include "mapatts.h"
#include "mapphone.h"
#ifndef USELDAP
#ifdef IC
#include "compat/tailor.h"
#else
#include "tailor.h"
#endif /* IC */
#endif USELDAP
#include "query.h"
#ifdef DOS
#undef putchar
#define putchar(c) gputchar(c)
#endif DOS

#ifdef USELDAP
#ifndef DOS
FILE * de_log;
int depid;
#endif DOS
#else
LLog    _de_log = {
    "de.log", NULLCP, NULLCP, LLOG_FATAL | LLOG_EXCEPTIONS | LLOG_NOTICE,
            LLOG_NONE, -1, LLOGCLS | LLOGCRT | LLOGZER, NOTOK
};
LLog *de_log = &_de_log;
#endif USELDAP

extern char *deTidyString();
extern char *findHelp();
void onint1(), de_exit();
void foundFollowing(), matchFollowing();
char enterYesNo();

struct query qinfo[MAXTYPE + 1];
struct namelist * atts[MAXTYPE + 1];
struct namelist * ypatts;

char initialMode = SIMPLELETTER;
char mode;
int browserAvail = FALSE; /* will be changed when browser ready, or maybe not */
int qosOn = TRUE;
int boundToDSA = FALSE;
int limitProblem = FALSE;
int browseMess = FALSE;
int notAllReached = FALSE;
int alarmCount = 0;
int abandoned = FALSE;
int accessrightproblem = FALSE;
int searchfail = FALSE;
int byeByeMessage = FALSE;
int controlCtoQuit = TRUE;
int wanAccess = FALSE;
int deptQ = TRUE;
int fuzzyMatching = TRUE;
int gotFuzzyMatch;
int quipuMastersCo = FALSE;
int goneAsync = FALSE;
int localOrgOnly = FALSE;
int searchAliasLo = FALSE;
int searchAliasOup = TRUE;
int exactMatch;
int highNumber = 0;
int maxOrgs = 1;
int maxDepts = 1;
int maxPersons = 3;
int localAlarmTime = 15;
int remoteAlarmTime = 30;
int bindTimeout = 120;
int noActivityTimeout = 0; /* 0 implies no timeout */
int byebyeScreenTime = 0;
int quitChars = 1;
int deLogLevel = 1;
int alarmLeft = 0;
int authLevel = AUTH_NAME;
int signedRead = FALSE;
int ufnDNs = FALSE;
int maxPowerSearchOrgs = 1000;
int minUfnNames = 1;

int dots;
int dotsPrinted;

struct cnamelist * cnamelp = NULLCNLIST;
struct mapnamelist * mapnamelp = NULLMNLIST;
struct mapphonelist * mapphonelp = NULLPHLIST;

#ifdef USELDAP
extern LDAP * ldap_ld;
extern int ldap_msgid;
#endif USELDAP

/* Defaults for unspecified name parts */
char origDefaultCo[LINESIZE], origDefaultOrg[LINESIZE],
     exactString[LINESIZE],
     welcomeMessage[LINESIZE] = DEFWELCOMEMESS,
     matched[LINESIZE],
     callingDteNumber[LINESIZE],
     searchVal[LINESIZE];


char * browserPath = NULLCP;

#ifdef USELDAP
char *ldapServer = NULLCP;
int ldapPort = LDAP_PORT;
#ifndef DOS
char * logfilename;
#endif DOS
#endif USELDAP

char * username, * backup_dsa_address, * password;
jmp_buf sjbuf;

#ifndef DOS
SFD cleanupok();
#endif DOS

#ifdef DOS
void main(argc, argv)
#else
int main(argc, argv)
#endif DOS
     int argc;
     char *argv[];
{
int res;
int ufnmenu = FALSE;
void doUfnSearch();
char enterOption();
char doPowerSearch();

/*  pdu_dump_init("/tmp"); */
  if (initialisations(argc, argv) != OK)
    de_exit(-1);

#ifdef QOS
  initQos();
#endif QOS
  tailorHelp();

  if (localOrgOnly)
  {
    /* default country and org must be set up in tailor file */
    if ((strcmp(qinfo[COUNTRY].defvalue, "") == 0) ||
        (strcmp(qinfo[ORG].defvalue, "") == 0))
    {
      (void)fprintf(stderr, NODEFAULTCOANDORG);
      de_exit(-1);
    }
  }

  if (de_bind(FALSE) != OK)
    de_exit(-1);

  mode = initialMode;
  (void)strcpy(origDefaultCo, qinfo[COUNTRY].defvalue);
  (void)strcpy(origDefaultOrg, qinfo[ORG].defvalue);

  qinfo[COUNTRY].lp = NULLLIST;
  qinfo[LOCALITY].lp = NULLLIST;
  qinfo[ORG].lp = NULLLIST;
  qinfo[ORGUNIT].lp = NULLLIST;
  qinfo[PERSON].lp = NULLLIST;

  if (initialMode == MENULETTER)
    welcome("welcomemenu");
  else
    welcome("welcomesimple");
  
  if (localOrgOnly)
  {
    /* force some of the defaults */
    initialMode = SIMPLELETTER;
  }

  switch(initialMode)
  {
    case MENULETTER:
    {
      doMenu();
      if ((mode == POWERLETTER) || (mode == YELLOWPAGES))
#ifdef NOPOWER
      {
	(void)printf(NOPOWEROPTION);
	mode = SIMPLELETTER;
      }
#else
	(void)strcpy(qinfo[ORG].defvalue, "");
#endif NOPOWER
      break;
    }
    case POWERLETTER:
       /* fall through */
    case YELLOWPAGES:
      /* fall through */
    case UFNLETTER:
      /* fall through */
    case SIMPLELETTER:
      break;
    case BROWSELETTER:
      break;
  }
  if (initialMode == MENULETTER)
  {
    if ((mode == SIMPLELETTER) || (mode == POWERLETTER))
#ifdef DOS
      displayFile("basics", FALSE, FALSE);
#else
      displayFile("basics", FALSE); /* FALSE means don't display usual
                                       help screen trailer */
#endif DOS
    else if (mode == YELLOWPAGES)
#ifdef DOS
      displayFile("ypbasics", FALSE, FALSE);
#else
      displayFile("ypbasics", FALSE);
#endif DOS
  }
  /* exit from this loop (and thus from the program) is handled by the 
     enterString routine */
  for (;;) 
  {
#ifndef DOS
    if (mode == BROWSELETTER)
    {
      doBrowse();
      doMenu();
      if ((mode == POWERLETTER)  || (mode == YELLOWPAGES))
#ifdef NOPOWER
      {
	(void)printf(NOPOWEROPTION);
	mode = SIMPLELETTER;
      }
#else
	(void)strcpy(qinfo[ORG].defvalue, "");
#endif NOPOWER
      continue;
    }
#endif DOS
    (void) setjmp(sjbuf);
    highNumber = 0;
    abandoned = FALSE;
    accessrightproblem = FALSE;
#ifdef DOS
    (void) signal(SIGINT, SIG_IGN);
#else
    if (controlCtoQuit == TRUE)
      (void) signal(SIGINT, cleanupok);
    else
      (void) signal(SIGINT, onint1);
#endif DOS


    if (mode == YELLOWPAGES)
    {
      doYellow();
    }
    else if (mode == UFNLETTER)
    {
#ifdef DOS
      _clearscreen(_GCLEARSCREEN);
#endif
      if (ufnmenu == FALSE)
      {
        displayHelp(findHelp(UFN));
        ufnmenu = TRUE;
      }
      (void)enterString(UFNTYPE); /* UFN uses PERSON part of qinfo buffer */
      if (strcmp(qinfo[PERSON].entered, "") == 0)
      {
        (void)strcpy (qinfo[PERSON].entered, MENUSTRING);
      }
    }
    else
      (void) enterString(PERSON);

    if (strcmp(qinfo[PERSON].entered, SIMPLESTRING) == 0)
    {
      mode = SIMPLELETTER;
      continue;
    }
    if ((strcmp(qinfo[PERSON].entered, POWERSTRING) == 0) ||
        (strcmp(qinfo[PERSON].entered, YELLOWSTRING) == 0))
    {
#ifdef NOPOWER
	(void)printf(NOPOWEROPTION);
	continue;
#else
      if (localOrgOnly)
      {
        (void)printf(LOCALONLY);
	(void)printf(NOPOWEROPTION);
      }
      else
      {
        if (strcmp(qinfo[PERSON].entered, POWERSTRING) == 0)
          mode = POWERLETTER;
        else
          mode = YELLOWPAGES;
	(void)strcpy(qinfo[ORG].defvalue, "");
      }
      continue;
#endif NOPOWER
    }
#ifndef DOS
    if (strcmp(qinfo[PERSON].entered, BROWSESTRING) == 0)
    {
      if (localOrgOnly)
      {
        (void)printf(LOCALONLY);
	(void)printf(NOMENUOPTION);
      }
      else
      {
        mode = BROWSELETTER;
	continue;
      }
    }
#endif DOS
    if (strcmp(qinfo[PERSON].entered, UFNSTRING) == 0)
    {
      mode = UFNLETTER;
      continue;
    }
    if (strcmp(qinfo[PERSON].entered, MENUSTRING) == 0)
    {
      if (localOrgOnly)
      {
        (void)printf(LOCALONLY);
	(void)printf(NOMENUOPTION);
      }
      else
      {
        doMenu();
	if ((mode == POWERLETTER) || (mode == YELLOWPAGES))
#ifdef NOPOWER
	{
	  (void)printf(NOPOWEROPTION);
	  mode = SIMPLELETTER;
	}
#else
	  (void)strcpy(qinfo[ORG].defvalue, "");
#endif NOPOWER
      }
      continue;
    }

#ifdef DOS
    (void) signal(SIGINT, SIG_IGN);
#else
    (void) signal(SIGINT, onint1);
#endif

    if (mode == UFNLETTER)
    {
      if (boundToDSA == FALSE)
        if (de_bind(TRUE) == NOTOK) /* do block */
          de_exit(-1);

      doUfnSearch();
      continue;
    }
    if (boundToDSA == FALSE)
      if (de_bind(FALSE) == NOTOK) /* don`t block */
       de_exit(-1);

    if (deptQ)
    {
      highNumber = 0; 
      (void) enterString(ORGUNIT);

    if (boundToDSA == FALSE)
      if (de_bind(FALSE) == NOTOK) /* don`t block */
        de_exit(-1);
    }
enterorg:
    if (localOrgOnly == FALSE)
    {
      (void) enterString(ORG);
      highNumber = 0;
      if ((exactMatch != ORG) || 
          ((strcmp(qinfo[ORG].entered, qinfo[ORG].defvalue) != 0) && 
  	         (exactMatch != ORG)) ||
                   (searchfail == TRUE))
      {
entercountry:
        (void) enterString(COUNTRY);
      }
    }
    else
    {
      (void)strcpy(qinfo[COUNTRY].entered, origDefaultCo);
      (void)strcpy(qinfo[ORG].entered, origDefaultOrg);
    }

    /* look at the input strings and decide what sort of search or list 
       to do */

    /* must have entered a country */
    if (strlen(qinfo[COUNTRY].entered) == 0)
    {
      if ((strlen(qinfo[ORG].entered) == 0) && (mode == SIMPLELETTER))
      {
        (void) printf(ENTERORGCO);
	goto enterorg;
      }
      else
      {
        (void) printf(ENTERCO);
	goto entercountry;
      }
    }

    if (boundToDSA == FALSE)
    {
      if (de_bind(TRUE) == NOTOK) /* block until bound */
        de_exit(-1);
#ifdef SPEC_MALL
      start_malloc_trace(0);
#endif
    }

    if ((mode == POWERLETTER) || (mode == YELLOWPAGES))
    {
      if (doPowerSearch() == QUITCHAR)
      {
	if (mode == YELLOWPAGES)
          (void) strcpy(qinfo[PERSON].entered, "");
	mode = SIMPLELETTER;
      }
      goto set_up_defaults;
    }

    if (deLogLevel)
#ifndef DOS
#ifdef USELDAP
      (void) fprintf (de_log,
                             "%5d:Search: co=%s, org=%s, ou=%s, cn=%s\n",
				depid,
#else
      (void) ll_log (de_log, LLOG_NOTICE, NULLCP, 
                             "Search: co=%s, org=%s, ou=%s, cn=%s",
#endif USELDAP
                             qinfo[COUNTRY].entered, qinfo[ORG].entered, 
			     qinfo[ORGUNIT].entered, qinfo[PERSON].entered);
#endif DOS
				   
    searchfail = FALSE;

    pagerOn(NUMBER_ALLOWED);

#ifdef DOS
    _clearscreen(_GCLEARSCREEN);
#endif
    res = doCountry();
    switch (res)
    {
      case QUERY_ERROR:
        goto set_up_defaults;
      case NAME_PRINTED:
      case LIST_PRINTED:
        if (((int)strlen(qinfo[ORG].entered) == 0) && 
	    (strlen(qinfo[ORGUNIT].entered) == 0) && 
	    (strlen(qinfo[PERSON].entered) == 0))
	{
	  goto set_up_defaults;
	}
	else
	  break;
    }
    
    res = doOrganisation(matched, COUNTRY);
    switch (res)
    {
      case QUERY_ERROR:
      case NO_ORG_ENTERED:
      case NO_ORG_FOUND:
      case NO_LOCALITY:
      case NO_LOCALITY_SELECTED:
        goto set_up_defaults;
      case NAME_PRINTED:
      case LIST_PRINTED:
        if (((int)strlen(qinfo[ORGUNIT].entered) == 0) && 
	    (strlen(qinfo[PERSON].entered) == 0))
	{
	  goto set_up_defaults;
	}
	else
	  break;
    }

    if (strlen(qinfo[ORGUNIT].entered) != 0)
    {
      res = doOU(matched);
      switch (res)
      {
        case NAME_PRINTED:
        case NO_DEPT_FOUND:
          if (strlen(qinfo[PERSON].entered) == 0)
	    goto set_up_defaults;
	  else
	  {
	    if (res == NO_DEPT_FOUND)
	    {
	      freeList(&qinfo[ORGUNIT].lp); /* fix from Giovanni et al */
	      (void) doPRR(matched, ORG);
	      goto set_up_defaults;
	    }
	    else
	      break;
	  }
        case PARENT_PRINTED:
	  goto set_up_defaults;
      }
      (void) doPRR(matched, ORGUNIT);
    }
    else /* ou is null */
    {
      freeList(&qinfo[ORGUNIT].lp);
      /* if prev ou value was non-null, force search for people */
      if (strlen(qinfo[ORGUNIT].defvalue) != 0)
        freeList(&qinfo[PERSON].lp);
      (void) doPRR(matched, ORG);
    }

set_up_defaults:
  /* set up defaults for next time round */
  /* note that the list default is converted to null */
  /* except for country */
  (void) strcpy(qinfo[COUNTRY].defvalue, qinfo[COUNTRY].entered);

  if (strcmp(qinfo[ORG].entered, "*") == 0)
    (void) strcpy(qinfo[ORG].defvalue, "");
  else
    (void) strcpy(qinfo[ORG].defvalue, qinfo[ORG].entered);

  if (strcmp(qinfo[ORGUNIT].entered, "*") == 0)
    (void) strcpy(qinfo[ORGUNIT].defvalue, "");
  else
    (void) strcpy(qinfo[ORGUNIT].defvalue, qinfo[ORGUNIT].entered);

  if (strcmp(qinfo[PERSON].entered, "*") == 0)
    (void) strcpy(qinfo[PERSON].defvalue, "");
  else
    (void) strcpy(qinfo[PERSON].defvalue, qinfo[PERSON].entered);
  }
  /* and that's all for now */
}

#ifdef DOS
void
#endif DOS
doMenu()
{
char menustring[LINESIZE];

  (void) setjmp(sjbuf);
  (void)sprintf(menustring, MODEMENU, browserAvail ? BROWSELINE : "");  
  for (;;)
  {
    mode = enterOption(menustring, VALIDMODES, (int *)0);
    if (mode == QUITCHAR)
      de_exit(0);
    if ((mode == HELPLETTER) || (mode == QUESTIONMARK))
    {
#ifdef DOS
      displayFile("hintro", FALSE, FALSE);
#else
      displayFile("hintro", FALSE);
#endif DOS
      for (;;)
      {
        char topic[LINESIZE];
        (void)printf("Enter help topic name, ? for help summary, q to quit from help: ");
        if (gets(topic) == NULLCP)
        {
#ifdef DOS
          goToStartOfLine();
#endif DOS
          clearerr(stdin);
          break;
        }
#ifdef DOS
        goToStartOfLine();
#endif DOS
        (void)strcpy(topic, deTidyString(topic));
        if (strlen(topic) == 0)
          continue;
        if (topic[0] == QUITCHAR)
          break;
        if (topic[0] == QUESTIONMARK)
	{
	  if (strlen(topic) == 1)
            (void)strcpy(topic, "help");
	  else /* user may have put an initial ? - lets strip it off */
	  {
	    topic[0] = ' ';
	    (void)strcpy(topic, deTidyString(topic));
	    if (topic[0] == QUESTIONMARK)
	      (void)strcpy(topic, "help");
	  }
	}
        displayHelp(findHelp(topic));
        continue;
      }
      continue;
    }
    if (mode == INFOLETTER)
    {
#ifdef DOS
      displayFile("info", FALSE, FALSE);
#else
      displayFile("info", FALSE);
#endif DOS
        continue;
    }
    if (mode == 0)
      mode = SIMPLELETTER;
    break;
  }
}

int
doCountry()
{
#ifdef USELDAP
BerElement *cookie;
char * at;
#else
Attr_Sequence at;
#endif USELDAP

  /* if we already have the values set up, use the cached results */
  if ((strcmp(qinfo[COUNTRY].entered, qinfo[COUNTRY].defvalue) == 0) &&
      (qinfo[COUNTRY].lp != NULLLIST) && (qinfo[COUNTRY].listlen == 1))
  {    
    printLastComponent(INDENTON, qinfo[COUNTRY].lp->name, COUNTRY, 0);
    (void)strcpy(matched, qinfo[COUNTRY].lp->name);
    return NAME_PRINTED;
  }
  else
  {
    freeList(&qinfo[LOCALITY].lp);
    freeList(&qinfo[ORG].lp);
    freeList(&qinfo[ORGUNIT].lp);
    freeList(&qinfo[PERSON].lp);
  }

  for (;;)
  {
    /* inits */
    freeList(&qinfo[COUNTRY].lp);
    pagerOn(NUMBER_ALLOWED);
/*
    if (strcmp(qinfo[COUNTRY].entered, "*") == 0)
      (void) strcpy(qinfo[COUNTRY].defvalue, "*");
    else
      (void) strcpy(qinfo[COUNTRY].defvalue, qinfo[COUNTRY].entered);
*/  
    if (listCos(qinfo[COUNTRY].entered, &qinfo[COUNTRY].lp) != OK)
    {
      (void) searchFail(COUNTRY);
      return QUERY_ERROR;
    }
    qinfo[COUNTRY].fuzzy = gotFuzzyMatch;
    qinfo[COUNTRY].listlen = listlen(qinfo[COUNTRY].lp);
    if (qinfo[COUNTRY].listlen == 0)
    {
      if (strcmp(qinfo[COUNTRY].entered, "*") == 0)
      {
        resetprint(TEMPPROBLEM);
        return QUERY_ERROR;
      }
      else
      {
        resetprint(NOCOMATCH, qinfo[COUNTRY].entered);
        (void) strcpy(qinfo[COUNTRY].defvalue, "");
        (void) enterString(COUNTRY);
	continue;
      }
    }
    else if (qinfo[COUNTRY].listlen == 1)
    {
#ifdef USELDAP
      for (at = ldap_first_attribute(ldap_ld, qinfo[COUNTRY].lp->ats, &cookie);
                at != NULL; at = ldap_next_attribute(ldap_ld,
			qinfo[COUNTRY].lp->ats, cookie))
      {
	if (strcmp(at, "masterDSA") == 0)
	{
          quipuMastersCo = TRUE;
          break;
        }
      }
#else
      /* is the next level mastered by a quipu DSA */
      quipuMastersCo = FALSE;
      for (at = qinfo[COUNTRY].lp->ats; at != NULLATTR; at = at->attr_link)
      {
        if (strcmp(attr2name(at->attr_type, OIDPART), "masterDSA") == 0)
        {
          quipuMastersCo = TRUE;
          break;
        }
      }
#endif USELDAP
      (void) strcpy(qinfo[COUNTRY].displayed, qinfo[COUNTRY].lp->name);
      printLastComponent(INDENTON, qinfo[COUNTRY].lp->name, COUNTRY, 0);
      (void)strcpy(matched, qinfo[COUNTRY].lp->name);
      return NAME_PRINTED;
    }
    else /* qinfo[COUNTRY].listlen > 1 */
    {
      if (strcmp(qinfo[COUNTRY].entered, "*") == 0)
        if (((int)strlen(qinfo[ORG].entered) != 0) || 
	    ((strlen(qinfo[ORGUNIT].entered) != 0)) || 
	     (strlen(qinfo[PERSON].entered) != 0))
	{
	  foundFollowing();
	  printListCos(qinfo[COUNTRY].entered, qinfo[COUNTRY].lp);
	  (void) enterString(COUNTRY);
	  continue;
	}
	else
	{
	  printListCos(qinfo[COUNTRY].entered, qinfo[COUNTRY].lp);
	  return LIST_PRINTED;
	}
      else
      { 
        matchFollowing();
	printListCos(qinfo[COUNTRY].entered, qinfo[COUNTRY].lp);
	(void) enterString(COUNTRY);
	continue;
      }
    }
  }
}

int
doOrganisation(matchstring, searchUnder)
char matchstring [];
int searchUnder;
{
int res;

  if ((strcmp(qinfo[ORG].entered, qinfo[ORG].defvalue) == 0) &&
      (qinfo[ORG].lp != NULLLIST) && (qinfo[ORG].listlen == 1))
  {    
    if (qinfo[LOCALITY].lp != NULLLIST)
      printLastComponent(INDENTON, qinfo[LOCALITY].lp->name,
      					LOCALITY, 0);
    printLastComponent(INDENTON, qinfo[ORG].lp->name, ORG, 0);
    (void)strcpy(matched, qinfo[ORG].lp->name);
    if (((int)strlen(qinfo[ORGUNIT].entered) == 0) && 
        (strlen(qinfo[PERSON].entered) == 0))
      printDetails(ORG, qinfo[ORG].lp);
    return NAME_PRINTED;
  }
  else
  {
    freeList(&qinfo[ORGUNIT].lp);
    freeList(&qinfo[PERSON].lp);
  }

  for (;;)
  {
    /* inits */
    freeList(&qinfo[ORG].lp);

    if (strlen(qinfo[ORG].entered) == 0)
    {
      resetprint(NOTHINGTO);
      (void) strcpy(qinfo[ORG].defvalue, "");
      (void) enterString(ORG);
      if (strlen(qinfo[ORG].entered) == 0)
        return NO_ORG_ENTERED;
    }

    pagerOn(NUMBER_ALLOWED);

#ifdef QOS
    startQosTime(matchstring, &qosrec);
#endif QOS
    if (listOrgs(matchstring, qinfo[ORG].entered, &qinfo[ORG].lp) != OK)
    {
#ifdef QOS
      updateStats(QOS_FAILURE, &qosrec);
#endif QOS      
      (void) searchFail(ORG);
      return QUERY_ERROR;
    }
#ifdef QOS
    updateStats(QOS_SUCCESS, &qosrec);
#endif QOS

    qinfo[ORG].fuzzy = gotFuzzyMatch;
    qinfo[ORG].listlen = listlen(qinfo[ORG].lp);
    if ((qinfo[ORG].listlen > 0) && (searchUnder != LOCALITY))
    { /* get rid of any locality lists */
      freeList(&qinfo[LOCALITY].lp);
    }
    if (qinfo[ORG].listlen == 0)
    {
      if (strcmp(qinfo[ORG].entered, "*") == 0)
      {
        resetprint(NOORGSFOUND);
        return QUERY_ERROR;
      }
      else
      {
        /* lets see if the organisation is under a locality -
	   but lets make sure first we haven't already checked!! */
        if (searchUnder == LOCALITY)
	{
	  resetprint(CFOM, qinfo[ORG].entered);
	  /* this isn't really consistent with the standard DE behaviour, 
	     which would normally return to the org prompt. However, after
	     an excursion into localities, it is not obvious what to type
	     at this prompt - so back to the person prompt */
	  return NO_ORG_FOUND;
	}
	else
	{
          /* lets see if the organisation is under a locality */
	  res = searchOrgUnderLocality(matchstring);
	  /* restore matched string to just the country component
	     unless an org has been found */
	  if (res != NAME_PRINTED)
	    (void)strcpy(matched, qinfo[COUNTRY].lp->name);
	  /* see comments above on where to return after searching failure */
          return res;
	}
      }
    }
    else if (qinfo[ORG].listlen == 1)
    {
      if (testRedisplay())
        printNames(LOCALITY);
      printLastComponent(INDENTON, qinfo[ORG].lp->name, ORG, 0);
      if (((int)strlen(qinfo[ORGUNIT].entered) == 0) && 
          (strlen(qinfo[PERSON].entered) == 0))
        printDetails(ORG, qinfo[ORG].lp);
      (void)strcpy(matched, qinfo[ORG].lp->name);
      return NAME_PRINTED;
    }
    else /* qinfo[ORG].listlen > 1 */
    {
      if (strcmp(qinfo[ORG].entered, "*") == 0)
        foundFollowing();
      else
        matchFollowing();
      printNames(LOCALITY);
      printListOrgs(qinfo[ORG].entered, qinfo[ORG].lp);
      (void) enterString(ORG);
      continue;
    }
  }
}

int
searchOrgUnderLocality(costr)
char * costr;
{
int res, noLocs;
struct namelist * savelp;

  resetprint(NOORGSMATCH, qinfo[ORG].entered);
  /* if this is an org search under the root, give up */
  if (strcmp(qinfo[COUNTRY].entered, "-") == 0)
    return NO_ORG_FOUND;
  resetprint(CHECKUNDERLOC);
  if (listLocs(costr, "*", &qinfo[LOCALITY].lp) != OK)
  {
    (void) searchFail(LOCALITY);
    return QUERY_ERROR;
  }
  qinfo[LOCALITY].fuzzy = gotFuzzyMatch;
  noLocs = qinfo[LOCALITY].listlen = listlen(qinfo[LOCALITY].lp);
  savelp = qinfo[LOCALITY].lp;
  if (qinfo[LOCALITY].listlen == 0)
  {
    resetprint(NOLOCINFO);
    return NO_LOCALITY;
  }
  for(;;) /* escape by finding an organisation, or the user abandoning 
             the search */
  {
    pagerOn(NUMBER_ALLOWED); /* from Giovanni et al */
    if (qinfo[LOCALITY].listlen == 1)
    {
      resetprint(ONLYONELOC,
                   lastComponent(qinfo[LOCALITY].lp->name, LOCALITY));
    }
    else
    {
      /* allow user to choose a locality to search */
      foundFollowing();
      printNames(COUNTRY);
      printListLocs("*", qinfo[LOCALITY].lp);
      (void) enterString(LOCALITY);
      if (strcmp(qinfo[LOCALITY].entered, "") == 0)
      {
	res = NO_LOCALITY_SELECTED;
	goto freeLocLists;
      }
      if (strcmp(qinfo[LOCALITY].entered, "*") == 0)
      {
        if (qinfo[LOCALITY].lp != savelp)
	{
	  freeList(&qinfo[LOCALITY].lp);
	  qinfo[LOCALITY].lp = savelp;
	  qinfo[LOCALITY].listlen = highNumber = listlen(qinfo[LOCALITY].lp);
	}
        continue;
      }
#ifdef USELDAP
      if (index(costr, ',') != NULLCP)
#else 
      if (rindex(costr, '@') != NULLCP)
#endif USELDAP
	(void)strcpy(costr, removeLastRDN(matched));
      if (qinfo[LOCALITY].lp != savelp)
        freeList(&qinfo[LOCALITY].lp);
      if (listLocs(costr, qinfo[LOCALITY].entered, &qinfo[LOCALITY].lp) != OK)
      {
        (void) searchFail(LOCALITY);
	freeList(&savelp);
        return QUERY_ERROR;
      }
      qinfo[LOCALITY].fuzzy = gotFuzzyMatch;
      /* following lines from Giovanni et al to deal with problem if locality
         does not match, modified by me to align with slightly modifed 
	 program design */
      qinfo[LOCALITY].listlen = listlen(qinfo[LOCALITY].lp);
      if (qinfo[LOCALITY].listlen == 0)
      {
	resetprint(NOLOCSMATCH, qinfo[LOCALITY].entered);
	if (enterYesNo(ANOTHERLOC) == YESCHAR)
	{
	  if (qinfo[LOCALITY].lp != savelp)
	    freeList(&qinfo[LOCALITY].lp);
	  qinfo[LOCALITY].lp = savelp;
	  qinfo[LOCALITY].listlen = highNumber = listlen(qinfo[LOCALITY].lp);
	  continue;
	}
	else
	{
	  res = NO_LOCALITY_SELECTED;
	  goto freeLocLists;
	}
      }
    }
    (void)strcpy(matched, qinfo[LOCALITY].lp->name);
    /* now lets do org search */
    setRedisplay();
    res = doOrganisation(matched, LOCALITY);
    if ((res == NO_ORG_FOUND) && (noLocs > 1))
    {
      if (enterYesNo(ANOTHERLOC)
                     == YESCHAR)
      {
        if (qinfo[LOCALITY].lp != savelp)
	  freeList(&qinfo[LOCALITY].lp);
        qinfo[LOCALITY].lp = savelp;
	qinfo[LOCALITY].listlen = highNumber = listlen(qinfo[LOCALITY].lp);
	continue;
      }
    }
freeLocLists:
    if (qinfo[LOCALITY].lp != savelp)
      freeList(&savelp);
    freeList(&qinfo[LOCALITY].lp);
    return res;
  }
}

int
doOU(matchstring)
char matchstring [];
{
  if ((strcmp(qinfo[ORGUNIT].entered, qinfo[ORGUNIT].defvalue) == 0) &&
      (qinfo[ORGUNIT].lp != NULLLIST) && (qinfo[ORGUNIT].listlen == 1))
  {    
    printLastComponent(INDENTON, qinfo[ORGUNIT].lp->name, ORGUNIT, 0);
    if (strlen(qinfo[PERSON].entered) == 0)
      printDetails(ORGUNIT, qinfo[ORGUNIT].lp);
    (void)strcpy(matched, qinfo[ORGUNIT].lp->name);
    return NAME_PRINTED;
  }
  else
    freeList(&qinfo[PERSON].lp);

  for (;;)
  {
    /* inits */
    freeList(&qinfo[ORGUNIT].lp);
    pagerOn(NUMBER_ALLOWED);
#ifdef QOS
    startQosTime(matchstring, &qosrec);
#endif QOS
    if (listOUs(matchstring, qinfo[ORGUNIT].entered, &qinfo[ORGUNIT].lp) != OK)
    {
      if (searchFail(ORGUNIT) != SF_ABANDONED)
      {
        /* initialise value to discard default which failed */
	(void) strcpy(qinfo[ORGUNIT].entered, "");
      }
#ifdef QOS
      updateStats(QOS_FAILURE, &qosrec);
#endif QOS      
      return PARENT_PRINTED;
    }

#ifdef QOS
    updateStats(QOS_SUCCESS, &qosrec);
#endif QOS

    qinfo[ORGUNIT].fuzzy = gotFuzzyMatch;
    qinfo[ORGUNIT].listlen = listlen(qinfo[ORGUNIT].lp);
    if (qinfo[ORGUNIT].listlen == 0)
    {
      if (strcmp(qinfo[ORGUNIT].entered, "*") == 0)
        if (strlen(qinfo[PERSON].entered) != 0)
          return NO_DEPT_FOUND;
        else
          resetprint(NODEPTS);
      else
      {
/*        (void) strcpy(qinfo[ORGUNIT].defvalue, ""); */
        resetprint(NODEPTMATCH, qinfo[ORGUNIT].entered);
	(void) strcpy(qinfo[ORGUNIT].entered, "");
      }
      if (strlen(qinfo[PERSON].entered) == 0)
      {
        resetprint(DISPORGDETAILS);
	printNames(ORG);
        printDetails(ORG, qinfo[ORG].lp);
        return PARENT_PRINTED;
      }
      else
      {
        if (strcmp(qinfo[PERSON].entered, "*") == 0)
	  resetprint(CONTPERSONLIST);
	else
          resetprint (CONTPERSONSEARCH, qinfo[PERSON].entered);
	return NO_DEPT_FOUND;
      }
    }
    else if (qinfo[ORGUNIT].listlen == 1)
    {
      if (testRedisplay())
        printNames(ORG);
      printLastComponent(INDENTON, qinfo[ORGUNIT].lp->name, ORGUNIT, 0);
      if (strlen(qinfo[PERSON].entered) == 0)
        printDetails(ORGUNIT, qinfo[ORGUNIT].lp);
      (void)strcpy(matched, qinfo[ORGUNIT].lp->name);
      return NAME_PRINTED;
    }
    else /* qinfo[ORGUNIT].listlen > 1 */
    {
      if (strcmp(qinfo[ORGUNIT].entered, "*") == 0)
      {
        foundFollowing();
	printNames(ORG);
	printListOUs(qinfo[ORGUNIT].entered, qinfo[ORGUNIT].lp);
	(void) enterString(ORGUNIT);
        if (strcmp(qinfo[ORGUNIT].entered, "") == 0)
          return NO_DEPT_FOUND;
	continue;
      }
      else
      { 
        matchFollowing();
	printNames(ORG);
	printListOUs(qinfo[ORGUNIT].entered, qinfo[ORGUNIT].lp);
	(void) enterString(ORGUNIT);
	if (strlen(qinfo[ORGUNIT].entered) == 0)
	  return NO_DEPT_FOUND;
	continue;
      }
    }
  }
}

int
doPRR(matchstring, searchparent)
char matchstring [];
int searchparent;
{
struct namelist * signedlp;

  if ((strcmp(qinfo[PERSON].entered, qinfo[PERSON].defvalue) == 0) &&
      (qinfo[PERSON].lp != NULLLIST) && (qinfo[PERSON].listlen == 1))
  {    
    printListPRRs(qinfo[PERSON].entered, qinfo[PERSON].lp, searchparent, TRUE, 0);
    return NAME_PRINTED;
  }
  
  for (;;)
  {
    /* inits */
    freeList(&qinfo[PERSON].lp);
    pagerOn(NUMBER_ALLOWED);
    
#ifdef QOS
    startQosTime(matchstring, &qosrec);
#endif QOS

    if (listPRRs(matchstring, qinfo[PERSON].entered, &qinfo[PERSON].lp) != OK)
    {
      if (searchFail(PERSON) != SF_ABANDONED)
        (void) strcpy(qinfo[PERSON].entered, "");
#ifdef QOS
    updateStats(QOS_FAILURE, &qosrec);
#endif QOS
      return PARENT_PRINTED;
    }
#ifdef QOS
    updateStats(QOS_SUCCESS, &qosrec);
#endif QOS

    qinfo[PERSON].fuzzy = gotFuzzyMatch;
    qinfo[PERSON].listlen = listlen(qinfo[PERSON].lp);
    if (qinfo[PERSON].listlen == 0)
    {
      if (strcmp(qinfo[PERSON].entered, "*") == 0)
        resetprint(NOPEOPLE);
      else
        resetprint(NOPEOPLEMATCH, qinfo[PERSON].entered);
      if (qinfo[ORGUNIT].lp != NULLLIST)
      {
        resetprint(DISPDEPTDETAILS);
	printNames(ORGUNIT);
        printDetails(ORGUNIT, qinfo[ORGUNIT].lp);
      }
      else
      {
        resetprint(DISPORGDETAILS);
	printNames(ORGUNIT);
        printDetails(ORG, qinfo[ORG].lp);
      }
      return PARENT_PRINTED;
    }
    else if (qinfo[PERSON].listlen == 1)
    {
      if (testRedisplay())
        printNames(ORGUNIT);
      printListPRRs(qinfo[PERSON].entered, qinfo[PERSON].lp, searchparent, TRUE, 0);
      if (signedRead == TRUE)
      {
	if (enterYesNo(DOSIGNEDREAD) == YESCHAR)
	{
          resetprint("");
          (void)printf(TRYSIGNEDREAD);
          (void)fflush(stdout);
          if (signedReadPRR(qinfo[PERSON].lp->name, &signedlp) != OK)
	  {
            resetprint(SIGNEDREADFAILED);
	  }
          else
          {
            (void)printf(SIGNEDRESOK);
	    printListPRRs(qinfo[PERSON].entered, signedlp, searchparent, TRUE, 0);
	    freeList(&signedlp);
	  }
	}
      }
      return NAME_PRINTED;
    }
    else /* qinfo[PERSON].listlen > 1 */
    {
      if (qinfo[PERSON].listlen > maxPersons)
      {
        if (strcmp(qinfo[PERSON].entered, "*") == 0)
          foundFollowing();
        else
	  matchFollowing();
	printNames(ORGUNIT);
        printListPRRs(qinfo[PERSON].entered, qinfo[PERSON].lp, searchparent, FALSE, 0);
        /* If number entered, continue trying to resolve the query.
	   Otherwise start a fresh query */
        if (strcmp(qinfo[PERSON].entered, "*") == 0)
	  (void) strcpy(qinfo[PERSON].defvalue, "");
        else
          (void) strcpy(qinfo[PERSON].defvalue, qinfo[PERSON].entered);
        if (enterString(PERSON) == 0)
	  break;
	else
	  continue;
      }
      else
      {
        if (testRedisplay())
	  printNames(ORGUNIT);
        printListPRRs(qinfo[PERSON].entered, qinfo[PERSON].lp, searchparent, TRUE, 0);
      }
      return NAME_PRINTED;
    }
  }
  return START_NEW_QUERY;
}


#ifdef DOS
void
#endif DOS
printNames(objectType)
int objectType;
{
	switch (objectType)
	{
		case COUNTRY:
			printLastComponent(INDENTON, qinfo[COUNTRY].lp->name, 
			                                         COUNTRY, 0);
			break;
		case LOCALITY:
			printLastComponent(INDENTON, qinfo[COUNTRY].lp->name,
			                                         COUNTRY, 0);
			if (qinfo[LOCALITY].lp != NULLLIST)
			  printLastComponent(INDENTON, qinfo[LOCALITY].lp->name,
			  					LOCALITY, 0);
			break;
		case ORG:
			printLastComponent(INDENTON, qinfo[COUNTRY].lp->name,
			                                         COUNTRY, 0);
			if (qinfo[LOCALITY].lp != NULLLIST)
			  printLastComponent(INDENTON, qinfo[LOCALITY].lp->name,
			  					LOCALITY, 0);
			printLastComponent(INDENTON, qinfo[ORG].lp->name,
			                                             ORG, 0);
			break;
		case ORGUNIT:
			printLastComponent(INDENTON, qinfo[COUNTRY].lp->name,
			                                         COUNTRY, 0);
			if (qinfo[LOCALITY].lp != NULLLIST)
			  printLastComponent(INDENTON, qinfo[LOCALITY].lp->name,
			  					LOCALITY, 0);
			printLastComponent(INDENTON, qinfo[ORG].lp->name,
			                                             ORG, 0);
			if (qinfo[ORGUNIT].lp != NULLLIST)
			  printLastComponent(INDENTON, qinfo[ORGUNIT].lp->name,
			                                           ORGUNIT, 0);
			break;
		case PERSON:
			break;
	}
}

void
printCountry()
{
  printLastComponent(INDENTON, qinfo[COUNTRY].lp->name, COUNTRY, 0);
}

void
foundFollowing()
{
  initPage();
  pageprint(FOUNDFOLLOWING);
}

void
matchFollowing()
{
  initPage();
  pageprint(MATCHFOLLOWING, gotFuzzyMatch ? FUZZY : "");
}



/* routine returns the number of an entry selected from a list, or zero
   otherwise */
int
enterString(objectType)
int objectType;
{
char prompt[LINESIZE];
static char prstr[] = ":-";
static char gotValue[LINESIZE] = "";
int numEnt;

  setRedisplay();
/*  if (boundToDSA == TRUE) */
    startUnbindTimer();
  switch(objectType)
  {
    case PERSON:
      if (strlen(gotValue) != 0)
      {
        (void) strcpy(qinfo[objectType].entered, gotValue);
	gotValue[0] = '\0';
	break;
      }
      (void) sprintf(prompt, PPROMPT);
      if (strlen(qinfo[objectType].defvalue) != 0)
        (void) sprintf(prompt, "%s<CR> for `%s', ", prompt, 
	       qinfo[objectType].defvalue);
      if (mode == SIMPLELETTER)
        (void) sprintf(prompt, "%s* to %s, ", prompt, 
             browseMess ? BROWSE : LISTPEOPLE);
      (void) sprintf(prompt, PMHELP, prompt, prstr);
      enterAndValidate(prompt, qinfo[objectType].entered, objectType, 
                       qinfo[objectType].defvalue, qinfo[objectType].lp, &numEnt);
      /* if a string was entered, but a number could validly have been
      entered, store value in gotValue for next invocation of this function */
      if ((highNumber > 0) && (numEnt == 0))
        (void) strcpy(gotValue, qinfo[objectType].entered);
      break;
    case ORGUNIT:
        (void) sprintf(prompt, OUPROMPT);
	if (mode == SIMPLELETTER)
	  (void) sprintf(prompt, "%s* to %s, ", prompt,
	    browseMess ? BROWSE : LISTOUS);
        if (strcmp(qinfo[objectType].defvalue, "*") == 0)
          (void) sprintf(prompt, OUBROWSE, prompt,
	     browseMess ? BROWSE : LIST);
	else
	{
	  if (strlen(qinfo[objectType].defvalue) == 0)
	  {
	    if (strlen(qinfo[PERSON].entered) != 0)
	      (void) sprintf(prompt, OUBROWSE, prompt, SEARCH);
	  }
	  else
	  {
            (void) strcat(prompt, SEARCHALLOUS);
	    (void) sprintf(prompt, SEARCHFOR,  prompt, 
	                              qinfo[objectType].defvalue);
	  }
	}
        (void) sprintf(prompt, PMHELP, prompt, prstr);
        enterAndValidate(prompt, qinfo[objectType].entered, objectType, 
	                    qinfo[objectType].defvalue, qinfo[objectType].lp, &numEnt);
        break;
    case ORG:
        (void) sprintf(prompt, ORGPROMPT);
	if (strcmp(qinfo[objectType].defvalue, "") != 0)
	{
	  (void) sprintf(prompt, GENSEARCH, prompt,
	                                        qinfo[objectType].defvalue);
          if ((mode == POWERLETTER) || (mode == YELLOWPAGES))
	    (void) sprintf(prompt, "%s-%s", prompt, SEARCHALLORGS);
	  else if ((int)strlen(qinfo[objectType].defvalue) > 10)
	    (void) sprintf(prompt, WRAPPROMPT, prompt);
	}
	else
	{
          if ((mode == POWERLETTER) || (mode == YELLOWPAGES))
	    (void) sprintf(prompt, "%s<CR>%s", prompt, SEARCHALLORGS);
	}
	if (mode == SIMPLELETTER)
          (void) sprintf(prompt, "%s* to %s, ", prompt, 
	               browseMess ? BROWSE : LISTORGS);
        (void) sprintf(prompt, PMHELP, prompt, prstr);
        enterAndValidate(prompt, qinfo[objectType].entered, objectType, 
	                    qinfo[objectType].defvalue, qinfo[objectType].lp, &numEnt);
        break;
    case LOCALITY:
        (void) sprintf(prompt, LOCPROMPT);
	if (strcmp(qinfo[objectType].defvalue, "") != 0)
	{
	  (void) sprintf(prompt, GENSEARCH, prompt,
	                                        qinfo[objectType].defvalue);
          if ((int)strlen(qinfo[objectType].defvalue) > 10)
	    (void) sprintf(prompt, WRAPPROMPT, prompt);
	}
        (void) sprintf(prompt, "%s* to %s, ", prompt, 
	               browseMess ? BROWSE : LISTLOCS);
        (void) sprintf(prompt, PMHELP, prompt, prstr);
        enterAndValidate(prompt, qinfo[objectType].entered, objectType, 
	                    qinfo[objectType].defvalue, qinfo[objectType].lp, &numEnt);
        break;
    case COUNTRY:
        (void) sprintf(prompt, COPROMPT);
	if ((strcmp(qinfo[objectType].defvalue, "") != 0) &&
	    (strcmp(qinfo[objectType].defvalue, "*") != 0))
	  (void) sprintf(prompt, GENSEARCH, prompt, 
	                                         qinfo[objectType].defvalue);
        (void) sprintf(prompt, "%s* to %s, ", prompt,
	               browseMess ? BROWSE : LISTCOS);
        (void) sprintf(prompt, PMHELP, prompt, prstr);
        enterAndValidate(prompt, qinfo[objectType].entered, objectType, 
	                    qinfo[objectType].defvalue, qinfo[objectType].lp, &numEnt);
        break;
    case UFNTYPE:
        (void) sprintf(prompt, PMHELP, UFNPROMPT, prstr);
        enterAndValidate(prompt, qinfo[PERSON].entered, objectType,
			    "", qinfo[PERSON].lp, &numEnt);
        objectType = PERSON; /* do this so that we test for quit at the
                                end of this routine */
	break;
    default:
      (void) fprintf(stderr, UNKNOWNOC);
      break;
  }
  stopUnbindTimer();
  if (lexnequ(qinfo[objectType].entered, QUITWORD,
	                        strlen(qinfo[objectType].entered)) == 0)
  {
    if (objectType == PERSON)
#ifdef DOS
      cleanupok(0);
#else
      cleanupok();
#endif DOS
    if (enterYesNo(WANTTOQUIT) == YESCHAR)
#ifdef DOS
      cleanupok(0);
#else
      cleanupok();
#endif DOS
    else
      longjmp(sjbuf, 0);
  }
  return numEnt;
}


#ifdef DOS
void
#endif DOS
enterAndValidate(prompt, buf, objectType, defaultValue, lp, nep)
char * prompt, * buf;
int objectType;
char * defaultValue;
struct namelist * lp;
int * nep;
{
char * cp, * cp2;
int i, n, isnum, gotcontrol;

  *nep = 0;
  /* this picks up any number that was entered at the pager prompt */
  if ((n = getpnum()) != -1)
  {
    if ((n > highNumber) || (n < 1)) /* check number against valid range */
    {
      if (highNumber > 0)
        (void) fprintf(stderr, INVNUMBER, highNumber);
      else
	(void) fprintf(stderr, LISTNOTCURRENT);
    }
    else /* valid number */
    {
      for (i = 1; i < n; i++, lp = lp->next) {};
      cp = copy_string(lastComponent(lp->name, objectType));
      exactMatch = objectType;
      (void) strcpy(exactString, lp->name);
      (void) strcpy(buf, cp);
      free(cp);
      *nep = n;
      return;
    }
  }

  for (;;)
  {
    exactMatch = -1;
    if (objectType == PERSON)
    {
      if (localOrgOnly)
      {
        (void)printf(LOCALONLY);
	(void)putchar('\n');
      }
      else if (mode == SIMPLELETTER)
        (void)printf(SIMPLEMODEON);
      else
        (void)printf(POWERMODEON);
    }
    writeInverse(prompt);
    (void) putchar(' ');
    if (gets(buf) == NULLCP) /* deal with control-D */
      if (objectType == PERSON)
        /* exit the program */
        cleanup(0);
      else
      {
#ifdef DOS
        goToStartOfLine();
#endif DOS
        /* behave as for an interrupt */
	clearerr(stdin);
#ifdef DOS
        onint1(0);
#else
        onint1();
#endif DOS
      }
#ifdef DOS
    goToStartOfLine();
#endif
    cp = copy_string(deTidyString(buf));
    /* look for escape chars */
    gotcontrol = FALSE;
    for (cp2 = cp; *cp2 != '\0'; cp2++)
      if (iscntrl(*cp2))
      {
        gotcontrol = TRUE;
	break;
      }
    if (gotcontrol == TRUE)
    {
      (void)printf(GOTCONTROL);
      continue;
    }
    if (strlen(cp) == 0) /* default accepted */
    {
      free(cp);
      cp = copy_string(defaultValue);
      break;
    }
    /* if "-" entered, convert this to a null entry, unless entering a 
       country.  In this case, "-" is treated as search international orgs */
    if (objectType != COUNTRY)
      if (strcmp(cp, "-") == 0)
      {
        *cp ='\0';
	break;
      }
    if (strcmp(cp, "?") == 0) /* help on current input requested */
    {
      switch (objectType)
      {
        case PERSON:
          displayHelp(findHelp(NAME));
	  break;
	case ORGUNIT:
	  displayHelp(findHelp(DEPARTMENT));
	  break;
	case ORG:
	  displayHelp(findHelp(ORGANISATION));
	  break;
	case LOCALITY:
	  displayHelp(findHelp(LOCALITY2));
	  break;
	case COUNTRY:
	  displayHelp(findHelp(COUNTRY2));
	  break;
        case UFNTYPE:
          displayHelp(findHelp(UFN));
          break;
      }
      continue;
    }
    if (*cp == '?') /* help on some other specific topic requested */
    {
      for (cp++; *cp == ' '; cp++) {};
      if ((lexequ(cp, "?") == 0) || 
          (lexequ(cp, HELP) == 0)) /* help about help requested */
        displayHelp(findHelp(HELP));
      else 
        displayHelp(findHelp(cp));
      continue;
    }

    /* if a number has been entered, check that it is in range, and 
       map the number onto the appropriate name */
    isnum = TRUE;
    for (cp2 = cp; *cp2 != '\0'; cp2++)
    {
      if (! isdigit(*cp2))
      {
        isnum = FALSE;
	break;
      }
    }
    if (isnum)
    {
      n = atoi(cp);
      if ((n > highNumber) || (n < 1)) /* check number against valid range */
      {
        if (highNumber > 0)
          (void) fprintf(stderr, INVNUMBER, highNumber);
	else
	  (void) fprintf(stderr, LISTNOTCURRENT);
	continue;
      }
      else
      {
	for (i = 1; i < n; i++, lp = lp->next) {};
	free(cp);
	cp = copy_string(lastComponent(lp->name, objectType));
        exactMatch = objectType;
	(void) strcpy(exactString, lp->name);
        *nep = n;
      }
    }
    break;
  }
  (void) strcpy(buf, cp);
  free(cp);
}

char enterYesNo(str)
char * str;
{
char buf[LINESIZE];
int i;

  for (;;)
  {
    (void) printf("%s", str);
    if (gets(buf) == NULLCP) /* control-D */
    {
#ifdef DOS
      goToStartOfLine();
#endif
      clearerr(stdin);
      return YESCHAR;
    }
#ifdef DOS
    goToStartOfLine();
#endif
    for (i = 0; buf[i] != '\0'; i++)
      buf[i] = uptolow(buf[i]);
    if ((buf[0] == YESCHAR) || (buf[0] == NOCHAR))
      return buf[0];
    else
    {
      soundBell();
      continue;
    }
  }
}

/* a '\n' in validChars matches no input - returns 0
   a '#' in validChars matches numeric input - returns '#' with number in n */
char enterOption(str, validChars, n)
char * str, validChars[];
int * n;
{
char buf[LINESIZE];
int i;

  for (;;)
  {
    (void) printf("%s", str);
    startUnbindTimer();
    if (gets(buf) == NULLCP) /* control-D */
    {
#ifdef DOS
      goToStartOfLine();
#endif
      clearerr(stdin);
      continue;
    }
    stopUnbindTimer();
#ifdef DOS
    goToStartOfLine();
#endif
    (void)strcpy(buf, deTidyString(buf));
    for (i = 0; validChars[i] != '\0'; i++)
    {
      if (uptolow(buf[0]) == validChars[i])
        return (validChars[i]);
      if ((buf[0] == '\0') && (validChars[i] == '\n'))
        return '\0';
      if (isdigit(buf[0]) && (validChars[i] == '#'))
      {
        *n = atoi(buf);
	if (*n != 0)
	  return '#';
	else
	  break;
      }
    }
    continue;
  }
}

void
#ifdef DOS
onint1(sig)
int sig;
#else
onint1()
#endif DOS
{
  (void) putchar('\n');
#ifdef USELDAP
  if (ldap_msgid) ldap_abandon(ldap_ld, ldap_msgid);
  ldap_msgid = 0;
#else
  de_abandon();
#endif USELDAP
  /* simulate search failure - 
     this ensures that the "country question" is asked */
  searchfail = TRUE;
  /* destroy default values - a bit of a hack
     but it is difficult to know what the defaults should be when a
     query is interrupted */
  (void) strcpy(qinfo[COUNTRY].defvalue, "");
  (void) strcpy(qinfo[LOCALITY].defvalue, "");
  (void) strcpy(qinfo[ORG].defvalue, "");
  (void) strcpy(qinfo[ORGUNIT].defvalue, "");
  (void) strcpy(qinfo[PERSON].defvalue, "");

#ifdef QOS
    updateStats(QOS_ABANDON, &qosrec);
#endif QOS

  longjmp(sjbuf, 0);
}

#ifdef DOS
SFD
cleanupok(sig)
int sig;
#else
SFD
cleanupok()
#endif DOS
{
  cleanup(0);
}

#ifdef DOS
void
#else
int
#endif DOS
cleanup(exitCode)
int exitCode;
{
  if (boundToDSA == TRUE)
    de_unbind(); 
#ifdef SPEC_MALL
  stop_malloc_trace();
#endif
  de_exit(exitCode);
}

/* the flushes need dealing with properly */
void
doInProgress()
{
static int alreadyPrinted;

  if ((dotsPrinted == 0) && (testSuppressSearchMess() != TRUE))
  {
    if (goneAsync == FALSE)
    {
      if (strcmp(searchVal, "*") == 0)
        (void)printf("%s", LISTMESS);
      else
        (void)printf("%s`%s' ", SEARCHMESS, searchVal);
    }
    else
      alreadyPrinted = FALSE;
  }
  if (goneAsync)
  {
    if (dotsPrinted == 15) /* not printed in this case - but count is useful */
    {
      if (alreadyPrinted != TRUE)
      {
        resetprint(STILLWAITING);
        alreadyPrinted = TRUE;
	unsetOrgsToDispMess();
      }
    }
  }
  else
  {
    if (testSuppressSearchMess()) /* not the greatest way of doing this! */
    {
      (void)printf(".");
      (void) fflush(stdout);
    }
    else if (dotsPrinted == dots)
    {
#ifdef QOS
      if (qosOn == TRUE)
        resetprint(waitMessage);
      else
        resetprint(OPSOMETIME);
#else      
      resetprint(OPSOMETIME);
#endif QOS
    }
    else if (dotsPrinted == (dots + 1))
    {
      resetprint(STILLTRYING);
      (void) fflush(stdout);
    }
    else if (dotsPrinted < dots)
    {
      (void)printf(".");
      (void) fflush(stdout);
    }
    else
    {
      resetprint(".");
      (void) fflush(stdout);
    }
  }
  dotsPrinted++;
}

searchFail(objectType)
int objectType;
{
int problem;
  searchfail = TRUE;
  if (abandoned)
  {
     resetprint(SEABAN);
     return SF_ABANDONED;
  }
  if (accessrightproblem)
  {
    problem = SF_ACCRIGHT;
    resetprint(ACLPROB);
  }
  else
  {
    problem = SF_OPFAIL;
    resetprint(THESEARCH);
    if (strcmp(qinfo[objectType].entered, "*") != 0)
      resetprint(FORENTRY, qinfo[objectType].entered);
    resetprint(HASFAILED);
    if (objectType == ORGUNIT)
    {
      resetprint(DISPLAYORG);
      resetprint(FORPEOPLEOUS);
    }
    else if (objectType == PERSON)
    {
      if (qinfo[ORGUNIT].lp == NULLLIST)
        resetprint(DISPLAYORG);
      else
        resetprint(DISPLAYDEPT);
      resetprint(FORPEOPLE);
    }
  }
  if (objectType == ORGUNIT)
  {
    printNames(ORG);
    printDetails(ORG, qinfo[ORG].lp);
    return problem;
  }
  if (objectType == PERSON)
  {
    if (qinfo[ORGUNIT].lp != NULLLIST)
    {
       printNames(ORGUNIT);
       printDetails(ORGUNIT, qinfo[ORGUNIT].lp);
    }
    else
    {
       printNames(ORG);
       printDetails(ORG, qinfo[ORG].lp);
     }
     return problem;
  }
  return problem;
}

void
de_exit(exitCode)
int exitCode;
{
void exit();

  freeList(&qinfo[COUNTRY].lp);
  freeList(&qinfo[LOCALITY].lp);
  freeList(&qinfo[ORG].lp);
  freeList(&qinfo[ORGUNIT].lp);
  freeList(&qinfo[PERSON].lp);
  if (byeByeMessage == TRUE)
#ifdef DOS
    displayFile(BYEBYE, FALSE, FALSE);
#else
    displayFile(BYEBYE, FALSE); /* FALSE means not a help screen */
#endif DOS
  if (byebyeScreenTime > 0)
  {
#ifdef DOS
    (void)signal(SIGINT, SIG_IGN);
#else
    (void)signal(SIGINT, SIG_DFL);
    (void)printf(FORCEQUIT, byebyeScreenTime);
#endif DOS
    (void)sleep((unsigned)byebyeScreenTime);
  }
#ifdef DOS
  else if (exitCode != 0)
    sleep(3);
#endif
  exit(exitCode);
}
