/* deufn.c - some de specific ufn routines */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/deufn.c,v 9.2 1993/03/19 22:54:14 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/deufn.c,v 9.2 1993/03/19 22:54:14 isode Exp isode $
 *
 *
 * $Log: deufn.c,v $
 * Revision 9.2  1993/03/19  22:54:14  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.1  1992/11/12  20:05:23  awy
 * IC-1 base
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#define deufn_c
#ifdef DOS
#include <stdlib.h>
#include "proto-de.h"
#endif DOS
#include "messages.h"
#include <stdio.h>
#include <ctype.h>
#include <pwd.h>
#include <signal.h>
#include <setjmp.h>
#ifdef DOS
#include <msdos.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#endif DOS

#ifdef USELDAP
#include <string.h>
#ifdef IC
#include <ldap/lber.h>
#include <ldap/ldap.h>
#else
#include <lber.h>
#include <ldap.h>
#endif /* IC */
#include "isomanifest.h"
#include "namelist.h"
#else
#include "quipu/ufn.h"
#include "quipu/util.h"
#endif USELDAP
#include "demanifest.h"
#include "util.h"
#include "destrings.h"
#ifndef USELDAP
#ifdef IC
#include "compat/tailor.h"
#else
#include "tailor.h"
#endif /* IC */
#endif USELDAP
#include "query.h"

extern int ufnConfigured;

#ifdef USELDAP
#ifndef DOS
extern FILE *de_log;
extern int depid;
#endif DOS
#else
extern LLog *de_log;
#endif USELDAP
extern char *deTidyString();
void onint1(), de_exit();

extern struct query qinfo[];

extern int minUfnNames;
extern int boundToDSA;
extern int deLogLevel;
extern char searchVal[];

void
doUfnSearch()
{
#ifdef USELDAP
struct namelist * ufn_interact();
struct namelist * ufnres, * dns;
#else
DNS ufn_interact();
struct dn_seq  *ufnres, * dns;
#endif USELDAP
char buf[BUFSIZ];
char * ufnargv[10];
int ufnel;
char * cp, * cp2, ** cpp;
int res;

  clearProblemFlags();
  suppressSearchMess();
  ufnel = 0;
  ufnres = NULL;
  (void) strcpy(buf, qinfo[PERSON].entered);
  cp = buf;
  for (cpp = &ufnargv[0]; ; cpp++)
  {
    *cpp = cp;
    ufnel++;
    cp2 = index(cp, ',');
    if (cp2 == NULL)
    {
      *(++cpp) = NULLCP;
      break;
    }
    else
    {
      *cp2 = '\0';
      cp = ++cp2;
    }
  }
  if (ufnel < minUfnNames)
  {
    resetprint(UFNTOOSHORT, ufnel);
    if (enterYesNo(MOREUFNDETAILS) == YESCHAR)
      return;
  }
  if ((index(qinfo[PERSON].entered, '@') != NULLCP) ||
      (index(qinfo[PERSON].entered, '.') != NULLCP))
  {
    resetprint(AVOIDDOMAINS);
    if (enterYesNo(MOREUFNDETAILS) == YESCHAR)
      return;
  }

#ifndef DOS
  if (deLogLevel)
#ifdef USELDAP
    (void) fprintf (de_log,
		"%5d:Search: ufn=%s", depid,
#else
    (void) ll_log (de_log, LLOG_NOTICE, NULLCP, 
		"Search: ufn=%s",
#endif USELDAP
                         qinfo[PERSON].entered);
#endif DOS

  initAlarm();
  (void)strcpy(searchVal, qinfo[PERSON].entered);
#ifdef USELDAP
  if (ufn_match(ufnel, ufnargv, ufn_interact, &ufnres, NULL) == 0)
#else
  if (ufn_match(ufnel, ufnargv, ufn_interact, &ufnres, NULLEL) == 0)
#endif USELDAP
  {
    if (ufnConfigured == TRUE)
    {
      resetprint(THESEARCH);
      resetprint(FORENTRY, searchVal);
      resetprint(HASFAILED);
    }
    else
      resetprint(NOUFN);
    return;
  }
#ifdef USELDAP
  if (ufnres == NULLLIST)
#else
  if (ufnres == NULLDNS)
#endif USELDAP
  {
    (void)printf (NOUFNMATCH);
    return;
  }
  pagerOn(NUMBER_NOT_ALLOWED);
  pageprint("\n");
#ifdef USELDAP
  for (dns = ufnres; dns != NULLLIST; dns = dns->next)
  {
    res = readPerson(dns->name, &qinfo[PERSON].lp);
    alarmCleanUp();
    if (res != OK)
    {
      resetprint("Couldn't read entry for `%s'\n",
                  lastComponent(dns->name, PERSON));
    }
    else
    {
      (void) printUfnComponents(dns->name);
      printDetails(PERSON, qinfo[PERSON].lp);
      freeList(&qinfo[PERSON].lp);
    }
    initAlarm();
  }
#else
  for (dns = ufnres; dns != NULLDNS; dns = dns->dns_next)
  {
    res =readPerson(dn2str(dns->dns_dn), &qinfo[PERSON].lp, DE_UNSIGNED);
    alarmCleanUp();
    if (res != OK)
    {
      resetprint(CANTREAD, lastComponent(dn2str(dns->dns_dn), PERSON));
    }
    else
    {
      (void) printUfnComponents(dn2str(dns->dns_dn));
      printDetails(PERSON, qinfo[PERSON].lp);
      freeList(&qinfo[PERSON].lp);
    }
    initAlarm();
  }
#endif USELDAP
  alarmCleanUp();
  (void) strcpy(qinfo[PERSON].defvalue, qinfo[PERSON].entered);
  return;
}


/* ARGSUSED */
#ifdef USELDAP
struct namelist * ufn_interact(dns, dn, s)
struct namelist * dns;
char * dn;
#else
DNS ufn_interact (dns, dn, s)
DNS dns;
DN dn;
#endif USELDAP
char * s;
{
char    buf[LINESIZE], buf2[LINESIZE], penult[LINESIZE];
#ifdef USELDAP
struct namelist * tmp, * ptr;
#else
DNS tmp, ptr;
#endif USELDAP
int i, j, n;
char * cp;

	alarmCleanUp();
#ifdef USELDAP
        if (dns == NULLLIST)
                return NULLLIST;
#else
        if (dns == NULLDNS)
                return NULLDNS;
#endif USELDAP
        pagerOn(NUMBER_ALLOWED);
	i = 0;
#ifdef USELDAP
        for (ptr = dns; ptr != NULLLIST; ptr = ptr->next)
#else
        for (ptr = dns; ptr; ptr = ptr -> dns_next)
#endif USELDAP
	{
          i++;
#ifdef USELDAP
          if (dns->next != NULLLIST) /* more than one in list */
          {
            if (removeLastRDN(ptr->name) != NULLCP)
            {
              (void)strcpy(buf2, removeLastRDN(ptr->name));
#else
          if (dns->dns_next != NULLDNS) /* more than one in list */
	  {
            if (removeLastRDN(dn2str(ptr->dns_dn)) != NULLCP)
	    {
	      (void)strcpy(buf2, removeLastRDN(dn2str(ptr->dns_dn)));
#endif USELDAP
              if (i == 1)
	        j = printUfnComponents(buf2);
	      else
	      {
	        if (strcmp(penult, buf2) != 0)
		  j = printUfnComponents(buf2);
	      }
	      (void)strcpy(penult, buf2);
	    }
	    else
	      j = 0; /* component under the root */
#ifdef USELDAP
            (void)strcpy(buf, lastRDN(ptr->name));
#else
	    (void)strcpy(buf, lastRDN(dn2str(ptr->dns_dn)));
#endif USELDAP
	    cp = index(buf, '=') + 1;
	    pageprint("%-*s%3d %s\n", j, "", i, cp);
	  }
	}
        if (i == 1)
	{
	  n = i;
	  goto validNumber;
	}
	if ((n = getpnum()) != -1)
	  if (n > i)
            (void) fprintf(stderr, INVNUMBER, i);
	  else
	    goto validNumber;

reEnter:
	writeInverse(ENTNUMBER);
	writeInverse(":- ");
	/* onint1 is used to do a return to the person prompt with
           appropriate cleaning up */
	if (gets(buf) == NULLCP) /* deal with control-D */
	{
#ifdef DOS
          goToStartOfLine();
	  clearerr(stdin);
          onint1(0);
	}
        goToStartOfLine();
#else
	  clearerr(stdin);
	  onint1();
	}
#endif DOS
	cp = copy_string(deTidyString(buf));
	if (strlen(cp) == 0)
	{
	  free(cp);
	  initAlarm();
#ifdef USELDAP
          return NULLLIST;
#else
	  return NULLDNS;
#endif USELDAP
	}
	if (lexnequ(cp, QUITWORD, strlen(cp)) == 0)
	{
	  free(cp);
#ifdef DOS
	  onint1(0);
#else
	  onint1();
#endif DOS
	}
	n = atoi(cp);
	if ((n < 1) || (n > i))
	{
	  soundBell();
	  goto reEnter;
	}
validNumber:
	for (ptr = dns, j = 1; j < n; j++)
	{
	  tmp = ptr;
#ifdef USELDAP
          ptr = ptr->next;
          tmp->next = NULLLIST;
          freeList(&tmp);
        }
        freeList(&(ptr->next));
        ptr->next = NULLLIST;
#else
	  ptr = ptr -> dns_next;
	  tmp -> dns_next = NULL;
	  dn_seq_free (tmp);
	}
	dn_seq_free(ptr->dns_next);
	ptr->dns_next = NULL;
#endif USELDAP
	initAlarm();
	return(ptr);
}

int
printUfnComponents(str)
char * str;
{
char buf[BUFSIZ];
int j;
char * cp, *cp2;

  if (str == NULLCP)
    return 0;
  (void)strcpy(buf, str);
  for (j = 0, cp = buf; cp != NULLCP; j++)
  {
#ifdef USELDAP
    cp2 = rindex(buf, ',');
    if (cp2 != NULLCP)
      *cp2++ = '\0';
    else
      cp2 = buf;
    cp = index(cp2, '=') + 1;
    pageprint("%*s%s\n", j, "", cp);
    if (cp2 != buf)
      cp = buf;
    else
      cp = NULLCP;
#else
    cp2 = index(cp, '@');
    if (cp2 != NULLCP)
      *cp2 = '\0';
    cp = index(cp, '=') + 1;
    pageprint("%*s%s\n", j, "", cp);
    if (cp2 != NULLCP)
      cp = cp2+1;
    else
      cp = NULLCP;
#endif USELDAP
  }
  return j;
}
