/* filt.c - some general filter routines */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/filt.c,v 9.3 1993/03/19 22:54:18 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/filt.c,v 9.3 1993/03/19 22:54:18 isode Exp isode $
 *
 *
 * $Log: filt.c,v $
 * Revision 9.3  1993/03/19  22:54:18  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.2  1992/12/15  07:05:26  awy
 * Update and fixes
 *
 * Revision 9.1  1992/11/12  20:05:23  awy
 * IC-1 base
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#include <stdio.h>
#include <string.h>

#ifndef USELDAP
#include "quipu/util.h"
#include "quipu/ds_search.h"
#endif

#include "demanifest.h"
#include "destrings.h"

#ifdef USELDAP
extern char ldap_filter[];
#else
char filbuf[BUFSIZ];
#endif
extern int fuzzyMatching;
extern int gotFuzzyMatch;

#ifndef USELDAP
Filter get_filter();
#endif

#ifdef USELDAP
void
genFilter1(val, oc, at)
char * val, * oc, * at;
{
	gotFuzzyMatch = FALSE;
	(void)sprintf(ldap_filter, "(&(%s=%s)(%s=%s))", DE_OBJECT_CLASS,
		oc, at, val);
}
#else
void
genFilter1(val, oc, at, fpp)
char * val, * oc, * at;
struct s_filter ** fpp;
{
	gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "(%s=%s) & (%s=%s)", DE_OBJECT_CLASS,
		oc, at, val);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
genFilter2(val, oc, at)
char * val, * oc, * at;
{
	gotFuzzyMatch = FALSE;
	(void)sprintf(ldap_filter, "(&(%s=%s)(%s=%s*))", DE_OBJECT_CLASS,
		oc, at, val);
}
#else
void
genFilter2(val, oc, at, fpp)
char * val, * oc, * at;
struct s_filter ** fpp;
{
	gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "(%s=%s) & (%s=%s*)", DE_OBJECT_CLASS,
		oc, at, val);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
genFilter3(val, oc, at)
char * val, * oc, * at;
{
	gotFuzzyMatch = FALSE;
	(void)sprintf(ldap_filter, "(&(%s=%s)(%s=*%s*))", DE_OBJECT_CLASS,
		oc, at, val);
}
#else
void
genFilter3(val, oc, at, fpp)
char * val, * oc, * at;
struct s_filter ** fpp;
{
	gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "(%s=%s) & (%s=*%s*)", DE_OBJECT_CLASS,
		oc, at, val);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
genFilter4(val, oc, at)
char * val, * oc, * at;
{
	if (fuzzyMatching == FALSE)
	{
		(void)strcpy(ldap_filter, "");
		return;
	}
	gotFuzzyMatch = TRUE;
	(void)sprintf(ldap_filter, "(&(%s=%s)(%s~=%s))", DE_OBJECT_CLASS,
		oc, at, val);
}
#else
void
genFilter4(val, oc, at, fpp)
char * val, * oc, * at;
struct s_filter ** fpp;
{
	if (fuzzyMatching == FALSE)
	{
		*fpp = NULLFILTER;
		return;
	}
	gotFuzzyMatch = TRUE;
	(void)sprintf(filbuf, "(%s=%s) & (%s~=%s)", DE_OBJECT_CLASS,
		oc, at, val);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
genAllFilter(oc)
char * oc;
{
	gotFuzzyMatch = FALSE;
	(void)sprintf(ldap_filter, "(%s=%s)", DE_OBJECT_CLASS, oc);
}
#else
void
genAllFilter(oc, fpp)
char * oc;
struct s_filter ** fpp;
{
	gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "%s=%s", DE_OBJECT_CLASS, oc);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
genExplicitFilter(val, oc, at)
char * val, * oc, * at;
{
	gotFuzzyMatch = FALSE;
	(void)sprintf(ldap_filter, "(& (%s=%s) (%s=%s))", DE_OBJECT_CLASS,
		oc, at, val);
}
#else
void
genExplicitFilter(val, oc, at, fpp)
char * val, * oc, * at;
struct s_filter ** fpp;
{
	gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "(%s=%s) & (%s=%s)", DE_OBJECT_CLASS,
		oc, at, val);
	*fpp = get_filter(filbuf);
}
#endif
