/* generic.c - search for a country/loc/org/ou/prr */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/country.c,v 9.3 1993/03/19 22:53:46 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/country.c,v 9.3 1993/03/19 22:53:46 isode Exp isode $
 *
 *
 * $Log: country.c,v $
 * Revision 9.3  1993/03/19  22:53:46  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.2  1992/12/15  07:05:26  awy
 * Update and fixes
 *
 * Revision 8.1  1991/09/13  14:36:41  isode
 * PARADISE Upgrade release
 *
 * Revision 8.0  91/07/17  13:18:38  isode
 * Release 7.0
 *
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#define country_c
#ifdef DOS
#include <stdlib.h>
#include "proto-de.h"
#endif DOS
#include "messages.h"
#include <signal.h>
#ifdef USELDAP
#ifdef IC
#include <ldap/lber.h>
#include <ldap/ldap.h>
#else
#include <lber.h>
#include <ldap.h>
#endif /* IC */
#include <string.h>
#include "isomanifest.h"
#ifdef DOS
#include <msdos.h>
#else
#include <sys/time.h>
#endif DOS
#else
#include "quipu/util.h"
#include "quipu/read.h"
#include "quipu/list.h"
#include "quipu/ds_search.h"
#include "quipu/dua.h"
#endif USELDAP
#include "demanifest.h"
#include "namelist.h"
#include "filter.h"
#include "destrings.h"

#ifndef USELDAP
#ifdef OSISEC
#include "osisec/osisec.h"
#endif
#include "osisec-stub.h"

/* OSISEC */
extern char * dsa_name;
extern struct SecurityServices *dsap_security;
#endif

#ifndef USELDAP
extern char filbuf[];
struct ds_read_arg rarg;
struct ds_read_result rresult;

struct ds_list_arg larg;
struct ds_list_result lresult;

struct ds_search_arg sarg;
struct ds_search_result sresult;
struct DSError serror;
#endif USELDAP

extern char mode;
extern int abandoned;
extern int highNumber;
extern int exactMatch;
extern int fuzzyMatching;
extern int gotFuzzyMatch;
extern int quipuMastersCo;
extern char exactString[];
extern int searchAliasLo;
extern int searchAliasOup;
extern char searchVal[];
extern char * username;

extern struct namelist * atts[];

extern int listAtRoot;

#ifdef USELDAP
extern LDAP * ldap_ld;
extern char * ldap_base;
extern int ldap_scope;
extern char ldap_filter[BUFSIZ];
extern char ** ldap_attrs;
extern char ldap_attrsonly;
extern int ldap_msgid;
extern int ldap_all;
extern struct timeval ldap_timeout;
extern LDAPMessage * ldap_res;
LDAPMessage * ldap_delete_result_entry();
void fillMostReadArgs();
void fillMostListArgs();
void fillMostSearchArgs();
#else
struct ds_read_arg *fillMostReadArgs();
struct ds_list_arg *fillMostListArgs();
struct ds_search_arg *fillMostSearchArgs();
Filter get_filter();
#endif USELDAP

extern VFP explicitCo[];
extern VFP explicitLoc[];
extern VFP explicitOrg[];
extern VFP explicitOU[];
extern VFP explicitPRR[];

extern VFP normalCo[];
extern VFP normalLoc[];
extern VFP normalOrg[];
extern VFP normalOU[];
extern VFP normalPRR[];

typedef void (*(*VFPP)) ();
#define NULLVFPA ((VFPP) 0)

VFP * explicitFilter[] = {
	NULLVFPA,
	explicitPRR,
	explicitOU,
	explicitOrg,
	explicitLoc,
	explicitCo };

VFP * normalFilter[] = {
	NULLVFPA,
	normalPRR,
	normalOU,
	normalOrg,
	normalLoc,
	normalCo };

int
listEntries(pstr, str, listp, objectType)
char * pstr, * str;
struct namelist ** listp;
int objectType;
{
	(void)strcpy(searchVal, str);
	clearProblemFlags();
	initAlarm();	
	if (exactMatch == objectType)
	  return(readEntry(exactString, listp, objectType));
        else if (strcmp(str, "*") == 0)
          return(listAllEntries(pstr, listp, objectType));
	else if (objectType == COUNTRY)
	{
	  if (strcmp(str, "-") == 0)
	    return(makeRootCountry(listp)); /* make the root a "country" to 
      	                       enable searching under the root of the tree */
	}
        return(listMatchingEntries(pstr, str, listp, objectType));
}

listAllEntries(str, listp, objectType)
char * str;
struct namelist ** listp;
int objectType;
{
int ret;

	if ((objectType == COUNTRY) || (quipuMastersCo == FALSE))
	{
#ifdef USELDAP
		fillMostListArgs(str, objectType);
#else
		larg = * fillMostListArgs(str);
#endif USELDAP
		ret = reallyMakeListEntries(listp, objectType);
	}
	else
	{
#ifdef USELDAP
	        fillMostSearchArgs(str, LDAP_SCOPE_ONELEVEL, objectType);
	        makeAllFilter(objectType);
#else
	        sarg = * fillMostSearchArgs(str, SRA_ONELEVEL, objectType);
	        makeAllFilter(&sarg.sra_filter, objectType);
#endif USELDAP
	        ret = makeListEntries(listp);
	}
        if (ret != OK)
		logListSuccess2(LIST_ERROR, objectType, 0);
	else
		logListSuccess2(LIST_OK, objectType, listlen(*listp));
						
	if ((objectType == COUNTRY) || (quipuMastersCo == FALSE))
		freeListArgs();
	else
		freeSearchArgs();
	alarmCleanUp();
	return ret;
}

listMatchingEntries(pstr, str, listp, objectType)
char * pstr, * str;
struct namelist ** listp;
int objectType;
{
VFP * filtarray;
VFP filterfunc;
int filtnumber;
int ret, repeatSearch;
char str2[BUFSIZ];

	if (((objectType == COUNTRY) && (strlen(str) == 2)) ||
	    ((objectType != COUNTRY) && (quipuMastersCo == FALSE))) /* try read first */
	{
#ifdef USELDAP
		if (objectType == COUNTRY)
			(void) sprintf(str2, "%s=%s", SHORT_CO, str);
		else
		{
			(void)sprintf(str2, "%s=%s, %s", 
			    shortString(objectType), str, pstr);
		}
#else
		if (objectType == COUNTRY)
			(void) sprintf(str2, "%s=%s", SHORT_CO, str);
		else
		{
			(void)sprintf(str2, "%s@%s=%s", pstr,
			    shortString(objectType), str);
		}
#endif
		ret = readEntry(str2, listp, objectType);
		if (ret == OK)
		{
			logReadSuccess2(READ_OK, objectType);
			alarmCleanUp();
			return OK;
		}
		else
			logReadSuccess2(READ_FAIL, objectType);
	}

	repeatSearch = 0;
#ifdef USELDAP
	fillMostSearchArgs(pstr, LDAP_SCOPE_ONELEVEL, objectType);
#else
	sarg = * fillMostSearchArgs(pstr, SRA_ONELEVEL, objectType);
#endif USELDAP
/* can return to this point if repeating a search with different search args
   - for example subtree instead of single level scope for OUs */
searchAgain:
        if (index(str, '*') != NULLCP) /* contains at least one asterisk */
	{
                filtarray = explicitFilter[objectType];
		filtnumber = -1;
	}
        else
	{
                filtarray = normalFilter[objectType];
		filtnumber = 0;
	}
        while ((filterfunc = *filtarray++) != NULLVFP)
	{
		filtnumber++;
#ifdef USELDAP
                filterfunc(str, ocString(objectType), atString(objectType));
		if (ldap_filter == NULLCP)
			continue;
#else
                filterfunc(str, ocString(objectType), atString(objectType),
			&sarg.sra_filter);
		if (sarg.sra_filter == NULLFILTER)
			continue;
#endif USELDAP
                ret = makeListEntries(listp);
		if ((ret != OK) && (ret != PROTREJECT))
		{ 	
			freeSearchArgs();
			logSearchSuccess2(SEARCH_ERROR, objectType, str, filtnumber, 0);
			alarmCleanUp();
			return NOTOK;
		}
                if (*listp != NULLLIST) /* got some results */
		{
			break;
		}
	}
	if (*listp != NULLLIST)
		logSearchSuccess2(SEARCH_OK, objectType, str, filtnumber, listlen(*listp));
	else
	{
		logSearchSuccess2(SEARCH_FAIL, objectType, str, filtnumber, 0);
		/* if looking for an OU, try a sub-tree search */
		if ((objectType == ORGUNIT) && (repeatSearch == 0)) 
		{
			freeSearchArgs();
			repeatSearch = 1;
#ifdef USELDAP
		        fillMostSearchArgs(pstr, LDAP_SCOPE_SUBTREE, objectType);
#else
		        sarg = * fillMostSearchArgs(pstr, SRA_WHOLESUBTREE, objectType);
#endif USELDAP
			goto searchAgain;
		}
	}
	freeSearchArgs();
	alarmCleanUp();
	return OK;
}

readEntry(objectstr, listp, objectType)
char * objectstr;
struct namelist ** listp;
int objectType;
{
int retval;
#ifdef USELDAP
LDAPMessage * enp;
#endif USELDAP

#ifdef USELDAP
	fillMostReadArgs(objectstr, objectType);
	retval = de_read();
#else
	rarg = * fillMostReadArgs(objectstr, objectType, DE_UNSIGNED);
#if (OSISEC2 && IC)
	retval = de_read(&rarg, &serror, &rresult, DE_UNSIGNED);
#else
	retval = de_read(&rarg, &serror, &rresult);
#endif
/*	if ((retval == DSE_INTR_ABANDONED) &&
	    (serror.dse_type == DSE_ABANDONED))
	         abandoned = TRUE; */
#endif USELDAP
#ifdef USELDAP
	freeReadArgs();
#endif USELDAP
	if (retval != OK)
		return retval;
	/* setProblemFlags(rresult); */

	*listp = list_alloc();
#ifdef USELDAP
	if (ldap_count_entries(ldap_ld, ldap_res) > 0) {
		enp = ldap_first_entry(ldap_ld, ldap_res);
		(*listp)->name = ldap_get_dn(ldap_ld, enp);
		(*listp)->ats = ldap_delete_result_entry( &ldap_res, enp );
	}
	else
		return NOTOK;
	freeLdapMsg(ldap_res);
#else
	(*listp)->name = dn2pstr(rresult.rdr_entry.ent_dn);
	(*listp)->ats = as_cpy(rresult.rdr_entry.ent_attr);
#endif USELDAP
	(*listp)->next = NULLLIST;
	highNumber = 1;
	return OK;
	
}

reallyMakeListEntries(listp, objectType)
struct namelist ** listp;
int objectType;
{
int retval;
char * cp;
#ifdef USELDAP
LDAPMessage * enp;
#else
struct subordinate * x;
DN dn1, dn2;
#endif USELDAP

	if (rebind() != OK)
                 return NOTOK;
#ifdef USELDAP
	retval = de_list();
#else
	retval = de_list(&larg, &serror, &lresult);
	if ((retval == DSE_INTR_ABANDONED) &&
	    (serror.dse_type == DSE_ABANDONED))
	        abandoned = TRUE;
#endif USELDAP
	if (retval != OK)
		 return retval;

	/* setProblemFlags(sresult); */
	highNumber = 0;
#ifdef USELDAP
	if (ldap_count_entries(ldap_ld, ldap_res) > 0)
	    for (enp = ldap_first_entry(ldap_ld, ldap_res); enp != NULL;
				enp = ldap_next_entry(ldap_ld, enp))
	    {
		/* only add the objects we are interested in to the list */
		cp = ldap_get_dn(ldap_ld, enp);
		if (rightObjectType(objectType, cp))
		{
			*listp = list_alloc();
			(*listp)->name = ldap_get_dn(ldap_ld, enp);
			(*listp)->ats = NULLMSG;
			listp = &(*listp)->next;
			highNumber++;
		}
		else free(cp);
	    }
	freeLdapMsg(ldap_res);
#else
	for (x = lresult.lsr_subordinates; x != (struct subordinate *) NULL;
	                                   x = x->sub_next)
	{
		/* only add countries and localities to the list */
		cp = strdup(attr2name(x->sub_rdn->rdn_at, OIDPART));
		if (rightObjectType(objectType, cp))
		{
			*listp = list_alloc();
			if (objectType == COUNTRY)
				(*listp)->name = rdn2pstr(x->sub_rdn);
			else
			{
				dn1 = dn_cpy(larg.lsa_object);
				dn2 = dn_comp_new(x->sub_rdn);
				dn_append(dn1, dn2);
				(*listp)->name = dn2pstr(dn1);
			}
			(*listp)->ats = NULLATTR;
			listp = &(*listp)->next;
			highNumber++;
		}
		free(cp);
	}
#endif USELDAP
	*listp = NULLLIST;
#ifndef USELDAP
	/* free something */
	dn_free (lresult.lsr_object);
	/* free something else */
#endif USELDAP
	return OK;
}

#ifdef USELDAP
makeListEntries(listp)
struct namelist ** listp;
{
LDAPMessage * enp, * tmpenp;
int retval;

	if (rebind() != OK)
		return NOTOK;
	retval = de_search();
	if (retval != OK)
	{
		*listp = NULLLIST;
		return retval;
	}
        highNumber = 0;
        if (ldap_count_entries(ldap_ld, ldap_res) > 0)
            for (enp = ldap_first_entry(ldap_ld, ldap_res); enp != NULL;
                                        enp = tmpenp)
            {
		tmpenp = ldap_next_entry(ldap_ld, enp);
                *listp = list_alloc();
                (*listp)->name = ldap_get_dn(ldap_ld, enp);
                (*listp)->ats = ldap_delete_result_entry( &ldap_res, enp );
                listp = &(*listp)->next;
                highNumber++;
            }
	freeLdapMsg(ldap_res);
        *listp = NULLLIST;
        return OK;
}
#else
makeListEntries(listp)
struct namelist ** listp;
{
entrystruct * x;
int retval;

	if (rebind() != OK)
		return NOTOK;
	retval = de_search(&sarg, &serror, &sresult);
/* the following if statement was commented out - don't know why ??? */
	if ((retval == DSE_INTR_ABANDONED) &&
	    (serror.dse_type == DSE_ABANDONED))
		abandoned = TRUE;
	if (retval != OK)
	{
		*listp = NULLLIST;
		filter_free(sarg.sra_filter);
		return retval;
	}
	correlate_search_results (&sresult);

	setProblemFlags(sresult);

	highNumber = 0;
	for (x = sresult.CSR_entries; x != NULLENTRYINFO; x = x->ent_next) {
		*listp = list_alloc();
		(*listp)->name = dn2pstr(x->ent_dn);
		(*listp)->ats = as_cpy(x->ent_attr);
		listp = &(*listp)->next;
		highNumber++;
	}
	*listp = NULLLIST;
	entryinfo_free(sresult.CSR_entries,0);
	dn_free (sresult.CSR_object);
	crefs_free (sresult.CSR_cr);
	filter_free(sarg.sra_filter);
	return OK;
}
#endif USELDAP

#ifdef USELDAP
void
fillMostReadArgs(objectstr, objectType)
char * objectstr;
int objectType;
{
char * cp;

/* it was like this, but it can't be right - keep the code until I'm
   sure why it was like this 
	ldap_base = removeLastRDN(objectstr); */
	ldap_base = strdup(objectstr);
	ldap_scope = LDAP_SCOPE_BASE;
	ldap_attrs = makeAllAttrs(atts[objectType]);
	ldap_attrsonly = 0;
	ldap_all = 1;
	ldap_timeout.tv_sec = 2;
	ldap_timeout.tv_usec = 0;
/* NEED TO CHECK THIS */
/*	(void)sprintf(ldap_filter, "(%s)", (cp = lastRDN(objectstr))); */
	(void)sprintf(ldap_filter, "(objectclass=*)");
/*	free(cp); this has to go as the line 2 above is out */
}
#else
struct ds_read_arg *
fillMostReadArgs(objectstr, objectType, signedop)
char * objectstr;
int objectType;
int signedop;
{
static struct ds_read_arg arg;
static CommonArgs sca = default_common_args;
Attr_Sequence * atl;
AttributeType at;
struct namelist * x;

	arg.rda_common =sca; /* struct copy */
	if (signedop == DE_SIGNED)
		arg.rda_common.ca_requestor = str2dn(username);
	arg.rda_common.ca_servicecontrol.svc_timelimit = SVC_NOTIMELIMIT;
	arg.rda_common.ca_servicecontrol.svc_sizelimit= SVC_NOSIZELIMIT;

	arg.rda_object = str2dn(objectstr);
	/* specify attributes of interest */
	arg.rda_eis.eis_allattributes = FALSE;
	atl = &(arg.rda_eis.eis_select);
	for (x = atts[objectType]; x != NULLLIST; x = x->next)
	{
		if ((at = str2AttrT(x->name)) == NULLAttrT)
		    continue;
		*atl = as_comp_alloc();
		(*atl)->attr_type = at;
		(*atl)->attr_value = NULLAV;
		atl = &(*atl)->attr_link;
	}
	*atl = NULLATTR;
	arg.rda_eis.eis_infotypes = EIS_ATTRIBUTESANDVALUES;

	if (signedop == DE_SIGNED)
	{
	    struct Nonce *nonce;

            if (strcmp(dsap_security->serv_name, "quipusecurityservices") == 0)
	    {
                (void)fprintf (stderr,
		    "Strong Operation Security Service requires OSISEC");
                goto done;
	    }

            if ((nonce = MAKE_NONCE(dsap_security,(struct Nonce *) 0)) 
			== (struct Nonce *) 0)
                    goto done;

            free(nonce->non_time2);
            free(nonce->non_r1.value);
            free(nonce->non_r2.value);
            oid_free(nonce->non_alg.algorithm);
            pe_free(nonce->non_alg.asn);

            arg.rda_common.ca_security = (struct security_parms *)
                    calloc(1, sizeof(struct security_parms));
            arg.rda_common.ca_security->sp_time = nonce->non_time1;
            arg.rda_common.ca_security->sp_path = MAKEPATH(dsap_security);
            arg.rda_common.ca_security->sp_name = str2dn(dsa_name);
            arg.rda_common.ca_security->sp_target = 1; /* 1 means ask DSA to
                                                     provide signed results */
            free((char *) nonce);

	}
done:
	return (&arg);
}
#endif USELDAP

#ifdef USELDAP
void
fillMostListArgs(str, objectType)
char * str;
int objectType;
{
	ldap_base = copy_string(str);
	ldap_scope = LDAP_SCOPE_ONELEVEL;
/* This should be pruned for a list operation */
	ldap_attrs = makeAllAttrs(atts[objectType]);
/* NEED TO CHECK THESE VALUES */
	ldap_attrsonly = 1;
	ldap_all = 1;
	ldap_timeout.tv_sec = 2;
	ldap_timeout.tv_usec = 0;
	makeAllFilter(objectType);
}
#else
struct ds_list_arg *
fillMostListArgs(str)
char * str;
{
static struct ds_list_arg arg;
static CommonArgs sca = default_common_args;

	arg.lsa_common =sca; /* struct copy */
	arg.lsa_common.ca_servicecontrol.svc_timelimit = SVC_NOTIMELIMIT;
	arg.lsa_common.ca_servicecontrol.svc_sizelimit= SVC_NOSIZELIMIT;

	arg.lsa_object = str2dn(str);
	return (&arg);
}
#endif USELDAP

#ifdef USELDAP
void
fillMostSearchArgs(objectstr, searchdepth, objectType)
char * objectstr;
int searchdepth;
int objectType;
{
	if (strcmp(objectstr, "root") == 0)
		ldap_base = copy_string("");
	else
		ldap_base = copy_string(objectstr);
	ldap_scope = searchdepth;
	ldap_attrs = makeAllAttrs(atts[objectType]);
	ldap_attrsonly = 0;
	ldap_all = 1;
	ldap_timeout.tv_sec = 2;
	ldap_timeout.tv_usec = 0;
}
#else
struct ds_search_arg *
fillMostSearchArgs(objectstr, searchdepth, objectType)
char * objectstr;
int searchdepth;
int objectType;
{
static struct ds_search_arg arg;
static CommonArgs sca = default_common_args;
Attr_Sequence * atl;
AttributeType at;
struct namelist * x;

	arg.sra_common = sca; /* struct copy */
        arg.sra_common.ca_servicecontrol.svc_timelimit = SVC_NOTIMELIMIT;
        arg.sra_common.ca_servicecontrol.svc_sizelimit= SVC_NOSIZELIMIT;

	arg.sra_subset = searchdepth;
	if (strcmp(objectstr, "root") == 0)
		 arg.sra_baseobject = NULLDN;
	else
		arg.sra_baseobject = str2dn(objectstr);
	switch (objectType)
	{
		case COUNTRY:
			arg.sra_searchaliases = FALSE;
			break;
		case LOCALITY:
		case ORG:
			arg.sra_searchaliases = searchAliasLo;
			break;
		case ORGUNIT:
		case PERSON:
			if ((mode == POWERLETTER) || (mode == YELLOWPAGES))
				arg.sra_searchaliases = FALSE;
			else
				arg.sra_searchaliases = searchAliasOup;
			break;
	}
	/* specify attributes of interest */
	arg.sra_eis.eis_allattributes = FALSE;
	atl = &(arg.sra_eis.eis_select);
	for (x = atts[objectType]; x != NULLLIST; x = x->next)
	{
		if ((at = str2AttrT(x->name)) == NULLAttrT)
		    continue;
		*atl = as_comp_alloc();
		(*atl)->attr_type = at;
		(*atl)->attr_value = NULLAV;
		atl = &(*atl)->attr_link;
	}
	*atl = NULLATTR;
	arg.sra_eis.eis_infotypes = EIS_ATTRIBUTESANDVALUES;
	return (&arg);
}
#endif USELDAP

#ifdef USELDAP
#ifdef DOS
void
#endif DOS
makeAllFilter(objectType)
int objectType;
{
	switch (objectType)
	{
		case COUNTRY:
			makeAllCoFilter();
			return;
		case ORGUNIT:
			genAllFilter(DE_ORGANISATIONAL_UNIT);
			return;
		case ORG:
			genAllFilter(DE_ORGANISATION);
			return;
		case LOCALITY:
			genAllFilter(DE_LOCALITY);
			return;
		case PERSON:
			makeAllPRRFilter();
			return;
	}
}
#else
makeAllFilter(fpp, objectType)
struct s_filter ** fpp;
{
	switch (objectType)
	{
		case COUNTRY:
			makeAllCoFilter(fpp);
			break;
		case ORGUNIT:
			genAllFilter(DE_ORGANISATIONAL_UNIT, fpp);
			break;
		case ORG:
			genAllFilter(DE_ORGANISATION, fpp);
			break;
		case LOCALITY:
			genAllFilter(DE_LOCALITY, fpp);
			break;
		case PERSON:
			makeAllPRRFilter(fpp);
			break;
	}
        *fpp = get_filter(filbuf);
}
#endif USELDAP
