/* init.c */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/init.c,v 9.3 1993/03/19 22:54:35 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/init.c,v 9.3 1993/03/19 22:54:35 isode Exp isode $
 *
 *
 * $Log: init.c,v $
 * Revision 9.3  1993/03/19  22:54:35  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.2  1992/12/15  07:05:26  awy
 * Update and fixes
 *
 * Revision 8.1  1991/09/13  14:36:41  isode
 * PARADISE Upgrade release
 *
 * Revision 8.0  91/07/17  13:18:42  isode
 * Release 7.0
 *
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */


/****************************************************************************

  init.c - Do some initialising
           Read tailor files
           Eventually do argument parsing

*****************************************************************************/

#define init_c
#ifdef DOS
#include <stdlib.h>
#include "proto-de.h"
#include <graph.h>
#endif DOS

/* OSISEC */
#ifndef USELDAP
#include "osisec-stub.h"
#endif

/* #include <stdlib.h> */
#ifndef DOS
#include <sys/stat.h>
#endif
#include "messages.h"
#include "demanifest.h"
#include "namelist.h"
#include "types.h"
#include "util.h"
#ifdef USELDAP
#include "stdlib.h"
#include "string.h"
#ifndef DOS
#include "strings.h"
#endif DOS
#include "isomanifest.h"
#else
#include "quipu/util.h"
#ifdef IC
#include "compat/tailor.h"
#include "compat/logger.h"
#else
#include "tailor.h"
#include "logger.h"
#endif /* IC */
#endif USELDAP
#include "query.h"
#include "destrings.h"

#ifndef USELDAP
static dsaAddFound = FALSE;

extern int print_parse_errors;          /* Quipu variable to disable
                                           printing of errors */
#endif USELDAP

#ifdef USELDAP
#ifndef DOS
extern FILE * de_log;
extern char * logfilename;
extern int depid;
#endif DOS
#else
extern LLog * de_log;
extern char *isodelogpath;
#endif USELDAP

extern struct query qinfo[];

extern char *oidtable,   /* Name of oidtable to use */
            *tailfile,   /* Name of dsaptailor file to use*/
            *username,
  	    *dsa_address,
	    *password,
            *backup_dsa_address,
  	    *local_dit;

extern char * dsa_name;

extern char initialMode;
extern int browserAvail;
extern int qosOn;
extern char * browserPath;
extern int preferInvVideo;
extern int greyBook;
extern int browseMess;
extern int maxOrgs;
extern int maxDepts;
extern int maxPersons;
extern int localAlarmTime;
extern int remoteAlarmTime;
extern int bindTimeout;
extern int noActivityTimeout;
extern int byebyeScreenTime;
extern int byeByeMessage;
extern int quitChars;
extern int deLogLevel;
extern int controlCtoQuit;
extern int wanAccess;
extern int deptQ;
extern int fuzzyMatching;
extern localOrgOnly;
extern int searchAliasLo;
extern int searchAliasOup;
extern int authLevel;
extern int signedRead;
extern int ufnDNs;
extern int maxPowerSearchOrgs;
extern int minUfnNames;

#ifdef USELDAP
extern char * ldapServer;
extern int ldapPort;
#endif USELDAP

extern char callingDteNumber[],
	    origDefaultCo[], 
	    origDefaultOrg[],
            welcomeMessage[];
char qosfilename[LINESIZE];	    
char detailfile[LINESIZE];
static void read_de_option();

extern struct namelist * atts[];

extern struct namelist * ypatts;

char * DS23DN2quipuDN(), * quipuDN2DS23DN();

#ifdef DOS
extern short fgcol;
extern short revfgcol;
extern long bgcol;
#endif DOS

/* OSISEC */
void
adios()
{
  de_exit(-1);
}

int initialisations(argc, argv)
int argc;
char ** argv;
{
/* OSISEC */
extern struct SecurityServices *dsap_security;

FILE *config_file;
int i;
#ifdef DOS
char linebuf[LINESIZE];
#else
char linebuf[LINESIZE], user_file[LINESIZE];
char * cp;
#ifndef USELDAP
void exit();
#endif USELDAP
#endif DOS

#ifndef USELDAP
  print_parse_errors = FALSE;   /* Stop auto printing of errors */
  quipu_syntaxes();
#endif USELDAP

#ifdef USE_PP
  pp_quipu_init ("de");
#endif

#ifdef OSISEC
        dsap_security = use_serv_X509();
#else  /* OSISEC */
#ifdef INSECURE
        dsap_security = use_serv_null();
#endif
#endif /* OSISEC */

#ifndef USELDAP
  /* Initialize dsap library. */
  dsap_init((int *)NULL, (char ***)NULL);
#ifdef OSISEC
  osisec_init((int *)NULL, (char ***)NULL);
#endif
  
  specialSyntaxHandlers();
#endif USELDAP

#ifdef USE_PP
  pp_quipu_run ();
#endif

  backup_dsa_address = NULLCP;
  username = NULLCP;
  password = NULLCP;

  for (i = PERSON; i <= COUNTRY; i++)
    qinfo[i].defvalue[0] = '\0';

  for (i = PERSON; i <= COUNTRY; i++)
    atts[i] = NULLLIST;

  ypatts = NULLLIST;

  detailfile[0] = '\0';

#ifdef POWERORGS
	maxPowerSearchOrgs = POWERORGS;
#endif

#ifndef USELDAP
/* Read in dsaptailor file */
  if ((config_file = fopen(isodefile(tailfile, 0), "r")) == (FILE *) NULL) {
    (void) fprintf(stderr, NODSAPTAILOR);
  } else {
    while(fgets(linebuf, sizeof(linebuf), config_file) != NULLCP)
      if ((*linebuf != '#') && (*linebuf != '\n')) (void) tai_string (linebuf);

    (void) fclose(config_file);
  }
  
  /* turn off logging that we are not interested in */
  (void) isodesetvar("compatlevel", "none", 0);
  (void) isodesetvar("addrlevel", "none", 0);
  (void) isodesetvar("tsaplevel", "none", 0);
  (void) isodesetvar("ssaplevel", "none", 0);
  (void) isodesetvar("psaplevel", "none", 0);
  (void) isodesetvar("psap2level", "none", 0);
  (void) isodesetvar("acsaplevel", "none", 0);
  (void) isodesetvar("rosaplevel", "none", 0);
  isodexport("de");
  (void)sprintf(qosfilename, "%s%s", isodelogpath, "/de.qos");
#else
#ifdef QOS
#ifdef QOSFILENAME
  (void)strcpy(qosfilename, QOSFILENAME);
#else
  (void)strcpy(qosfilename, "/tmp/de.qos");
#endif QOSFILENAME  
#endif QOS
#endif USELDAP


  /* always read object class attribute - this means that searches/reads will 
     work even if none of the selected attributes is present in the entry */
  for (i = PERSON; i <= COUNTRY; i++)
    addToList(&atts[i], DE_OBJECT_CLASS);
  /* always want this att for country - this is to allow de to determine
     whether it is querying in a Quipu part of the world. */
  addToList(&atts[COUNTRY], "masterDSA");
  /* we need to be able to read a valid locality attribute */
  addToList(&atts[LOCALITY], DE_LOCALITY_NAME);

#ifndef DOS
  for (argc--, argv++; argc > 0; )
  {
    cp = *argv;
    if (*cp == '-')
      switch (*++cp)
      {
        case 'h':
	  argc--;
	  argv++;
	  if (argv != (char **)NULL)
	  {
	    (void) strcpy(callingDteNumber, *argv);
	    argc--;
	    argv++;
	  }
	  else
	    (void) strcpy(callingDteNumber, "");
	  break;
	case 't': /* Tailor file */
	  argc--;
	  argv++;
	  if( *argv != NULLCP )
	    (void) strcpy(detailfile, *argv);
	  else
	  {
	    (void)fprintf( stderr, NOTAILORFILE);
	    exit(-1);
	  }
	  argc--;
	  argv++;
	  break ;
	default:
	  (void)fprintf(stderr, ARGPROBLEM, *cp);
          exit(-1);
      }
    else
    {
      (void)fprintf(stderr, MEANINGLESS, cp);
      argc--;
      argv++;
    }
  }
#endif DOS

#ifndef DOS
  if (strcmp(detailfile, "") != 0)
  {
    if ((config_file = fopen(detailfile, "r")) != (FILE *) NULL) {
      while(fgets(linebuf, sizeof(linebuf), config_file) != NULLCP)
        if ((*linebuf != '#') && (*linebuf != '\n')) read_de_option(linebuf);
      (void) fclose(config_file);
      goto tailfiledone;
    }
    else {
      (void)fprintf(stderr, CANTOPENTFILE, detailfile);
      exit(-1);
    }
  }
#endif DOS

#ifndef DOS
  if ((cp = getenv("HOME")) != NULLCP)
  {
    (void) strcpy(user_file, cp);
    (void) strcat(user_file, "/.derc");
    if ((config_file = fopen(isodefile(user_file, 0), "r")) != (FILE *) NULL) {
      while(fgets(linebuf, sizeof(linebuf), config_file) != NULLCP)
        if ((*linebuf != '#') && (*linebuf != '\n')) read_de_option(linebuf);
      (void) fclose(config_file);
      goto tailfiledone;
    }
  }
#endif DOS

#ifdef DOS
  if ((config_file = fopen(isodefile("de.cfg", 0), "r")) == (FILE *) NULL) {
#else
  (void)sprintf(user_file, "%stailor", HELPFILEPREFIX);
  if ((config_file = fopen(isodefile(user_file, 0), "r")) == (FILE *) NULL) {
#endif DOS
    (void) fprintf(stderr, NODETAILOR);
  } else {
    while(fgets(linebuf, sizeof(linebuf), config_file) != NULLCP)
      if ((*linebuf != '#') && (*linebuf != '\n')) read_de_option(linebuf);
    
    (void) fclose(config_file);
  }

tailfiledone:

  if (initialiseLogging() == -1)
    (void)printf(LOGFAILCONT);

  /* we must have a surname attribute to sort personal names */
  if (attInList(atts[PERSON], DE_SURNAME) != TRUE)
    addToList(&atts[PERSON], DE_SURNAME);

  /* re-initialise department default if necessary */
  if (deptQ == FALSE)
    qinfo[ORGUNIT].defvalue[0] = '\0';

  /* if want to do signed read ops, need to check/adjust some other values */
  if (signedRead == TRUE)
  {
#ifndef FORTESTING
    if (authLevel != AUTH_STRONG)
      signedRead = FALSE;
    else
#endif
      maxPersons = 1;
  }

#ifdef DOS
  initVideo();
  _settextcolor(revfgcol);
  (void) printf("\n%*s%s\n\n", (80 - (int)strlen(welcomeMessage)) / 2, "",
                welcomeMessage);
  _settextcolor(fgcol);
#else
  (void) printf("%*s%s\n\n", (80 - (int)strlen(welcomeMessage)) / 2, "", 
                welcomeMessage);

  initVideo();
#endif DOS

#ifdef TRASH
    (void)sprintf(qosfilename, "/cs/research/pap/pink/incads/mt/qosstuff/qos.exp"); 
    de_log->ll_file = "/cs/research/pap/pink/incads/mt/qosstuff/delogfile";
#endif TRASH
    

  return OK;
}

/*
 * - read_de_option() -
 * Read in an option from detailor or derc file.
 *
 */
static void read_de_option(line)
     char *line;
{
char *part1, *part2;
extern char *deTidyString(), *SkipSpace();
int n;

  part1 = SkipSpace(line);
  
  if ((part2 = index(part1, ':')) == NULLCP) return;

  *part2++ = '\0';
  part2 = deTidyString(part2);

  if (lexequ(part1, "welcomeMessage") == 0) {
    (void) strcpy(welcomeMessage, part2);
  }
  else if (lexequ(part1, "default_country") == 0) {
    (void) strcpy(qinfo[COUNTRY].defvalue, part2);
  }
  else if (lexequ(part1, "default_org") == 0) {
    (void) strcpy(qinfo[ORG].defvalue, part2);
  }
  else if (lexequ(part1, "default_dept") == 0) {
    (void) strcpy(qinfo[ORGUNIT].defvalue, part2);
  }
#ifdef USELDAP
  else if (lexequ(part1, "ldapServer") == 0) {
    ldapServer = copy_string(part2);
  }
  else if (lexequ(part1, "ldapPort") == 0) {
    n = atoi(part2);
    if (n > 0)
      ldapPort = n;
    else
      (void)fprintf(stderr, NONNUMERICPORT, part2);
  }
#else
  else if (lexequ(part1, "dsa_address") == 0) {
    if (dsaAddFound == FALSE)
    {
      dsa_address = copy_string(part2);
      dsaAddFound = TRUE;
    }
    else if (backup_dsa_address == NULLCP)
      backup_dsa_address = copy_string(part2);
  }
/* OSISEC */
  else if (lexequ(part1, "dsa_name") == 0) {
    dsa_name = copy_string(part2);
  }
#endif USELDAP
  else if (lexequ(part1, "username") == 0) {
#ifdef USELDAP
    if (index(part2, '@') != NULLCP)
      username = quipuDN2DS23DN(part2);
    else
      username = copy_string(part2);
#else
    if (index(part2, '@') != NULLCP)
      username = copy_string(part2);
    else
      username = DS23DN2quipuDN(part2);
#endif USELDAP
  }
  else if (lexequ(part1, "password") == 0) {
    password = copy_string(part2);
  }
#ifndef DOS
  else if (lexequ(part1, "delogfile") == 0) {
#ifdef USELDAP
    logfilename = copy_string(part2);
#else
    de_log->ll_file = copy_string(part2);
#endif USELDAP
  }
#endif DOS
  else if (lexequ(part1, "deQosFile") == 0) {
    (void) strcpy(qosfilename, part2);
  }
  else if (lexequ(part1, "initialMode") == 0) {
    if (part2[0] == MENULETTER)
      initialMode = MENULETTER;
    else if (part2[0] == POWERLETTER)
      initialMode = POWERLETTER;
    else if (part2[0] == BROWSELETTER)
      initialMode = BROWSELETTER;
    else
      initialMode = SIMPLELETTER;
  }
  else if (lexequ(part1, "qos") == 0) {
    if (lexequ(part2, "off") == 0)
      qosOn = FALSE;
    else
      qosOn = TRUE;
  }
  else if (lexequ(part1, "browserAvail") == 0) {
    if (lexequ(part2, "off") == 0)
      browserAvail = FALSE;
    else
      browserAvail = TRUE;
  }
  else if (lexequ(part1, "browserPath") == 0) {
    browserPath = copy_string(part2);
  }
  else if (lexequ(part1, "byeByeMessage") == 0) {
    if (lexequ(part2, "off") == 0)
      byeByeMessage = FALSE;
    else
      byeByeMessage = TRUE;
  }
#ifndef DOS
  else if (lexequ(part1, "inverseVideo") == 0) {
    if (lexequ(part2, "off") == 0)
      preferInvVideo = FALSE;
    else
      preferInvVideo = TRUE;
  }
#endif DOS
  else if (lexequ(part1, "greyBook") == 0) {
    if (lexequ(part2, "off") == 0)
      greyBook = FALSE;
    else
      greyBook = TRUE;
  }
  else if (lexequ(part1, "browseMess") == 0) {
    if (lexequ(part2, "off") == 0)
      browseMess = FALSE;
    else
      browseMess = TRUE;
  }
  else if (lexequ(part1, "allowControlCtoQuit") == 0) {
    if (lexequ(part2, "off") == 0)
      controlCtoQuit = FALSE;
    else
      controlCtoQuit = TRUE;
  }
  else if (lexequ(part1, "wanAccess") == 0) {
    if (lexequ(part2, "off") == 0)
      wanAccess = FALSE;
    else
      wanAccess = TRUE;
  }
  else if (lexequ(part1, "deptQ") == 0) {
    if (lexequ(part2, "on") == 0)
      deptQ = TRUE;
    else
      deptQ = FALSE;
  }
  else if (lexequ(part1, "fuzzyMatching") == 0) {
    if (lexequ(part2, "on") == 0)
      fuzzyMatching = TRUE;
    else
      fuzzyMatching = FALSE;
  }
  else if (lexequ(part1, "localOrgOnly") == 0) {
    if (lexequ(part2, "on") == 0)
      localOrgOnly = TRUE;
    else
      localOrgOnly = FALSE;
  }
  else if (lexequ(part1, "searchAliasOup") == 0) {
    if (lexequ(part2, "on") == 0)
      searchAliasOup = TRUE;
    else
      searchAliasOup = FALSE;
  }
  else if (lexequ(part1, "searchAliasLo") == 0) {
    if (lexequ(part2, "on") == 0)
      searchAliasLo = TRUE;
    else
      searchAliasLo = FALSE;
  }
  else if (lexequ(part1, "ufnDNs") == 0) {
    if (lexequ(part2, "on") == 0)
      ufnDNs = TRUE;
    else
      ufnDNs = FALSE;
  }
  else if (lexequ(part1, "authLevel") == 0) {
    if (lexequ(part2, "none") == 0)
      authLevel = AUTH_NONE;
    else if (lexequ(part2, "name") == 0)
      authLevel = AUTH_NAME;
    else if (lexequ(part2, "simple") == 0)
      authLevel = AUTH_SIMPLE;
    else if (lexequ(part2, "strong") == 0)
      authLevel = AUTH_STRONG;
  }
  else if (lexequ(part1, "signedRead") == 0) {
    if (lexequ(part2, "on") == 0)
      signedRead = TRUE;
    else
      signedRead = FALSE;
  }
  else if (lexequ(part1, "country") == 0) {
    addToCoList(part2);
  }
  else if (lexequ(part1, "mapattname") == 0) {
    addToAttList(part2);
  }
  else if (lexequ(part1, "commonatt") == 0) {
    addToList(&atts[PERSON], part2);
    addToList(&atts[ORGUNIT], part2);
    addToList(&atts[ORG], part2);
  }
  else if (lexequ(part1, "orgatt") == 0) {
    addToList(&atts[ORG], part2);
  }
  else if (lexequ(part1, "ouatt") == 0) {
    addToList(&atts[ORGUNIT], part2);
  }
  else if (lexequ(part1, "prratt") == 0) {
    addToList(&atts[PERSON], part2);
  }
  else if (lexequ(part1, "ypatt") == 0) {
    addToList(&ypatts, part2);
  }
  else if (lexequ(part1, "mapphone") == 0) {
    addToPhoneList(part2);
  }
  else if (lexequ(part1, "maxPersons") == 0) {
    n = atoi(part2);
    if (n > 0)
      maxPersons = n;
  }
  else if (lexequ(part1, "minUfnNames") == 0) {
    n = atoi(part2);
    if (n > 0)
      minUfnNames = n;
  }
  else if (lexequ(part1, "maxPowerSearchOrgs") == 0) {
    n = atoi(part2);
    if (n > 0)
#ifdef POWERORGS
      if (POWERORGS > n)
#endif
        maxPowerSearchOrgs = n;
  }

  else if (lexequ(part1, "localAlarmTime") == 0) {
    n = atoi(part2);
    if (n > 0)
      localAlarmTime = n;
  }
  else if (lexequ(part1, "remoteAlarmTime") == 0) {
    n = atoi(part2);
    if (n > 0)
      remoteAlarmTime = n;
  }
  else if (lexequ(part1, "bindTimeout") == 0) {
    n = atoi(part2);
    if (n > 0)
      bindTimeout = n;
  }
  else if (lexequ(part1, "noActivityTimeout") == 0) {
    n = atoi(part2);
    if (n > 0)
      noActivityTimeout = n;
  }
  else if (lexequ(part1, "byebyeScreenTime") == 0) {
    n = atoi(part2);
    if (n > 0)
      byebyeScreenTime = n;
  }
  else if (lexequ(part1, "quitChars") == 0) {
    n = atoi(part2);
    if (n > 0)
      quitChars = n;
  }
#ifndef DOS
  else if (lexequ(part1, "logLevel") == 0) {
    deLogLevel = atoi(part2);
  }
#endif
#ifdef DOS
  else if (lexequ(part1, "textColour") == 0) {
    fgcol = (short)checkColour(part2);
  }
  else if (lexequ(part1, "boldColour") == 0) {
    revfgcol = (short)checkColour(part2);
  }
  else if (lexequ(part1, "backgroundColour") == 0) {
    bgcol = (long)checkColour(part2);
  }
#endif
} /* read_de_option */

void
welcome(filename)
char * filename;
{
FILE * welcome_file;
char linebuf[LINESIZE];
char fn[LINESIZE];
#ifdef DOS
int printing;

  (void)sprintf(fn, "%s", "de.hlp");
#else
  (void)sprintf(fn, "%s%s", HELPFILEPREFIX, filename);
#endif DOS
  if ((welcome_file = fopen(isodefile(fn, 0), "r")) == (FILE *) NULL)
    (void) fprintf(stderr, NODEWELCOME, fn);
  else 
  {
#ifdef DOS
    printing = 0;
    while(fgets(linebuf, sizeof(linebuf), welcome_file) != NULLCP) {
      if (strncmp(linebuf, "**** ", 5) == 0)
        if (printing)
          break;
        else {
          if (strncmp(&linebuf[5], filename, strlen(filename)) == 0) {
            printing = 1;
            continue;
          }
        }
      if (printing)
        (void) fputs(linebuf, stdout);
    }
    if (! printing)
      (void) fprintf(stderr, NODEWELCOME, fn);
#else
    while(fgets(linebuf, sizeof(linebuf), welcome_file) != NULLCP)
      (void) fputs(linebuf, stdout);
#endif DOS
    (void) fclose(welcome_file);
  }
}

/*
 * convert "@c=GB@o=some org@ou=some ou@cn=some name"
 * to      "cn=some name, ou=some ou, o=some org, c=GB"
 */
char *
quipuDN2DS23DN(str)
char * str;
{
  char * newstr, * savestr, * p, * p2;

  if (str == NULLCP)
    return NULLCP;
  if (*str == '\0')
    return NULLCP;

  savestr = copy_string(str);
  newstr = (char *) smalloc(strlen(str) + 256); /* The string may grow a bit
						   during conversion! */
  for (p = savestr; *p != '\0'; p++);
  *newstr = '\0';
  while (p >= savestr) {
    if (*p == '@' || p == savestr) {
      for (p2 = p; *p2 == '@' || *p2 == ' '; p2++) ;
      (void)strcat(newstr, p2);
      if (p > savestr)
	(void)strcat(newstr, ", ");
      *p = '\0';
    }
    p--;
  }
  free(savestr);
  return newstr;
}

/*
 * convert "cn=some name,ou=some ou,o=some org,c=GB"
 * to      "@c=GB@o=some org@ou=some ou@cn=some name"
 */
char *
DS23DN2quipuDN(str)
char * str;
{
  char * newstr, * savestr, * p, * p2;

  if (str == NULLCP)
    return NULLCP;
  if (*str == '\0')
    return NULLCP;

  savestr = copy_string(str);
  newstr = (char *) smalloc(strlen(str) + 256); /* The string may grow a bit
						   during conversion! */
  for (p = savestr; *p != '\0'; p++) ;
  (void)strcpy(newstr, "@");
  while (p >= savestr) {
    if (*p == ',' || p == savestr) {
      for (p2 = p; *p2 == ',' || *p2 == ' '; p2++) ;
      (void)strcat(newstr, p2);
      if (p > savestr)
	(void)strcat(newstr, "@");
      *p = '\0';
    }
    p--;
  }
  free(savestr);
  return newstr;
}

#ifdef DOS
char * Colours[] = {
  "black",
  "blue",
  "green",
  "cyan",
  "red",
  "magenta",
  "brown",
  "white",
  "darkgrey",
  "lightblue",
  "lightgreen",
  "lightcyan",
  "lightred",
  "lightmagenta",
  "yellow",
  "brightwhite"
};

int
checkColour(colour)
char * colour;
{
int i;

  for (i = 0; i < 16; i++)
    if (lexequ(colour, Colours[i]) == 0)
      return(i);
  return(32);
}
#endif

int
initialiseLogging()
{
#ifndef DOS
mode_t saveMask;

	saveMask = umask(RWRWRW_MASK);
#ifdef USELDAP
  if (logfilename == NULLCP)
    logfilename = copy_string(LOGFILENAME);

  if ((de_log = fopen(isodefile(logfilename, 0), "a")) == (FILE *)NULL)
  {
    (void)fprintf(stderr, LOGFILEPROBLEM);
    (void)umask(saveMask);
    return -1;
  }
  depid = getpid();
  (void) fprintf (de_log, "%5d:Started: \n", depid);
#else
  ll_hdinit(de_log, "de");
  (void) ll_log (de_log, LLOG_NOTICE, NULLCP, "Started: ");
#endif USELDAP
  (void)umask(saveMask);
  return 0;
#endif DOS
}
