/* isode.c
 *
 *  Some isode (like) routines which are useful to have around 
 *  Only used when de is built with USELDAP defined.
 */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/isode.c,v 9.2 1993/03/19 22:54:39 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/isode.c,v 9.2 1993/03/19 22:54:39 isode Exp isode $
 *
 *
 * $Log: isode.c,v $
 * Revision 9.2  1993/03/19  22:54:39  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.1  1992/11/12  20:05:23  awy
 * IC-1 base
 *
 */

/*
 *                                NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */
	     
#ifdef USELDAP
#ifdef DOS
#include <ctype.h>
#include "proto-de.h"
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "isomanifest.h"
/*#include "config.h"*/

char *
isodefile(filename, notused)
char * filename;
int notused;
{
static char buffer[BUFSIZ];

#ifdef DOS
char * dedir, * path, * p1, * p2;
FILE * fp;
int ended;

  if (filename == NULLCP)
    return NULLCP;
  if ((dedir = getenv("DE")) != NULLCP)
  {
    (void)sprintf(buffer, "%s/%s", dedir, filename);
    return buffer;
  }
  if ((fp = fopen(filename, "r")) != NULL)
  {
    fclose(fp);
    return filename;
  }
  if ((p1 = getenv("PATH")) == NULL)
    return NULLCP;
  path = copy_string(p1);
  p1 = p2 = path;
  ended = 0;
  while (! ended)
  {
    for ( ; *p2 != ';' && *p2 != '\0'; p2++)
      ;
    if (*p2 == '\0')
      ended = 1;
    else *p2 = '\0';
    (void)sprintf(buffer, "%s/%s", p1, filename);
    if ((fp = fopen(buffer, "r")) != NULL)
    {
      fclose(fp);
      free(path);
      return buffer;
    }
    if (! ended)
      p1 = ++p2;
  }
  free(path);
  return NULLCP;
#else
	if (filename != NULLCP)
	{
		if (*filename == '/')
			return filename;

		else
		{
	 		(void)sprintf(buffer,"%s/%s", BASENAME, filename);
			return buffer;
		}
	}
	else 
		return NULLCP;
#endif DOS
}

/* table for character conversion */

char                                   /* character conversion table   */
	chrcnv[] =                     /*   lower to upper case letters */
{
    '\0', '\1', '\2', '\3', '\4', '\5', '\6', '\7',
    '\10', '\t', '\n', '\13', '\14', '\r', '\16', '\17',
    '\20', '\21', '\22', '\23', '\24', '\25', '\26', '\27',
    '\30', '\31', '\32', '\33', '\34', '\35', '\36', '\37',
    ' ', '!', '"', '#', '$', '%', '&', '\47',
    '(', ')', '*', '+', ',', '-', '.', '/',
    '0', '1', '2', '3', '4', '5', '6', '7',
    '8', '9', ':', ';', '<', '=', '>', '?',
    '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G',
    'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
    'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W',
    'X', 'Y', 'Z', '[', '\\', ']', '^', '_',
    '`', 'A', 'B', 'C', 'D', 'E', 'F', 'G',
    'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
    'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W',
    'X', 'Y', 'Z', '{', '|', '}', '~', '\177',
    '\0', '\1', '\2', '\3', '\4', '\5', '\6', '\7',
    '\10', '\t', '\n', '\13', '\14', '\r', '\16', '\17',
    '\20', '\21', '\22', '\23', '\24', '\25', '\26', '\27',
    '\30', '\31', '\32', '\33', '\34', '\35', '\36', '\37',
    ' ', '!', '"', '#', '$', '%', '&', '\47',
    '(', ')', '*', '+', ',', '-', '.', '/',
    '0', '1', '2', '3', '4', '5', '6', '7',
    '8', '9', ':', ';', '<', '=', '>', '?',
    '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G',
    'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
    'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W',
    'X', 'Y', 'Z', '[', '\\', ']', '^', '_',
    '`', 'A', 'B', 'C', 'D', 'E', 'F', 'G',
    'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
    'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W',
    'X', 'Y', 'Z', '{', '|', '}', '~', '\177'
};

lexequ (str1, str2)
register char   *str1,
		*str2;
{
    if (str1 == NULL)
	if (str2 == NULL)
		return (0);
	else
		return (-1);

    if (str2 == NULL)
	return (1);

    while (chrcnv[*str1] == chrcnv[*str2]) {
	if (*str1++ == NULL)
	    return (0);
	str2++;
    }

    if (chrcnv[*str1] > chrcnv[*str2])
	return (1);
    else
	return (-1);
}

lexnequ (str1, str2, len)
register char   *str1,
		*str2;
int             len;
{
    register int count = 1;

    if (str1 == NULL)
	if (str2 == NULL)
		return (0);
	else
		return (1);

    if (str2 == NULL)
	return (-1);

    while (chrcnv[*str1] == chrcnv[*str2++]) {
	if (count++ >= len)
	    return (0);
	if (*str1++ == NULL)
	    return (0);
    }

    str2--;
    if (chrcnv[*str1] > chrcnv[*str2])
	return (1);
    else
	return (-1);
}

char * SkipSpace (ptr)
register char * ptr;
{
        if (ptr == NULLCP)
                return (NULLCP);
        while ( isascii(*ptr) && isspace (*ptr))
                ptr++;
        return (ptr);
}

static void default_smalloc_handler ()
{
	abort ();
}

static VFP smalloc_handler = default_smalloc_handler;

VFP set_smalloc_handler (fnx)
VFP fnx;
{
	VFP savefnx = smalloc_handler;

	if (fnx)
		smalloc_handler = fnx;
	else	smalloc_handler = default_smalloc_handler;
	return savefnx;
}

char *
smalloc(size)
int	size;
{
	register char *ptr;

	if ((ptr = (char *)malloc((unsigned) size)) == (char *)0) {
		(*smalloc_handler) ();
		_exit(1);	/* just in case */
	}

	return(ptr);
}

#endif USELDAP
