/* list.c */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/list.c,v 9.3 1993/03/19 22:54:47 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/list.c,v 9.3 1993/03/19 22:54:47 isode Exp isode $
 *
 *
 * $Log: list.c,v $
 * Revision 9.3  1993/03/19  22:54:47  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.2  1992/12/15  07:05:26  awy
 * Update and fixes
 *
 * Revision 8.1  1991/09/13  14:36:41  isode
 * PARADISE Upgrade release
 *
 * Revision 8.0  91/07/17  13:18:43  isode
 * Release 7.0
 *
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */


#ifdef DOS
#include <stdlib.h>
#include "proto-de.h"
#endif
#include <stdio.h>
#ifdef USELDAP
#include <string.h>
#ifdef IC
#include <ldap/lber.h>
#include <ldap/ldap.h>
#else
#include <lber.h>
#include <ldap.h>
#endif /* IC */
#include "isomanifest.h"
#include "demanifest.h"
#endif USELDAP
#include "util.h"
#include "namelist.h"
#ifndef USELDAP
#include "quipu/util.h"
#endif USELDAP

#ifdef USELDAP
extern char * ldap_base;
extern char ** ldap_attrs;
#endif USELDAP

void
addToList(lp, str)
struct namelist ** lp;
char *str;
{
  for (;*lp != NULLLIST; lp = &(*lp)->next) {};
  *lp = list_alloc();
  (*lp)->name = copy_string(str);
#ifdef USELDAP
  (*lp)->ats = NULLMSG;
#else
  (*lp)->ats = NULLATTR;
#endif
  (*lp)->next = NULLLIST;
  
}

attInList(lp, str)
struct namelist * lp;
char * str;
{
  for (; lp != NULLLIST; lp = lp->next)
  {
    if (strcmp(lp->name, str) == 0)
      return TRUE;
  }
  return FALSE;
}

#ifdef USELDAP

char ** makeAllAttrs(atlist)
struct namelist * atlist;
{
char **atpp, **cpp;
struct namelist * x;

        atpp = cpp = (char **) malloc(BUFSIZ);
        for (x = atlist; x != NULLLIST; x = x->next)
        {
                *cpp++ = strdup(x->name);
        }
        *cpp = NULLCP;
        return atpp;
}

#endif USELDAP

void
freeList(listpp)
struct namelist ** listpp;
{
struct namelist * x, * y;

        x = *listpp;
        while (x != NULLLIST)
        {
                if (x->name != NULLCP)
                        free(x->name);
#ifdef USELDAP
                if (x->ats) ldap_msgfree(x->ats);
#else
                as_free(x->ats);
#endif USELDAP
                y = x->next;
                free((char *) x);
                x = y;
        }
        *listpp=NULLLIST;
}

#ifdef USELDAP
freeLdapOpArgs()
{
char ** cpp;

  free (ldap_base);
  for (cpp = ldap_attrs; *cpp != NULLCP; cpp++)
    free(*cpp);
  free ((char **)ldap_attrs);
}
#endif USELDAP
