/* org.c - search for an organisation */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/org.c,v 9.3 1993/03/19 22:55:43 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/org.c,v 9.3 1993/03/19 22:55:43 isode Exp isode $
 *
 *
 * $Log: org.c,v $
 * Revision 9.3  1993/03/19  22:55:43  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.2  1992/12/15  07:05:26  awy
 * Update and fixes
 *
 * Revision 8.1  1991/09/13  14:36:41  isode
 * PARADISE Upgrade release
 *
 * Revision 8.0  91/07/17  13:18:46  isode
 * Release 7.0
 *
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */
#define org_c
#ifdef DOS
#include <stdlib.h>
#include "proto-de.h"
#endif DOS
#include "messages.h"
#include <signal.h>
#ifdef USELDAP
#include <string.h>
#ifdef IC
#include <ldap/lber.h>
#include <ldap/ldap.h>
#else
#include <lber.h>
#include <ldap.h>
#endif /* IC */
#include "isomanifest.h"
#ifdef DOS
#include <msdos.h>
#else
#include <sys/time.h>
#endif DOS
#else
#include "quipu/util.h"
#include "quipu/read.h"
#include "quipu/list.h"
#include "quipu/ds_search.h"
#include "quipu/dua.h"
#endif USELDAP
#include "demanifest.h"
#include "namelist.h"
#include "destrings.h"

#ifdef USELDAP
extern LDAP * ldap_ld;
extern char * ldap_base;
extern int ldap_scope;
extern char ldap_filter[BUFSIZ];
extern char ** ldap_attrs;
extern char ldap_attrsonly;
extern int ldap_msgid;
extern int ldap_all;
extern struct timeval ldap_timeout;
extern LDAPMessage * ldap_res;
LDAPMessage * ldap_delete_result_entry();
#else
extern char filbuf[];
extern struct ds_list_arg larg;
extern struct ds_list_result lresult;

extern struct ds_search_arg sarg;
extern struct ds_search_result sresult;
extern struct DSError serror;
#endif USELDAP

extern char mode;
extern int abandoned;
extern int highNumber;
extern int numberType;
extern int exactMatch;
extern int fuzzyMatching;
extern int gotFuzzyMatch;
extern int quipuMastersCo;
extern char exactString[];
extern int searchAliasLo;
extern char searchVal[];

extern struct namelist * atts[];

#ifdef USELDAP
void fillMostOrgListArgs();
void fillMostOrgSearchArgs();
#else
struct ds_list_arg *fillMostOrgListArgs();
struct ds_search_arg *fillMostOrgSearchArgs();
#endif USELDAP

VFP explicitOrg[] = {genExplicitFilter, NULLVFP};
VFP powerOrg[] = {genFilter3, NULLVFP};
VFP normalOrg[] = {genFilter1, genFilter3, genFilter4, NULLVFP};

int
listOrgs(cstr, ostr, olistp)
char * cstr, * ostr;
struct namelist ** olistp;
{
	return (listEntries(cstr, ostr, olistp, ORG));
}

void
printListOrgs(org, olistp)
char * org;
struct namelist * olistp;
{
struct namelist * x;
int i;

	if (olistp == NULLLIST)
		if (strcmp(org, "*") == 0)
			pageprint(NOORGSFOUND);
		else
			pageprint(NOORGSMATCH, org);
	else
	{
		for (i = 1, x = olistp; x != NULLLIST; i++, x = x->next)
			printLastComponent(INDENTON, x->name, ORG, i);
		showAnyProblems(org);
	}
}

#ifdef BUM
int
listAllOrgs(cstr, olistp)
char * cstr;
struct namelist ** olistp;
{
int ret;

	if (quipuMastersCo == FALSE)
	{
#ifdef USELDAP
		fillMostOrgListArgs(cstr);
#else
		larg = * fillMostOrgListArgs(cstr);
#endif USELDAP
		ret = reallyMakeListOrgs(olistp);
	}
	else
	{
#ifdef USELDAP
	        fillMostOrgSearchArgs(cstr, LDAP_SCOPE_ONELEVEL);
	        genAllFilter(DE_ORGANISATION);
#else
	        sarg = * fillMostOrgSearchArgs(cstr, SRA_ONELEVEL);
	        genAllFilter(DE_ORGANISATION, &sarg.sra_filter);
#endif USELDAP
	        ret = makeListOrganisations(olistp);
	}
        if (ret != OK)
		logListSuccess(LIST_ERROR, "org", 0);
	else
		logListSuccess(LIST_OK, "org", listlen(*olistp));
	if (quipuMastersCo == FALSE)
		freeListArgs();
	else
		freeSearchArgs();
	alarmCleanUp();
	return ret;
}

int
listMatchingOrgs(cstr, ostr, olistp)
char * cstr, * ostr;
struct namelist ** olistp;
{
VFP * filtarray;
VFP filterfunc;
int filtnumber;
char rstr[BUFSIZ];

        if (index(ostr, '*') != NULLCP) /* contains at least one asterisk */
	{
                filtarray = explicitOrg;
		filtnumber = -1;
	}
	else if ((mode == POWERLETTER) || (YELLOWPAGES))
	{
		filtarray = powerOrg;
		filtnumber = -1;
	}
        else
	{
                filtarray = normalOrg;
		filtnumber = 0;
	}
	if (quipuMastersCo ==FALSE) /* try read first */
	{
#ifdef USELDAP
		(void)sprintf(rstr, "o=%s, %s", ostr, cstr);
#else
		(void)sprintf(rstr, "%s@o=%s", cstr, ostr);
#endif USELDAP
		if (readExactOrg(rstr, olistp) == OK)
		{
			logReadSuccess(READ_OK, "org");		
			return OK;
		}
		else
			/* else try searches */
			logReadSuccess(READ_FAIL, "org");
	}
#ifdef USELDAP
	fillMostOrgSearchArgs(cstr, LDAP_SCOPE_ONELEVEL);
#else
	sarg = * fillMostOrgSearchArgs(cstr, SRA_ONELEVEL);
#endif USELDAP
        while ((filterfunc = *filtarray++) != NULLVFP)
	{
		filtnumber++;
#ifdef USELDAP
		filterfunc(ostr, DE_ORGANISATION,
			DE_ORGANISATION_NAME);
		if (strcmp(ldap_filter, "") == 0)
			continue;
#else
                filterfunc(ostr, DE_ORGANISATION,
			DE_ORGANISATION_NAME, &sarg.sra_filter);
		if (sarg.sra_filter == NULLFILTER)
			continue;
#endif USELDAP
                if (makeListOrganisations(olistp) != OK)
		{
			freeSearchArgs();
			logSearchSuccess(SEARCH_ERROR, "org", ostr, filtnumber, 0);
			alarmCleanUp();
			return NOTOK;
		}
                if (*olistp != NULLLIST)
                        break;
	}
	if (*olistp != NULLLIST)
		logSearchSuccess(SEARCH_OK, "org", ostr, filtnumber, listlen(*olistp));
	else
		logSearchSuccess(SEARCH_FAIL, "org", ostr, filtnumber, 0);
	freeSearchArgs();
	alarmCleanUp();
	return OK;
}

int
readExactOrg(ostr, olistp)
char * ostr;
struct namelist ** olistp;
{
int ret;

	ret = readOrg(ostr, olistp);
	alarmCleanUp();
	return ret;
}

int
reallyMakeListOrgs(olistp)
struct namelist ** olistp;
{
#ifdef USELDAP
LDAPMessage * enp;
#else
struct subordinate * x;
DN dn1, dn2;
#endif USELDAP
int retval;
char * cp;

	if (rebind() != OK)
		return NOTOK;
#ifdef USELDAP
	retval = de_list();
	/* what should happen here ??? */
#else
	retval = de_list(&larg, &serror, &lresult);
	if ((retval == DSE_INTR_ABANDONED) &&
	    (serror.dse_type == DSE_ABANDONED))
	       abandoned = TRUE;
#endif USELDAP

	/* setProblemFlags(sresult); */
	highNumber = 0;
#ifdef USELDAP
	if (ldap_count_entries(ldap_ld, ldap_res) > 0)
	    for (enp = ldap_first_entry(ldap_ld, ldap_res); enp != NULL;
				enp = ldap_next_entry(ldap_ld, enp))
	    {
		/* only add locs to the list */
		cp = ldap_get_dn(ldap_ld, enp);
		if (strncmp(cp, SHORT_ORG,
				strlen(SHORT_ORG)) == 0)
		{
			*olistp = list_alloc();
			(*olistp)->name = cp;
			(*olistp)->ats = NULLMSG;
			olistp = &(*olistp)->next;
			highNumber++;
		}
		else free(cp);
	    }
	freeLdapMsg(ldap_res);
#else
	for (x = lresult.lsr_subordinates; x != (struct subordinate *) NULL;
	                                    x = x->sub_next)
	{
		/* only add orgs to the list */
		cp = strdup(attr2name(x->sub_rdn->rdn_at, OIDPART));
		if (strcmp(cp, DE_ORGANISATION_NAME) == 0)
		{
			*olistp = list_alloc();
			dn1 = dn_cpy(larg.lsa_object);
			dn2 = dn_comp_new(x->sub_rdn);
			dn_append(dn1, dn2);
			(*olistp)->name = dn2pstr(dn1);
			(*olistp)->ats = NULLATTR;
			olistp = &(*olistp)->next;
			highNumber++;
			
		}
		free(cp);
	}
#endif USELDAP
	*olistp = NULLLIST;
#ifndef USELDAP
	/* free something */
	dn_free (lresult.lsr_object);
	/* free something else */
#endif USELDAP
	return OK;
}

int
makeListOrganisations(olistp)
struct namelist ** olistp;
{
#ifdef USELDAP
LDAPMessage * enp, * tmpenp;
#else
entrystruct * x;
#endif USELDAP
int retval;

	if (rebind() != OK)
		return NOTOK;
#ifdef USELDAP
	retval = de_search();
#else
	retval = de_search(&sarg, &serror, &sresult);
	if ((retval == DSE_INTR_ABANDONED) &&
	    (serror.dse_type == DSE_ABANDONED))
		abandoned = TRUE;
#endif USELDAP
        if (retval != OK)
                return NOTOK;
#ifdef USELDAP
	setProblemFlags(ldap_ld->ld_errno);
#else
	correlate_search_results (&sresult);

	setProblemFlags(sresult);
#endif USELDAP

	highNumber = 0;
#ifdef USELDAP
	if (ldap_count_entries(ldap_ld, ldap_res) > 0)
	    for (enp = ldap_first_entry(ldap_ld, ldap_res); enp != NULL;
				enp = tmpenp)
	    {
		tmpenp = ldap_next_entry(ldap_ld, enp);
		*olistp = list_alloc();
		(*olistp)->name = ldap_get_dn(ldap_ld, enp);
		(*olistp)->ats = ldap_delete_result_entry( &ldap_res, enp );
		olistp = &(*olistp)->next;
		highNumber++;
	    }
	freeLdapMsg(ldap_res);
#else
	for (x = sresult.CSR_entries; x != NULLENTRYINFO; x = x->ent_next) 
	{
		*olistp = list_alloc();
		(*olistp)->name = dn2pstr(x->ent_dn);
                (*olistp)->ats = as_cpy(x->ent_attr);
		olistp = &(*olistp)->next;
		highNumber++;
	}
#endif USELDAP
	*olistp = NULLLIST;
#ifndef USELDAP
	entryinfo_free(sresult.CSR_entries, 0);
	dn_free (sresult.CSR_object);
	crefs_free (sresult.CSR_cr);
	filter_free(sarg.sra_filter);
#endif USELDAP
	return OK;
}

int
readOrg(ostr, olistp)
char * ostr;
struct namelist ** olistp;
{
#ifdef USELDAP
LDAPMessage * enp;
char * cp;
#else
static struct ds_read_arg rarg;
static struct ds_read_result rresult;
static struct DSError rerror;
static CommonArgs sca = default_common_args;
Attr_Sequence * atl;
AttributeType at;
struct namelist * x;
#endif USELDAP
int retval;

	if (rebind() != OK)
		return NOTOK;
#ifdef USELDAP
	ldap_base = removeLastRDN(ostr);
	ldap_scope = LDAP_SCOPE_ONELEVEL;
	ldap_attrs = makeAllAttrs(atts[ORG]);
	ldap_attrsonly = 0;
	ldap_all = 1;
	ldap_timeout.tv_sec = 2;
	ldap_timeout.tv_usec = 0;
	(void)sprintf(ldap_filter, "(%s)", (cp = lastRDN(ostr)));
	free(cp);
	retval = de_read();
	freeLdapOpArgs();
#else
	rarg.rda_common =sca; /* struct copy */
	rarg.rda_common.ca_servicecontrol.svc_timelimit = SVC_NOTIMELIMIT;
	rarg.rda_common.ca_servicecontrol.svc_sizelimit= SVC_NOSIZELIMIT;
	rarg.rda_object = str2dn(ostr);
	/* specify attributes of interest */
	rarg.rda_eis.eis_allattributes = FALSE;
	atl = &(rarg.rda_eis.eis_select);
	for (x = atts[ORG]; x != NULLLIST; x = x->next)
	{
		if ((at = str2AttrT(x->name)) == NULLAttrT)
			continue;
		*atl = as_comp_alloc();
		(*atl)->attr_type = at;
		(*atl)->attr_value = NULLAV;
		atl = &(*atl)->attr_link;
	}
	*atl = NULLATTR;
	rarg.rda_eis.eis_infotypes = EIS_ATTRIBUTESANDVALUES;
	retval = de_read(&rarg, &rerror, &rresult, DE_UNSIGNED);
	if ((retval == DSE_INTR_ABANDONED) &&
            (rerror.dse_type == DSE_ABANDONED))
                abandoned = TRUE;
#endif USELDAP
	if (retval != OK)
	        return NOTOK;
	/* setProblemFlags(sresult); */
	highNumber = 1;	
	*olistp = list_alloc();
#ifdef USELDAP
	if (ldap_count_entries(ldap_ld, ldap_res) > 0) {
		enp = ldap_first_entry(ldap_ld, ldap_res);
		(*olistp)->name = ldap_get_dn(ldap_ld, enp);
		(*olistp)->ats = ldap_delete_result_entry( &ldap_res, enp );
	}
	else
		return NOTOK;
	freeLdapMsg(ldap_res);
#else
	(*olistp)->name = dn2pstr(rresult.rdr_entry.ent_dn);
	(*olistp)->ats = as_cpy(rresult.rdr_entry.ent_attr);
#endif USELDAP
	(*olistp)->next = NULLLIST;
	return retval;
}

#ifdef USELDAP
void
fillMostOrgListArgs(str)
char * str;
{
	ldap_base = copy_string(str);
	ldap_scope = LDAP_SCOPE_ONELEVEL;
	ldap_attrs = (char **) NULL;
	ldap_attrsonly = 1;
	ldap_all = 1;
	ldap_timeout.tv_sec = 2;
	ldap_timeout.tv_usec = 0;
	(void)sprintf(ldap_filter, "(objectclass=organization)");
}
#else
struct ds_list_arg *
fillMostOrgListArgs(str)
char * str;
{
static struct ds_list_arg arg;
static CommonArgs sca = default_common_args;

	arg.lsa_common =sca; /* struct copy */
	arg.lsa_common.ca_servicecontrol.svc_timelimit = SVC_NOTIMELIMIT;
	arg.lsa_common.ca_servicecontrol.svc_sizelimit= SVC_NOSIZELIMIT;

	arg.lsa_object = str2dn(str);
	return (&arg);
}
#endif USELDAP

#ifdef USELDAP
void
fillMostOrgSearchArgs(cstr, searchdepth)
char * cstr;
int searchdepth;
{
	ldap_base = copy_string(cstr);
	ldap_scope = searchdepth;
	ldap_attrs = makeAllAttrs(atts[ORG]);
	ldap_attrsonly = 0;
	ldap_all = 1;
	ldap_timeout.tv_sec = 2;
	ldap_timeout.tv_usec = 0;
}
#else
struct ds_search_arg *
fillMostOrgSearchArgs(cstr, searchdepth)
char * cstr;
int searchdepth;
{
static struct ds_search_arg arg;
Attr_Sequence * atl;
AttributeType at;
struct namelist * x;
static CommonArgs sca = default_common_args;

	arg.sra_common = sca; /* struct copy */
        arg.sra_common.ca_servicecontrol.svc_timelimit = SVC_NOTIMELIMIT;
        arg.sra_common.ca_servicecontrol.svc_sizelimit= SVC_NOSIZELIMIT;

	arg.sra_subset = searchdepth;
	if (strcmp(cstr, "root") == 0)
		arg.sra_baseobject = NULLDN;
	else
		arg.sra_baseobject = str2dn(cstr);
	arg.sra_searchaliases = searchAliasLo;
	/* specify attributes of interest */
	arg.sra_eis.eis_allattributes = FALSE;
	atl = &(arg.sra_eis.eis_select);
	for (x = atts[ORG]; x != NULLLIST; x = x->next)
	{
		if ((at = str2AttrT(x->name)) == NULLAttrT)
			continue;
		*atl = as_comp_alloc();
		(*atl)->attr_type = at;
		(*atl)->attr_value = NULLAV;
		atl = &(*atl)->attr_link;
	}
	*atl = NULLATTR;
	arg.sra_eis.eis_infotypes = EIS_ATTRIBUTESANDVALUES;
	return (&arg);
}
#endif USELDAP

#endif BUM
