/* ou.c - search for an org unit */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/ou.c,v 9.3 1993/03/19 22:55:47 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/ou.c,v 9.3 1993/03/19 22:55:47 isode Exp isode $
 *
 *
 * $Log: ou.c,v $
 * Revision 9.3  1993/03/19  22:55:47  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.2  1992/12/15  07:05:26  awy
 * Update and fixes
 *
 * Revision 8.1  1991/09/13  14:36:41  isode
 * PARADISE Upgrade release
 *
 * Revision 8.0  91/07/17  13:18:47  isode
 * Release 7.0
 *
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#define ou_c
#ifdef DOS
#include <stdlib.h>
#include "proto-de.h"
#endif DOS
#include "messages.h"
#include <signal.h>
#ifdef USELDAP
#include <string.h>
#ifdef IC
#include <ldap/lber.h>
#include <ldap/ldap.h>
#else
#include <lber.h>
#include <ldap.h>
#endif /* IC */
#include "isomanifest.h"
#ifdef DOS
#include <msdos.h>
#else
#include <sys/time.h>
#endif DOS
#else
#include "quipu/util.h"
#include "quipu/read.h"
#include "quipu/list.h"
#include "quipu/ds_search.h"
#include "quipu/dua.h"
#endif USELDAP
#include "demanifest.h"
#include "namelist.h"
#include "destrings.h"

#ifdef USELDAP
extern LDAP * ldap_ld;
extern char * ldap_base;
extern int ldap_scope;
extern char ldap_filter[BUFSIZ];
extern char ** ldap_attrs;
extern char ldap_attrsonly;
extern int ldap_msgid;
extern int ldap_all;
extern struct timeval ldap_timeout;
extern LDAPMessage * ldap_res;
LDAPMessage * ldap_delete_result_entry();
#else
extern char filbuf[];
extern struct ds_list_arg larg;
extern struct ds_list_result lresult;

extern struct ds_search_arg sarg;
extern struct ds_search_result sresult;
extern struct DSError serror;
#endif USELDAP

extern char mode;
extern int abandoned;
extern int highNumber;
extern int exactMatch;
extern int fuzzyMatching;
extern int gotFuzzyMatch;
extern int quipuMastersCo;
extern char exactString[];
extern int searchAliasOup;
extern char searchVal[];

extern struct namelist * atts[];

#ifdef USELDAP
void fillMostOUListArgs();
void fillMostOUSearchArgs();
#else
struct ds_list_arg *fillMostOUListArgs();
struct ds_search_arg *fillMostOUSearchArgs();
#endif USELDAP

VFP explicitOU[] = {genExplicitFilter, NULLVFP};
VFP normalOU[] = {genFilter1, genFilter2, genFilter3, genFilter4, NULLVFP};

int
listOUs(parentstr, thisstr, listp)
char * parentstr, * thisstr;
struct namelist ** listp;
{
	return (listEntries(parentstr, thisstr, listp, ORGUNIT));
}

void
printListOUs(str, listp)
char * str;
struct namelist * listp;
{
struct namelist * x;
int i;
	if (listp == NULLLIST)
		if (strcmp(str, "*") == 0)
			pageprint(NOOUSFOUND);
		else
			pageprint(NOOUSMATCH, str);
	else
	{
		for (i =1, x = listp; x != NULLLIST; i++, x = x->next)
			printLastComponent(INDENTON, x->name, ORGUNIT, i);
		showAnyProblems(str);
	}
}

#ifdef DOS
void
#else
int
#endif
powerSearchOUs(parentstr, thisstr, opp)
char * parentstr, * thisstr;
int * opp;
{
   if (rebind() != OK)
     return NOTOK;
   clearProblemFlags();
#ifdef USELDAP
   fillMostSearchArgs(parentstr, LDAP_SCOPE_SUBTREE, ORGUNIT);
   if (strlen(thisstr) <= 3)
     genFilter1(thisstr, DE_ORGANISATIONAL_UNIT, 
     	DE_ORGANISATIONAL_UNIT_NAME); /* ou=foo */
   else
     genFilter3(thisstr, DE_ORGANISATIONAL_UNIT, 
     	DE_ORGANISATIONAL_UNIT_NAME); /* ou=*foo* */
   (void)de_asynSearch(opp); /* opp contains opno value */
#else
   sarg = * fillMostSearchArgs(parentstr, SRA_WHOLESUBTREE, ORGUNIT);
   if (strlen(thisstr) <= 3)
     genFilter1(thisstr, DE_ORGANISATIONAL_UNIT, DE_ORGANISATIONAL_UNIT_NAME,
     	&sarg.sra_filter); /* ou=foo */
   else
     genFilter3(thisstr, DE_ORGANISATIONAL_UNIT, DE_ORGANISATIONAL_UNIT_NAME,
     	&sarg.sra_filter); /* ou=*foo* */
   (void)de_asynSearch(&sarg, &serror, opp); /* opp contains opno value */
   filter_free(sarg.sra_filter);
#endif USELDAP
   freeSearchArgs();
   return;
}
