/* pager.c */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/pager.c,v 9.3 1993/03/19 22:55:51 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/pager.c,v 9.3 1993/03/19 22:55:51 isode Exp isode $
 *
 *
 * $Log: pager.c,v $
 * Revision 9.3  1993/03/19  22:55:51  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.2  1992/12/15  07:05:26  awy
 * Update and fixes
 *
 * Revision 8.1  1991/09/13  14:36:41  isode
 * PARADISE Upgrade release
 *
 * Revision 8.0  91/07/17  13:18:48  isode
 * Release 7.0
 *
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#define pager_c
#ifdef DOS
#include <stdlib.h>
#include "proto-de.h"
#include <ctype.h>
#include <conio.h>
#include <graph.h>
#endif DOS
#include "messages.h"
#include <stdio.h>
#include <varargs.h>
#ifdef DOS
#include <msdos.h>
#else
#include <sys/types.h>
#include <termios.h>
#endif DOS
#ifdef USELDAP
#include "isomanifest.h"
#else
#include "quipu/util.h"
#endif USELDAP
#include "demanifest.h"
#ifdef DOS
#undef putchar
#define putchar(c) gputchar(c)
#endif DOS

extern int lines, cols;

static int redisplay = FALSE;
static int numOK;
static int pagerNumber = -1;
static int wrapLines = FALSE;

int lineno;
int discardInput;

void
initPage()
{
  lineno = 0;
}

quitPager()
{
  return discardInput;
}

testRedisplay()
{
  if (redisplay)
    return TRUE;
  else
    return FALSE;
}

void
setRedisplay()
{
  redisplay = TRUE;
}

void
pagerOn(number)
int number;
{
  lineno = 0;
  discardInput = FALSE;
  pagerNumber = -1;
  if (number == NUMBER_ALLOWED)
    numOK = TRUE;
  else
    numOK = FALSE;
}

void
linewrapOn()
{
  wrapLines = TRUE;
}

void
linewrapOff()
{
  wrapLines = FALSE;
}

isWrapOn()
{ 
  return wrapLines;
}

void
resetprint(va_alist)
va_dcl
{
va_list ap;
char buf[BUFSIZ];
#ifdef USELDAP
char *fmt;
#endif USELDAP

  va_start (ap);
#ifdef USELDAP
  fmt = va_arg(ap, char *);
  vsprintf (buf, fmt, ap);
#else
  _asprintf (buf, NULLCP, ap);
#endif USELDAP
#ifdef DOS
    _outtext(buf);
#else
  (void) fputs(buf, stdout);
#endif DOS
  pagerOn(numOK);
  redisplay = TRUE;
  va_end(ap);
}

void
pageprint(va_alist)
va_dcl /* no ; */
{
va_list ap;
char buf[BUFSIZ];
int i, c;
static int charsInLine = 0;
#ifdef USELDAP
char *fmt;
#endif USELDAP

  va_start (ap);
  redisplay = FALSE;
  if (discardInput == TRUE)
    return;
#ifdef USELDAP
  fmt = va_arg(ap, char *);
  vsprintf (buf, fmt, ap);
#else
  _asprintf (buf, NULLCP, ap);
#endif USELDAP
  for (i = 0; buf[i] != '\0'; i++)
  {
    if (buf[i] == '\n')
    {
      charsInLine = 0;
      (void) putchar(buf[i]);
      lineno++;
      if (lineno >= lines - 1)
      {
        putPagePrompt();
        c = getPagerInput();
        switch(c)
        {
          case '\n':
	    lineno--;
	    break;
          case ' ':
	    lineno = 1;
	    break;
	  default:
	    break;
        }
#ifndef DOS
	if ((pagerNumber == -1) && ((c == VEOF) || (c == VKILL)))
	  (void) kill(getpid(), 2); /* let the signal handling sort it out */
#endif DOS
        if (((pagerNumber == -1)&& (c == QUITCHAR)) || (pagerNumber != -1))
	{
	  discardInput = TRUE;
	  break;
	}
      }
    }
    else
      /* optionally discard chars that would cause line wrapping */
      if (isWrapOn() ||
         (charsInLine < (cols - 1))) 
      {
        (void) putchar(buf[i]);
	if (buf[i] == '\b')
	  charsInLine--;
	else
	  charsInLine++;
	if (isWrapOn())
	{
	  if (charsInLine == cols)
	  {
	    charsInLine = 0;
	    lineno++;
	  }
	}
      }
  }
  va_end(ap);
}

#ifdef DOS
void
#endif DOS
putPagePrompt()
{
char buf[BUFSIZ];

    (void)sprintf(buf, PROMPT1, QUITCHAR);
    writeInverse(buf);
    if (numOK == TRUE)
      writeInverse(PROMPT2);
    writeInverse(": ");
}

int
getPagerInput()
{
int c, i;
char numstr[LINESIZE];

  pagerNumber = -1;
#ifndef DOS
  setRawMode();
#endif DOS
  c = 'Z';
#ifdef DOS
  while (! ((c == QUITCHAR) || (c == ' ') || (c == '\n') ))
#else
  while (! ((c == QUITCHAR) || (c == ' ') || (c == '\n') 
                       || (c == VKILL) || (c == VEOF)))
#endif DOS
  {
    if ((numOK == TRUE) && isdigit(c))
    {
      for (i = 0; isdigit(c);i++)
      {
        (void) putchar(c);
        numstr[i] = c;
#ifdef DOS
        c = _getch();
#else
	c = getchar();
#endif DOS
      }
      if (c == '\n')
      {
        numstr[i] = '\0';
        c = pagerNumber = atoi(numstr);
	break;
      }
      else
      {
        clearLine();
	putPagePrompt();
#ifdef DOS
        c = _getch();
#else
        c = getchar();
#endif DOS
        continue;
      }
    }
    else
#ifdef DOS
      c = _getch();
#else
      c = getchar();
#endif DOS
  }
#ifndef DOS
  unsetRawMode();
#endif DOS
  clearLine();
  return c;
}

int
getpnum()
{
  return pagerNumber;
}
