/* people.c - search for a person 
   This file still needs a lot more work to align it with the routines in 
   generic.c */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/people.c,v 9.3 1993/03/19 22:55:55 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/people.c,v 9.3 1993/03/19 22:55:55 isode Exp isode $
 *
 *
 * $Log: people.c,v $
 * Revision 9.3  1993/03/19  22:55:55  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.2  1992/12/15  07:05:26  awy
 * Update and fixes
 *
 * Revision 8.1  1991/09/13  14:36:41  isode
 * PARADISE Upgrade release
 *
 * Revision 8.0  91/07/17  13:18:48  isode
 * Release 7.0
 *
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#define people_c
#ifdef DOS
#include <stdlib.h>
#include "proto-de.h"
#endif
#include "messages.h"
#include <signal.h>
#ifdef USELDAP
#include <string.h>
#ifdef IC
#include <ldap/lber.h>
#include <ldap/ldap.h>
#else
#include <lber.h>
#include <ldap.h>
#endif /* IC */
#include "isomanifest.h"
#ifdef DOS
#include <msdos.h>
#else
#include <sys/time.h>
#endif DOS
#else
#include "quipu/util.h"
#include "quipu/ds_search.h"
#include "quipu/read.h"
#include "quipu/dua.h"
#endif USELDAP
#include "demanifest.h"
#include "namelist.h"
#include "destrings.h"
#include "asyn.h"

#ifdef USELDAP
extern LDAP * ldap_ld;
extern char * ldap_base;
extern int ldap_scope;
extern char ldap_filter[BUFSIZ];
extern char ** ldap_attrs;
extern char ldap_attrsonly;
extern int ldap_msgid;
extern int ldap_all;
extern struct timeval ldap_timeout;
extern LDAPMessage * ldap_res;
LDAPMessage * ldap_delete_result_entry();
#else
extern char filbuf[LINESIZE];
extern struct ds_search_arg sarg;
extern struct ds_search_result sresult;
extern struct DSError serror;
#endif USELDAP

extern char mode;
extern int abandoned;
extern int accessrightproblem;
extern int highNumber;
extern int exactMatch;
extern int fuzzyMatching;
extern int gotFuzzyMatch;
extern char exactString[];
extern int searchAliasOup;
extern char searchVal[];

/* PRR stands fpr people, rooms and roles */

extern struct namelist * atts[];

#ifndef USELDAP
Filter get_filter();
#endif USELDAP

void makeExplicitPRRFilter();
void prrFilter1(), prrFilter2(), prrFilter3(), prrFilter4();
void exactSurname(), makeAllPFilter(), makeRequestedFilter();

VFP explicitPRR[] = {makeExplicitPRRFilter, NULLVFP};
VFP normalPRR[] = {prrFilter1, prrFilter2, prrFilter3, prrFilter4, NULLVFP};
/*VFP normalPRR[] = {prrFilter1, prrFilter3, NULLVFP};*/

int
listPRRs(parentstr, thisstr, listp)
char * parentstr, * thisstr;
struct namelist ** listp;
{
int ret;

	(void)strcpy(searchVal, thisstr);
	clearProblemFlags();
	initAlarm();	
	if (exactMatch == PERSON)
	  return (readExactPRR(exactString, listp));
        if (strcmp(thisstr, "*") == 0)
          ret = listAllPRRs(parentstr, listp);
        else
          ret = listMatchingPRRs(parentstr, thisstr, listp);
#ifndef DOS
	sortList(PERSON, listp, parentstr);
#endif DOS
	return ret;
}

void
printListPRRs(str, listp, searchparent, pdet, fromNumber)
char * str;
struct namelist * listp;
int searchparent, pdet, fromNumber;
{
struct namelist * x;
char * savestr, * cp;
static char lastsavedcomp[LINESIZE], saveOrgName[LINESIZE];
int i;

	saveOrgName[0] = '\0';
	if (listp == NULLLIST)
		if (strcmp(str, "*") == 0)
			pageprint(NOPEOPLEFOUND);
		else
			pageprint(NOPEOPLEMATCH);
	else
	{
		for (i = fromNumber + 1, x = listp; x != NULLLIST; i++, x = x->next)
		{
		 	if ((mode == POWERLETTER) || (mode == YELLOWPAGES))
			{
			  if (strcmp((cp = orgNameFromDN(x->name, 0)), saveOrgName) != 0)
			  {
			    free(cp);
			    (void)strcpy(saveOrgName, (cp = orgNameFromDN(x->name, 0)));
			    free(cp);
			    printLastComponent(INDENTON, saveOrgName, ORG, 0);
			  }
			  else
			    free(cp);
			}
			/* if searching subtree under org (as opposed to an
			   org unit), print ou if there is one */
			if (searchparent == ORG)
			{
				savestr = removeLastRDN(x->name);
#ifdef USELDAP
                                if (index(savestr, ',') != rindex(savestr, ','))
                                {
                                    if (strncmp(savestr,
                                          SHORT_OU, strlen(SHORT_OU)) == 0)
#else
				if (index(savestr, '@') != rindex(savestr, '@'))
				{
				    if (strncmp((rindex(savestr, '@') + 1), 
				          SHORT_OU, strlen(SHORT_OU)) == 0)
#endif USELDAP
					if (strcmp(lastsavedcomp, savestr) != 0)
					{
						printLastComponent(INDENTON, savestr, ORGUNIT, 0);
						(void) strcpy(lastsavedcomp, savestr);
					}
				}
				free (savestr);
			}
			if (pdet)
			{
				printLastComponent(INDENTON, x->name, PERSON,
 							pdet ? 0 : i);
				printDetails(PERSON, x);
			}
			else
				printPersonOneLiner(x, i);
		}
		if (mode == SIMPLELETTER)
			showAnyProblems(str);
	}
	lastsavedcomp[0] = '\0';
}


int
listAllPRRs(parentstr, listp)
char * parentstr;
struct namelist ** listp;
{
int ret;
	
#ifdef USELDAP
        fillMostSearchArgs(parentstr, LDAP_SCOPE_SUBTREE, PERSON);
        makeAllPRRFilter();
#else
        sarg = * fillMostSearchArgs(parentstr, SRA_WHOLESUBTREE, PERSON);
        makeAllPRRFilter(&sarg.sra_filter);
#endif USELDAP
        ret = makeListPRRs(listp, parentstr);
	if (ret != OK)
		logListSuccess2(LIST_ERROR, PERSON, 0);
	else
		logListSuccess2(LIST_OK, PERSON, listlen(*listp));
	freeSearchArgs();
	alarmCleanUp();
	return ret;
}

#ifdef DOS
void
#else
int
#endif DOS
powerSearchPeople(parentstr, thisstr, opp)
char * parentstr, * thisstr;
int * opp;
{
   if (rebind() != OK)
     return NOTOK;

   clearProblemFlags();
#ifdef USELDAP
   fillMostSearchArgs(parentstr, LDAP_SCOPE_SUBTREE, PERSON);
   if (strcmp(thisstr, "*") == 0)
     makeAllPFilter(); /* sn=* */
   else if (index(thisstr, '=') != 0)
     makeRequestedFilter(thisstr);
   else if (index(thisstr, '*') != 0)
     makeExplicitPRRFilter(thisstr);
   else if (index(thisstr, ' ') == 0)
     exactSurname(thisstr); /* sn=foo */
   else
     prrFilter2(thisstr); /* cn=f*bar */
   (void)de_asynSearch(opp); /* opp contains opno value */
#else
   sarg = * fillMostSearchArgs(parentstr, SRA_WHOLESUBTREE, PERSON);
   if (strcmp(thisstr, "*") == 0)
     makeAllPFilter(&sarg.sra_filter); /* sn=* */
   else if (index(thisstr, '=') != 0)
     makeRequestedFilter(thisstr, &sarg.sra_filter);
   else if (index(thisstr, '*') != 0)
     makeExplicitPRRFilter(thisstr, &sarg.sra_filter);
   else if (index(thisstr, ' ') == 0)
     exactSurname(thisstr, &sarg.sra_filter); /* sn=foo */
   else
     prrFilter2(thisstr, &sarg.sra_filter); /* cn=f*bar */
   (void)de_asynSearch(&sarg, &serror, opp); /* opp contains opno value */
   filter_free(sarg.sra_filter);
#endif USELDAP
   freeSearchArgs();
   return;
}

int
listMatchingPRRs(parentstr, thisstr, listp)
char * parentstr, * thisstr;
struct namelist ** listp;
{
VFP * filtarray;
VFP filterfunc;
int filtnumber;

        if (index(thisstr, '*') != NULLCP) /* contains at least one asterisk */
	{
                filtarray = explicitPRR;
		filtnumber = -1;
	}
        else
	{
                filtarray = normalPRR;
		filtnumber = 0;
	}
#ifdef USELDAP
	fillMostSearchArgs(parentstr, LDAP_SCOPE_SUBTREE, PERSON);
#else
	sarg = * fillMostSearchArgs(parentstr, SRA_WHOLESUBTREE, PERSON);
#endif USELDAP
        while ((filterfunc = *filtarray++) != NULLVFP)
	{
		filtnumber++;
#ifdef USELDAP
                filterfunc(thisstr);
		if (strcmp(ldap_filter, "") == 0)
			continue;
#else
                filterfunc(thisstr, &sarg.sra_filter);
		if (sarg.sra_filter == NULLFILTER)
			continue;
#endif USELDAP
                if (makeListPRRs(listp, parentstr) != OK)
		{
			freeSearchArgs();
			logSearchSuccess2(SEARCH_ERROR, PERSON, thisstr, filtnumber, 0);
			alarmCleanUp();
		        return NOTOK;
		}
                if (*listp != NULLLIST)
                        break;
	}
	if (*listp != NULLLIST)
		logSearchSuccess2(SEARCH_OK, PERSON, thisstr, filtnumber, listlen(*listp));
	else
		logSearchSuccess2(SEARCH_FAIL, PERSON, thisstr, filtnumber, 0);
	freeSearchArgs();
	alarmCleanUp();
	return OK;
}

int
signedReadPRR(objectstr, listp)
char * objectstr;
struct namelist ** listp;
{
int ret;

        clearProblemFlags();
        initAlarm();
	suppressSearchMess();
#if (OSISEC2 && IC)
	ret = readPerson(objectstr, listp, DE_SIGNED);
#else
	ret = readPerson(objectstr, listp);
#endif
	alarmCleanUp();
	return ret;
}

int
readExactPRR(objectstr, listp)
char * objectstr;
struct namelist ** listp;
{
int ret;

#if (OSISEC2 && IC)
        ret = readPerson(objectstr, listp, DE_UNSIGNED);
#else
	ret = readPerson(objectstr, listp);
#endif
	alarmCleanUp();
	return ret;
}

/* needs combining with makeListPRRs */
int
makeListForOneOrg(opid)
int * opid;
{
int ret;
struct namelist ** listp;
struct opsPending * oplp;
char *cp, *cp2;
#ifdef USELDAP
LDAPMessage * enp, * tmpenp;
char *cp3;
#else
entrystruct * x;
#endif USELDAP

#ifdef USELDAP
  ret = waitSearchResponse(opid);
#else
  ret = waitSearchResponse(&serror, &sresult, opid);
#endif USELDAP
  if (ret != OK)
    return ret;
  oplp = findOp(*opid);
  listp = & oplp->lp;
#ifdef USELDAP
  /* we want to build the list so that any people with no ou
   come first */
  if (ldap_count_entries(ldap_ld, ldap_res) > 0)
    for (enp = ldap_first_entry(ldap_ld, ldap_res); enp != NULL;
        enp = tmpenp)
  {
    tmpenp = ldap_next_entry(ldap_ld, enp);
    cp = ldap_get_dn(ldap_ld, enp);
    cp2 = removeLastRDN(cp);
    if (strncmp((cp3 = lastRDN(cp2)), SHORT_OU, strlen(SHORT_OU)) != 0)
    {
      *listp = list_alloc();
      (*listp)->name = cp;
      (*listp)->ats = ldap_delete_result_entry( &ldap_res, enp );
      listp = &(*listp)->next;
    }
    else
      free(cp);
    free(cp2);
    free(cp3);
  }
  if (ldap_count_entries(ldap_ld, ldap_res) > 0)
    for (enp = ldap_first_entry(ldap_ld, ldap_res); enp != NULL;
        enp = tmpenp)
  {
    tmpenp = ldap_next_entry(ldap_ld, enp);
    cp = ldap_get_dn(ldap_ld, enp);
    cp2 = removeLastRDN(cp);
    if (strncmp((cp3 = lastRDN(cp2)), SHORT_OU, strlen(SHORT_OU)) == 0)
    {
      *listp = list_alloc();
      (*listp)->name = cp;
      (*listp)->ats = ldap_delete_result_entry( &ldap_res, enp );
      listp = &(*listp)->next;
    }
    else
      free(cp);
    free(cp2);
    free(cp3);
  }
  freeLdapMsg(ldap_res);
#else
  correlate_search_results (&sresult);
  /* we want to build the list so that any people with no ou
   come first */
  for (x = sresult.CSR_entries; x != NULLENTRYINFO; x = x->ent_next)
  {
     cp = dn2pstr(x->ent_dn);
     cp2 = removeLastRDN(cp);
     if (strncmp(lastRDN(cp2), SHORT_OU, strlen(SHORT_OU)) != 0)
     {
       *listp = list_alloc();
       (*listp)->name = cp;
       (*listp)->ats = as_cpy(x->ent_attr);
       listp = &(*listp)->next;
     }
     else
       free(cp);
     free(cp2);
  }
  for (x = sresult.CSR_entries; x != NULLENTRYINFO; x = x->ent_next)
  {
    cp = dn2pstr(x->ent_dn);
    cp2 = removeLastRDN(cp);
    if (strncmp(lastRDN(cp2), SHORT_OU, strlen(SHORT_OU)) == 0)
    {
      *listp = list_alloc();
      (*listp)->name = cp;
      (*listp)->ats = as_cpy(x->ent_attr);
      listp = &(*listp)->next;
    }
    else
      free(cp);
    free(cp2);
  }
#endif USELDAP
  *listp = NULLLIST;
#ifndef USELDAP
  entryinfo_free(sresult.CSR_entries,0);
  dn_free (sresult.CSR_object);
  crefs_free (sresult.CSR_cr);
#endif USELDAP
    return OK;
}

int
makeListPRRs(listp, parentstr)
struct namelist ** listp;
char * parentstr;
{
int retval;
char *cp, *cp2, *cp3;
#ifdef USELDAP
char * cp4;
LDAPMessage * enp, * tmpenp;
#else
entrystruct * x;
#endif USELDAP

	if (rebind() != OK)
		return NOTOK;
#ifdef USELDAP
	retval = de_search();
#else
	retval = de_search(&sarg, &serror, &sresult);
	if (retval == DSE_INTR_ABANDONED) 
	  if (serror.dse_type == DSE_ABANDONED)
		abandoned = TRUE;
	  else if (serror.dse_type == DSE_SECURITYERROR)
	        accessrightproblem = TRUE;
#endif USELDAP
	if (retval != OK)
		return NOTOK;
#ifdef USELDAP
	setProblemFlags(ldap_ld->ld_errno);
#else
	correlate_search_results (&sresult);

	setProblemFlags(sresult);
#endif USELDAP

	highNumber = 0;
	if (strncmp((cp3 = lastRDN(parentstr)), SHORT_OU, strlen(SHORT_OU)) != 0)
	{
		/* we want to build the list so that any people with no ou 
		   come first */
#ifdef USELDAP
		if (ldap_count_entries(ldap_ld, ldap_res) > 0)
			for (enp = ldap_first_entry(ldap_ld, ldap_res);
				enp != NULL;enp = tmpenp)
		{
			tmpenp = ldap_next_entry(ldap_ld, enp);
			cp = ldap_get_dn(ldap_ld, enp);
			cp2 = removeLastRDN(cp);
			if (strncmp((cp4 = lastRDN(cp2)), SHORT_OU, strlen(SHORT_OU)) != 0)
			{
				*listp = list_alloc();
				(*listp)->name = cp;
				(*listp)->ats = ldap_delete_result_entry( &ldap_res, enp );
				listp = &(*listp)->next;
				highNumber++;
			}
			else
				free(cp);
			free(cp2);
			free(cp4);
		}
		if (ldap_count_entries(ldap_ld, ldap_res) > 0)
			for (enp = ldap_first_entry(ldap_ld, ldap_res);
				enp != NULL;enp = tmpenp)
		{
			tmpenp = ldap_next_entry(ldap_ld, enp);
			cp = ldap_get_dn(ldap_ld, enp);
			cp2 = removeLastRDN(cp);
			if (strncmp((cp4 = lastRDN(cp2)), SHORT_OU, strlen(SHORT_OU)) == 0)
			{
				*listp = list_alloc();
				(*listp)->name = cp;
				(*listp)->ats = ldap_delete_result_entry( &ldap_res, enp );
				listp = &(*listp)->next;
				highNumber++;
			}
			else
				free(cp);
			free(cp2);
			free(cp4);
		}
		freeLdapMsg(ldap_res);
#else
		for (x = sresult.CSR_entries; x != NULLENTRYINFO; x = x->ent_next)
		{
			cp = dn2pstr(x->ent_dn);
			cp2 = removeLastRDN(cp);
			if (strncmp(lastRDN(cp2), SHORT_OU, strlen(SHORT_OU)) != 0)
			{
				*listp = list_alloc();
				(*listp)->name = cp;
				(*listp)->ats = as_cpy(x->ent_attr);
				listp = &(*listp)->next;
				highNumber++;
			}
			else
				free(cp);
			free(cp2);
		}
		for (x = sresult.CSR_entries; x != NULLENTRYINFO; x = x->ent_next)
		{
			cp = dn2pstr(x->ent_dn);
			cp2 = removeLastRDN(cp);
			if (strncmp(lastRDN(cp2), SHORT_OU, strlen(SHORT_OU)) == 0)
			{
				*listp = list_alloc();
				(*listp)->name = cp;
				(*listp)->ats = as_cpy(x->ent_attr);
				listp = &(*listp)->next;
				highNumber++;
			}
			else
				free(cp);
			free(cp2);
		}
#endif USELDAP
	}
	else
	{
#ifdef USELDAP
		if (ldap_count_entries(ldap_ld, ldap_res) > 0)
			for (enp = ldap_first_entry(ldap_ld, ldap_res);
				enp != NULL;enp = tmpenp)
		{
			tmpenp = ldap_next_entry(ldap_ld, enp);
			*listp = list_alloc();
			(*listp)->name = ldap_get_dn(ldap_ld, enp);
			(*listp)->ats = ldap_delete_result_entry( &ldap_res, enp );
			listp = &(*listp)->next;
			highNumber++;
		}
		freeLdapMsg(ldap_res);
#else
		for (x = sresult.CSR_entries; x != NULLENTRYINFO; x = x->ent_next)
		{
			*listp = list_alloc();
			(*listp)->name = dn2pstr(x->ent_dn);
			(*listp)->ats = as_cpy(x->ent_attr);
			listp = &(*listp)->next;
			highNumber++;
		}
#endif USELDAP
	}
	*listp = NULLLIST;
#ifdef USELDAP
	free(cp3);
#endif USELDAP
#ifndef USELDAP
	entryinfo_free(sresult.CSR_entries,0);
	dn_free (sresult.CSR_object);
	crefs_free (sresult.CSR_cr);
	filter_free(sarg.sra_filter);
#endif USELDAP
        return OK;
}

int
#if (OSISEC2 && IC)
readPerson(pstr, plistp, Signed)
#else
readPerson(pstr, plistp)
#endif
char * pstr;
struct namelist ** plistp;
#if (OSISEC2 && IC)
int Signed;
#endif

{
#ifdef USELDAP
LDAPMessage * enp, * tmpenp;
char * cp;
#else
static struct ds_read_arg rarg;
static struct ds_read_result rresult;
static struct DSError rerror;
/* static CommonArgs sca = default_common_args; */
#endif USELDAP
int retval;

	if (rebind() != OK)
		return NOTOK;
#ifdef USELDAP
	fillMostReadArgs(pstr, PERSON);
	retval = de_read();
	freeLdapOpArgs();
#else
#if (OSISEC2 && IC)
	rarg = * fillMostReadArgs(pstr, PERSON, Signed);
	retval = de_read(&rarg, &rerror, &rresult, Signed);
#else
	rarg = * fillMostReadArgs(pstr, PERSON, DE_UNSIGNED);
	retval = de_read(&rarg, &rerror, &rresult);
#endif

	if ((retval == DSE_INTR_ABANDONED) &&
            (rerror.dse_type == DSE_ABANDONED))
                abandoned = TRUE;
#endif USELDAP
	if (retval != OK)
	        return NOTOK;
	/* setProblemFlags(sresult); */
	highNumber = 1;	
	*plistp = list_alloc();
#ifdef USELDAP
	if (ldap_count_entries(ldap_ld, ldap_res) > 0) {
		enp = ldap_first_entry(ldap_ld, ldap_res);
		(*plistp)->name = ldap_get_dn(ldap_ld, enp);
		(*plistp)->ats = ldap_delete_result_entry( &ldap_res, enp );
	}
	else
		return NOTOK;
	freeLdapMsg(ldap_res);
#else
	(*plistp)->name = dn2pstr(rresult.rdr_entry.ent_dn);
	(*plistp)->ats = as_cpy(rresult.rdr_entry.ent_attr);
#endif USELDAP
	(*plistp)->next = NULLLIST;
	return retval;
}

#ifdef USELDAP
#ifdef DOS
void
#endif DOS
makeAllPRRFilter()
{
	gotFuzzyMatch = FALSE;
        (void)strcpy(ldap_filter, "(|(sn=*)(objectclass=organizationalRole)");
        (void)sprintf(ldap_filter, "%s(objectclass=room))", ldap_filter);
}
#else
makeAllPRRFilter(fpp)
struct s_filter ** fpp;
{
        gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "(%s=*) | (%s=%s) |(%s=%s)", DE_SURNAME,
		DE_OBJECT_CLASS, DE_ROLE, DE_OBJECT_CLASS, DE_ROOM);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
makeExplicitPRRFilter(prrstr)
char * prrstr;
{
        gotFuzzyMatch = FALSE;
        (void)sprintf(ldap_filter, "(|(&(objectclass=person)(|(sn=%s)(cn=%s)))",
                                 prrstr, prrstr);
        (void)sprintf(ldap_filter, "%s(&(|(objectclass=organizationalRole)(objectclass=room))", ldap_filter);
        (void)sprintf(ldap_filter, "%s(cn=%s)))", ldap_filter, prrstr);
}
#else
void
makeExplicitPRRFilter(prrstr, fpp)
char * prrstr;
struct s_filter ** fpp;
{
        gotFuzzyMatch = FALSE;
        {
		(void)sprintf(filbuf, "((%s=%s) | (%s=%s)) & ((%s=*) |(%s=%s) | (%s=%s))", 
		    DE_COMMON_NAME, prrstr, DE_SURNAME, prrstr, 
		    DE_SURNAME, DE_OBJECT_CLASS, DE_ROLE,
		    DE_OBJECT_CLASS, DE_ROOM);
		*fpp = get_filter(filbuf);
	}
}
#endif USELDAP

#ifdef USELDAP
void
prrFilter1(prrstr)
char * prrstr;
{
char firststring[BUFSIZ];
char * fsp, * lsp, * laststring;

        gotFuzzyMatch = FALSE;
        /* if the string entered contains any spaces, form two substrings
           firstnamepart = all up to the first space
           lastnamepart  = all after last space */
        if (index(prrstr, ' ') != NULLCP)
        {
                (void) (void)strcpy(firststring, prrstr);
                fsp = index(firststring, ' ');
                *fsp = '\0';
                lsp = rindex(fsp + 1, ' ');
                if (lsp != NULLCP)
                        laststring = lsp++;
                else
                        laststring = fsp + 1;

                (void)sprintf(ldap_filter, "(|(cn=%s* %s*)", firststring, laststring);
        }
        else
        {
                (void)sprintf(ldap_filter, "(|(sn=%s)", prrstr);
        }
        (void)sprintf(ldap_filter, "%s(&(cn=%s)(|(sn=*)(objectclass=room)(objectclass=organizationalRole))))",
                        ldap_filter, prrstr);
}
#else
void
prrFilter1(prrstr, fpp)
char * prrstr;
struct s_filter ** fpp;
{
char firststring[LINESIZE];
char * fsp, * lsp, * laststring;

        gotFuzzyMatch = FALSE;
	/* if the string entered contains any spaces, form two substrings
	   firstnamepart = all up to the first space
	   lastnamepart  = all after last space */
	if (index(prrstr, ' ') != NULLCP)
	{
		(void) (void)strcpy(firststring, prrstr);
		fsp = index(firststring, ' ');
		*fsp = '\0';
		lsp = rindex(fsp + 1, ' ');
		if (lsp != NULLCP)
			laststring = lsp++;
		else
			laststring = fsp + 1;
		
		(void)sprintf(filbuf, "(((%s=%s* %s*)&(%s=*))|", DE_COMMON_NAME,
		       firststring, laststring, DE_SURNAME);
	}
	else
		(void)sprintf(filbuf, "((%s=%s)|", DE_SURNAME, prrstr);
	(void)sprintf(filbuf, "%s((%s=%s)&((%s=%s)|(%s=%s))))", filbuf, 
	      DE_COMMON_NAME, prrstr, DE_OBJECT_CLASS, DE_ROLE, 
	      DE_OBJECT_CLASS, DE_ROOM);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
prrFilter2(prrstr)
char * prrstr;
{
char firststring[BUFSIZ];
char * fsp, * lsp, * laststring;

        gotFuzzyMatch = FALSE;
        /* if the string entered contains any spaces, and the string up to
           the first space is more than 1 character long, form two substrings

           firstnamepart = first initial (match against beginning of cn)
           lastnamepart  = all after last space (match against beg. of sn)

           this means that "paul barker" will match entries of "p barker" */
        ldap_filter[0] = '\0';
        if (index(prrstr, ' ') != NULLCP)
        {
                (void) (void)strcpy(firststring, prrstr);
                if (strlen(firststring) == 1)
                        return;
                fsp = index(firststring, ' ');
                firststring[1] = '\0';
                lsp = rindex(fsp + 1, ' ');
                if (lsp != NULLCP)
                        laststring = lsp++;
                else
                        laststring = fsp + 1;

                (void)sprintf(ldap_filter, "(&(cn=%s*)(sn=%s)(sn=*))",
                                firststring, laststring);
        }
}
#else
void
prrFilter2(prrstr, fpp)
char * prrstr;
struct s_filter ** fpp;
{
char firststring[LINESIZE];
char * fsp, * lsp, * laststring;

        gotFuzzyMatch = FALSE;
	/* if the string entered contains any spaces, and the string up to
	   the first space is more than 1 character long, form two substrings
	   
	   firstnamepart = first initial (match against beginning of cn)
	   lastnamepart  = all after last space (match against beg. of sn)
	   
	   this means that "paul barker" will match entries of "p barker" */
	*fpp = NULLFILTER;
	if (index(prrstr, ' ') != NULLCP)
	{
		(void) (void)strcpy(firststring, prrstr);
		if (strlen(firststring) == 1)
			return;
		fsp = index(firststring, ' ');
		firststring[1] = '\0';
		lsp = rindex(fsp + 1, ' ');
		if (lsp != NULLCP)
			laststring = lsp++;
		else
			laststring = fsp + 1;
		
		(void)sprintf(filbuf, "(%s=%s*) & (%s=%s)", DE_COMMON_NAME, 
			firststring, DE_SURNAME, laststring);
		*fpp = get_filter(filbuf);
	}
}
#endif USELDAP

#ifdef USELDAP
void
prrFilter3(prrstr)
char * prrstr;
{
        gotFuzzyMatch = FALSE;
        (void)sprintf(ldap_filter, "(&(cn=*%s*)(|(sn=*)(objectclass=organizationalRole)(objectclass=room)))",
                prrstr);
}
#else
void
prrFilter3(prrstr, fpp)
char * prrstr;
struct s_filter ** fpp;
{
        gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "(%s=*%s*) & ((%s=*)|(%s=%s)|(%s=%s))", 
	          DE_COMMON_NAME, prrstr, DE_SURNAME, DE_OBJECT_CLASS, DE_ROOM,
		  DE_OBJECT_CLASS, DE_ROLE);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
prrFilter4(prrstr)
char * prrstr;
{
	if (fuzzyMatching == FALSE)
	{
		(void)strcpy(ldap_filter, "");
		return;
	}
        gotFuzzyMatch = TRUE;
        (void)sprintf(ldap_filter, "(&(cn~=%s)(|(sn=*)(objectclass=organizationalRole)(objectclass=room)))",
                prrstr);
}
#else
void
prrFilter4(prrstr, fpp)
char * prrstr;
struct s_filter ** fpp;
{
	if (fuzzyMatching == FALSE)
	{
		*fpp = NULLFILTER;
		return;
	}
        gotFuzzyMatch = TRUE;
	(void)sprintf(filbuf, "(%s~=%s) & ((%s=*)|(%s=%s)|(%s=%s))", 
	          DE_COMMON_NAME, prrstr, DE_SURNAME, DE_OBJECT_CLASS, DE_ROOM,
		  DE_OBJECT_CLASS, DE_ROLE);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
exactSurname(prrstr)
char * prrstr;
{
        gotFuzzyMatch = FALSE;
	(void)sprintf(ldap_filter, "(sn=%s)", prrstr);
}
#else
void
exactSurname(prrstr, fpp)
char * prrstr;
struct s_filter ** fpp;
{
        gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "(%s=%s)", DE_SURNAME, prrstr);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
makeRequestedFilter(prrstr)
char * prrstr;
{
        gotFuzzyMatch = FALSE;
	(void)sprintf(ldap_filter, "(%s)", prrstr);
}
#else
void
makeRequestedFilter(prrstr, fpp)
char * prrstr;
struct s_filter ** fpp;
{
        gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "(%s)", prrstr);
	*fpp = get_filter(filbuf);
}
#endif USELDAP

#ifdef USELDAP
void
makeAllPFilter()
{
        gotFuzzyMatch = FALSE;
	(void)sprintf(ldap_filter, "(sn=*)");
}
#else
void
makeAllPFilter(fpp)
struct s_filter ** fpp;
{
        gotFuzzyMatch = FALSE;
	(void)sprintf(filbuf, "(%s=*)", DE_SURNAME);
	*fpp = get_filter(filbuf);
}
#endif USELDAP
