/* power.c - routines for power searching */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/power.c,v 9.3 1993/03/19 22:55:58 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/power.c,v 9.3 1993/03/19 22:55:58 isode Exp isode $
 *
 *
 * $Log: power.c,v $
 * Revision 9.3  1993/03/19  22:55:58  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.2  1992/12/15  07:05:26  awy
 * Update and fixes
 *
 * Revision 9.1  1992/11/12  20:05:23  awy
 * IC-1 base
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#define power_c
#ifdef DOS
#include <stdlib.h>
#include "proto-de.h"
#include <graph.h>
#endif DOS
#include "messages.h"

#include <stdio.h>
#include <string.h>
#include <setjmp.h>
#include <signal.h>
#ifdef USELDAP
#ifdef IC
#include <ldap/lber.h>
#include <ldap/ldap.h>
#else
#include <lber.h>
#include <ldap.h>
#endif /* IC */
#include <string.h>
#include "isomanifest.h"
#ifdef DOS
#include <msdos.h>
#else
#include <sys/time.h>
#endif DOS
#endif USELDAP
#include "demanifest.h"
#include "destrings.h"
#include "namelist.h"
#include "query.h"
#include "asyn.h"
#include "util.h"

jmp_buf abanbuf;

extern struct query qinfo[];

#ifdef USELDAP
#ifndef DOS
extern FILE * de_log;
extern int depid;
#endif DOS
#else
extern LLog *de_log;
#endif USELDAP

extern int boundToDSA;
extern int highNumber;
extern int goneAsync;
extern int dotsPrinted;
extern int deLogLevel;

extern char matched[];

#ifndef USELDAP
extern struct ds_search_arg sarg;
extern struct ds_search_result sresult;
extern struct DSError serror;
#endif USELDAP

int orgToDispFlag;

struct namelist *nextfewfromlist();
struct namelist * lp1, * orglp, * saveorglp;
extern struct opsPending * ops;
extern int noOpsAbandoned;
extern char mode;
extern int maxPowerSearchOrgs;
char numberlist[BUFSIZ];

char
doPowerSearch()
{
int i, n, res, no_ops, no_orgs, orgsThisSearch, orgsstill2search, searchmode;
int opnum, opid, noFails, lookFor, pnum = -1;
char c;
#ifdef DOS
void abandonops(int sig), onint1();
#else
void abandonops(), onint1();
#endif DOS
struct namelist * lp, * dlp, * fails, * successes, * x, * makeCombinedList();
struct opsPending * oplp;
char options[10];
char optstr[BUFSIZ];
char * cp;

  if (strlen(qinfo[PERSON].entered) == 0)
  {
    resetprint(NOPERSONNAME);
    return '\0';
  }
  else if (strcmp(qinfo[PERSON].entered, "*") == 0)
  {
    resetprint(NOPERSONNAME);
    return '\0';
  }

  if (deLogLevel)
#ifndef DOS
#ifdef USELDAP
    (void) fprintf (de_log,
                             "%5d:PowerSearch: co=%s, org=%s, ou=%s, cn=%s\n",
				depid,
#else
    (void) ll_log (de_log, LLOG_NOTICE, NULLCP,
                             "PowerSearch: co=%s, org=%s, ou=%s, cn=%s",
#endif USELDAP
                             qinfo[COUNTRY].entered, qinfo[ORG].entered,
                             qinfo[ORGUNIT].entered, qinfo[PERSON].entered);
#endif DOS

  fails = NULLLIST;
  successes = NULLLIST;
  noFails = 0;

  pagerOn(NUMBER_ALLOWED);

#ifdef DOS
  _clearscreen(_GCLEARSCREEN);
#endif
  res = doCountry();
  switch (res)
  {
    case QUERY_ERROR:
      goto escape;
    default:
      break;
  }

/* jump back to this label if the scope of the search is to be restricted
   by entering more organisation information */
makeorglist:
  if (strlen(qinfo[ORG].entered) == 0)
    (void)strcpy(qinfo[ORG].entered, "*");
  if (strcmp(qinfo[ORGUNIT].entered, "*") == 0)
    (void)strcpy(qinfo[ORGUNIT].entered, "");
  if (strlen(qinfo[ORGUNIT].entered) == 0)
    lookFor = PERSON;
  else
    lookFor = ORGUNIT;
  if (listOrgs(matched, qinfo[ORG].entered, &qinfo[ORG].lp) != OK)
    goto escape;
  no_orgs = qinfo[ORG].listlen = listlen(qinfo[ORG].lp);
  if (no_orgs == 0)
  {
    (void)printf(NOMATCHINGORGS, qinfo[ORG].entered);
    goto escape;
  }
  if (no_orgs > maxPowerSearchOrgs)
  {
    (void)printf(MAXPARALLEL, no_orgs, maxPowerSearchOrgs);
    (void)sprintf(optstr, LIMITEDOPTS, maxPowerSearchOrgs, 
		maxPowerSearchOrgs, maxPowerSearchOrgs);
    for (;;)
    {
      if (enterOption(optstr, "#\n", &searchmode) == 0)
        goto escape;
      if (searchmode >= 1 && searchmode <= 3)
        break;
      soundBell();
    }
    if (searchmode == 3)
    {
#ifdef USELDAP
#ifndef DOS
    (void) fprintf (de_log, "%5d:Adjusting scope of PowerSearch\n", depid);
#endif DOS
#else
    (void) ll_log (de_log, LLOG_NOTICE, NULLCP,
                             "Adjusting scope of PowerSearch");
#endif USELDAP
      freeList(&qinfo[ORG].lp);
      (void) enterString(ORG);
      goto makeorglist;
    }
    orglp = qinfo[ORG].lp;
    orgsstill2search = no_orgs;
/* this label is jumped to from the end of the main loop if power searching
is restricted to a limited number of organisations */
searchmoreorgs:
    if (searchmode == 1)
    {
      for (;;)
      {
        orgsThisSearch = maxPowerSearchOrgs;
        orglp = nextfewfromlist(orglp, &x, &orgsThisSearch);
        orgsstill2search -= orgsThisSearch;
        saveorglp = x;
        pagerOn(NUMBER_NOT_ALLOWED);
        printListOrgs(qinfo[ORG].entered, saveorglp);
        if (enterYesNo(SEARCHTHESEORGS) != YESCHAR)
        {
          while (saveorglp != NULLLIST)
          {
            x = saveorglp->next;
            free((char *)saveorglp);
            saveorglp = x;
          }
          if (orgsstill2search != 0)
            continue;
          else
            goto escape;
        }
        else
          break;
      }
    }
    else /* searchmode == 2 */
    {
      pagerOn(NUMBER_NOT_ALLOWED);
      pageprint(BYNUMBERS, maxPowerSearchOrgs);
      printListOrgs(qinfo[ORG].entered, qinfo[ORG].lp);
      if (quitPager() == TRUE)
        resetprint("Enter numbers: ");
      else
        pageprint("Enter numbers: ");
      startUnbindTimer();
      if (gets(numberlist) == NULLCP)
      {
        clearerr(stdin);
        goto escape;
      }
      stopUnbindTimer();
      if (strlen(numberlist) == 0)
      {
        pagerOn(NUMBER_NOT_ALLOWED);
        goto escape;
      }
      orgListFromNumbers(numberlist, orglp, &x, &orgsThisSearch, no_orgs);
      if (orgsThisSearch == 0)
      {
        pagerOn(NUMBER_NOT_ALLOWED);
        goto escape;
      }
    }
  }
  else
  {
    searchmode = 0;
    x = qinfo[ORG].lp;
    orgsThisSearch = no_orgs;
  }
  lp1 = qinfo[PERSON].lp = NULLLIST;
  highNumber = 0;
  fails = NULLLIST;
  successes = NULLLIST;
  noFails = 0;
  (void)initAbans();

#ifdef QOS
    bulkQosUpdateOn();
#endif QOS

  /* fire off all the org searches */
  no_ops = 0;
  (void)printf(INITSEARCHES, orgsThisSearch);
  for (; x != NULLLIST; x = x->next)
  {
    if (lookFor == PERSON)
      powerSearchPeople(x->name, qinfo[PERSON].entered, &opnum);
    else
      powerSearchOUs(x->name, qinfo[ORGUNIT].entered, &opnum);
    if ((no_ops %5) == 0) /* needs to be factored off to separate dot module */
    {
      (void)printf(".");
      (void) fflush(stdout);
      dotsPrinted++;
    }
    if (opnum == -1)
    {
      (void)printf(SEARCHINITFAIL, x->name);
      continue;
    }
    addToOpList(opnum, x->name, lookFor, NULLOPL);
    no_ops++;
  }
#ifdef QOS
    setQosOffsetTime();
#endif QOS 
  
  /* now lets wait for them to come back */
  (void) resetprint(WAITING);
  (void)initAbans();
  goneAsync = TRUE;
  unsetOrgsToDispMess();
#ifdef DOS
  (void) signal(SIGINT, SIG_IGN);
#else
  (void) signal(SIGINT, abandonops);
#endif DOS
  if (setjmp(abanbuf) == 0)
  {
    while (no_ops)
    {
      /* handle exits from pager */
      pnum = getpnum();
      if (quitPager() == TRUE) /* quit or number entered */
#ifdef DOS
        abandonops(0); /* this setjmps to menu below */
#else
        abandonops(); /* this setjmps to menu below */
#endif DOS
	
      (void)showOrgsToSearch(orgsThisSearch);
#ifdef FOO
      (void)printf("List contains following orgs\n");
      for (oplp = ops; oplp != NULLOPL; oplp = oplp->next)
        (void)printf("%d %s\n", oplp->opno, oplp->orgname);
#endif FOO
      initAlarm();
      res = makeListForOneOrg(& opid);
      /* (void)printf("result for opno %d\n", opid); */
      oplp = findOp(opid);
      no_ops--;
      if (res == OK)
      {
#ifdef QOS
      updateStats(QOS_SUCCESS, &(oplp->qosRec));
#endif QOS
        if (oplp == NULLOPL)
        {
          (void)fprintf(stderr, CANTFINDOP, opid);
        }
        else
        {
          if (oplp->lp != NULLLIST)
          {
	    if (oplp->type == ORGUNIT)
	    {
	      for (dlp = oplp->lp; dlp != NULLLIST; dlp = dlp->next)
	      {
	        powerSearchPeople(dlp->name, qinfo[PERSON].entered, &opnum);
		if (opnum == -1)
		  /* do something */;
		addToOpList(opnum, dlp->name, PERSON, oplp);
		no_ops++;
		oplp->subordSearches++;
	      }
	    }
	    else
	    {
             (void)clearOrgsToSearch();
              printListPRRs(qinfo[PERSON].entered, oplp->lp, ORG, 0, highNumber);
   	      lp1 = makeCombinedList(lp1, oplp->lp);
              if (qinfo[PERSON].lp == NULLLIST)
  	        qinfo[PERSON].lp = oplp->lp;
  	      highNumber += listlen(oplp->lp);
	      oplp->lp = NULLLIST; /* to prevent untoward freeing */
	    }
  	  }
  	  else
  	  {
  	  /* (void)printf("Nothing found for %s\n", orgNameFromDN(oplp->orgname), 1);*/
  	  }
        }
	if (oplp->parent == NULLOPL)
	{
	  cp = orgNameFromDN(oplp->orgname, 1);
	  addToList(&successes, cp);
	  free(cp);
	}
      }
      else
      {
#ifdef QOS
        updateStats(QOS_FAILURE, &(oplp->qosRec));
#endif
        if (oplp->parent == NULLOPL)
	{
	  cp = orgNameFromDN(oplp->orgname, 1);
          addToList(&fails, cp);
	  free(cp);
          noFails++;
	}
      }
      if (oplp->parent == NULLOPL)
      {
        if (oplp->subordSearches == 0)
	{
          orgsThisSearch--;
          (void)removeFromOpList(opid);
	}
      }
      else 
        if ((n = removeFromOpList(opid)) != 0)
	{
	  (void)removeFromOpList(n); /*remove parent from list */
	  orgsThisSearch--;
	}
#ifdef FOO
      (void)printf("Op list countConns %d, no_ops %d\n", countConns(), no_ops);
#endif FOO
    }
  }

  (void)clearOrgsToSearch();
  goneAsync = FALSE;
#ifdef DOS
  (void) signal(SIGINT, SIG_IGN);
#else
  (void) signal(SIGINT, onint1);
#endif DOS
  if (pnum != -1)
  {
    pagerOn(NUMBER_NOT_ALLOWED);
    printSelectedEntry(pnum);
  }
escape:
#ifdef QOS
  bulkQosUpdateOff();
#endif QOS
  if (qinfo[PERSON].lp == NULLLIST)
    pageprint(NOTHINGFOUND);
  for(;;)
  {
    (void)sprintf(options, "%c%c\n", QUESTIONMARK, QUITCHAR);
    if (qinfo[PERSON].lp != NULLLIST)
    {
      pageprint(OPTIONS);
      (void)sprintf(options, "%s%c", options, LISTCHAR);
      pageprint(NUMBER);
      (void)sprintf(options, "%s#", options);
      pageprint(LIST, LISTCHAR);
    }
    if (successes != NULLLIST)
    {
      pageprint(SUCCESS, SUCCESSCHAR);
      (void)sprintf(options, "%s%c", options, SUCCESSCHAR);
    }
    if (noFails > 0)
    {
      pageprint(FAIL1, FAILCHAR);
      pageprint(FAIL2);
      (void)sprintf(options, "%s%c", options, FAILCHAR);
    }
    if (noOpsAbandoned > 0)
    {
      pageprint(ABAN, ABANCHAR);
      (void)sprintf(options, "%s%c", options, ABANCHAR);
    }
    if ((searchmode == 1) && (orgsstill2search > 0))
    {
      pageprint(NEXTSTR, MORECHAR, maxPowerSearchOrgs);
      (void)sprintf(options, "%s%c", options, MORECHAR);
    }
    if (searchmode == 2)
    {
      pageprint(MORESTR, MORECHAR, maxPowerSearchOrgs);
      (void)sprintf(options, "%s%c", options, MORECHAR);
    }
    if (mode == POWERLETTER)
    {
      pageprint(ANOTHER);
      pageprint(QUITPOWER, QUITCHAR);
    }
    else
    {
      pageprint(ANOTHERYP);
      pageprint(QUITYP, QUITCHAR);
    }
    pageprint(SHOWPOWEROPTS, QUESTIONMARK);
    c = enterOption(OPTSTRING, options, &n);
    if (qinfo[PERSON].lp == NULLLIST)
      pagerOn(NUMBER_ALLOWED);
    else
      pagerOn(NUMBER_NOT_ALLOWED);
    if (c == QUESTIONMARK)
      continue; /* redisplay options */
    if (c == '#')
    {
      /* replace this with printSelectedEntry when we know it works OK */
      if (n > highNumber)
      {
        resetprint(RANGEPROBLEM);
	continue;
      }
      for (i = 1, lp = qinfo[PERSON].lp; i < n; i++, lp = lp->next){};
      printEntry(lp->name);
      printDetails(PERSON, lp);
      continue;
    }
    if (c ==  LISTCHAR)
    {
      pagerOn(NUMBER_ALLOWED);
      printListPRRs(qinfo[PERSON].entered, qinfo[PERSON].lp, ORG, 0, 0);
      if ((n = getpnum()) != -1)
      {
        pagerOn(NUMBER_NOT_ALLOWED);
        printSelectedEntry(n);
      }
      if (quitPager() == TRUE)
        pagerOn(NUMBER_NOT_ALLOWED);
      continue;
    }
    if (c == SUCCESSCHAR)
    {
      pagerOn(NUMBER_NOT_ALLOWED);
      (void)printOrgReport(OKSEARCH, successes);
      if (quitPager() == TRUE)
        pagerOn(NUMBER_NOT_ALLOWED);
      continue;
    }
    if (c == FAILCHAR)
    {
      pagerOn(NUMBER_NOT_ALLOWED);
      (void)printOrgReport(CANTSEARCH,fails);
      if (quitPager() == TRUE)
        pagerOn(NUMBER_NOT_ALLOWED);
      continue;
    }
    if (c == ABANCHAR)
    {
      pagerOn(NUMBER_NOT_ALLOWED);
      (void)printOrgAbandons();
      if (quitPager() == TRUE)
        pagerOn(NUMBER_NOT_ALLOWED);
      continue;
    }
    if (c == MORECHAR)
    {
      while (saveorglp != NULLLIST)
      {
	x = saveorglp->next;
	free((char *)saveorglp);
	saveorglp = x;
      }
    }
    break; /* return */
  }
  freeList(&successes);
  freeList(&fails);
  initAbans();
  freeList(&qinfo[PERSON].lp);
  if (c == MORECHAR)
    goto searchmoreorgs;
  return c;
}

struct namelist *
makeCombinedList(main, addthis)
struct namelist * main, * addthis;
{
struct namelist * lp;

  if (main != NULLLIST)
    main->next = addthis;
  for (lp = addthis; lp->next != NULLLIST; lp = lp->next){};
  return(lp);
}

#ifdef DOS
void
#endif DOS
printOrgReport(message, lp)
char * message;
struct namelist * lp;
{
struct namelist * tmp;
  pageprint(message);
 for (tmp = lp ;tmp != NULLLIST; tmp = tmp->next)
    pageprint("  %s\n", tmp->name);
}

/* make sure all indexes are replaced by strstr ... and that strings
   are replaced by SHORT_CO etc */
   /* NO - THROW AWAY AND START AGAIN - THIS IS CRUDE BEYOND BELIEF */
#ifdef DOS
void
#endif DOS
printEntry(dnstr)
char * dnstr;
{
char * cp, * cp2, * savecp;

	savecp = cp = cp2 = copy_string(dnstr);
#ifdef USELDAP
	cp = rindex(savecp, ',');
	if (cp == NULLCP)
	  return;
	*cp++ = '\0';
	printLastComponent(INDENTON, cp, COUNTRY, 0);
	cp = rindex(savecp, ',');
	if (cp == NULLCP)
	  return;
	*cp++ = '\0';
	printLastComponent(INDENTON, cp, ORG, 0);
	cp = removeLastRDN(savecp);
	if (cp != NULLCP)
	  printLastComponent(INDENTON, cp, ORGUNIT, 0);
	printLastComponent(INDENTON, savecp, PERSON, 0);
	free(cp);
#else
	cp = index(cp, '@');
	if (cp == NULLCP)
	  return;
	else
	{
	  *cp = '\0';
	  printLastComponent(INDENTON, cp2, COUNTRY, 0);
	  cp2 = ++cp;
	  if (strstr(cp2, "@o=") != NULLCP)
	  {
	    cp2 = strstr(cp2, "@o=");
	    cp2++;
	  }
	  cp = index(cp2, '@');
	  if (cp == NULLCP)
	    return;
	  else
	  {
	    *cp = '\0';
	    printLastComponent(INDENTON, cp2, ORG, 0);
	    cp2 = removeLastRDN(++cp);
	    if (cp2 != NULLCP)
              printLastComponent(INDENTON, cp2, ORGUNIT, 0);
	    free(cp2);
	    printLastComponent(INDENTON, cp, PERSON, 0);
	  }
	}
#endif USELDAP
	free(savecp);
}

#ifdef DOS
void
#endif DOS
showOrgsToSearch(orgs)
#ifdef DOS
int orgs;
#endif
{
#ifdef DOS
struct _rccoord curpos;
#endif DOS

  if (testOrgsToDispMess() == FALSE)
  {
    (void)printf("%s ", STILLTODOMESS);
    setOrgsToDispMess();
  }
  else
#ifdef DOS
  {
    curpos = _gettextposition();
    _settextposition(curpos.row, curpos.col - 3);
  }
#else
    (void)printf("\b\b\b");
#endif DOS
  (void)printf("%3d", orgs);
  (void)fflush(stdout);
}

#ifdef DOS
void
#endif DOS
clearOrgsToSearch()
{
int i;
#ifdef DOS
int len;
struct _rccoord curpos;

  len = strlen(STILLTODOMESS) + 4;
  curpos = _gettextposition();
  _settextposition(curpos.row, curpos.col - len);
  for (i = 0; i < len; i++)
    _outtext(" ");
  _settextposition(curpos.row, curpos.col - len);
#else

  for (i = 0; i < ((int)strlen(STILLTODOMESS) + 4); i++)
    (void)printf("\b \b");
#endif DOS
  unsetOrgsToDispMess();
}

#ifdef DOS
void
#endif DOS
printSelectedEntry(entNo)
int entNo;
{
struct namelist * lp;
int i;
  if (entNo > highNumber)
  {
    resetprint(RANGEPROBLEM);
    return;
  }
  for (i = 1, lp = qinfo[PERSON].lp; i < entNo; i++, lp = lp->next){};
    printEntry(lp->name);
  printDetails(PERSON, lp);
}

void
setOrgsToDispMess()
{
  orgToDispFlag = TRUE;
}

void
unsetOrgsToDispMess()
{
  orgToDispFlag = FALSE;
}

int
testOrgsToDispMess()
{
  return orgToDispFlag;
}

struct namelist *
nextfewfromlist(lp, x, n)
struct namelist * lp;
struct namelist ** x;
int * n;
{
int i;

	for (i = 0; *n != 0 && lp != NULLLIST; i++, (*n)--, lp = lp->next)
	{
		*x = list_alloc();
		(*x)->name = lp->name;
		(*x)->ats = lp->ats;
		x = &(*x)->next;
	}
	*x = NULLLIST;
	*n = i;
	return lp;
}

orgListFromNumbers(str, lp, x, noNums, maxOrgNo)
char * str;
struct namelist * lp;
struct namelist ** x;
int * noNums;
{
char * cp, *cp2;
struct namelist * lp2;
int i, n;

	*noNums = 0;
	for (cp = str; *cp != '\0'; cp++)
	{
		cp2 = index(cp, ' ');
		if (cp2 != NULLCP)
			*cp2 = '\0';
		n = atoi(cp);
		if ((n > 0) && (n <= maxOrgNo))
		{
			(*noNums)++;
			for (i = 1, lp2 = lp; i < n; i++, lp2 = lp2->next) {};
			*x = list_alloc();
			(*x)->name = lp2->name;
			(*x)->ats = lp2->ats;
			x = &(*x)->next;
		}
		if (*noNums >= maxPowerSearchOrgs)
			break;
		if (cp2 != NULLCP)
			cp = cp2;
		else
			break;
	}
	*x = NULLLIST;
}
