/* qos.h */

#ifndef _qos_h_
#define _qos_h_

#include <sys/types.h>
#include <sys/stat.h>
#include<time.h>

enum QosTypes { QOS_FAILURE, QOS_SUCCESS, QOS_ABANDON };

#define ERRQOSREC -1 
#define NEWQOSREC -2 
#define DNSIZE 128 
#define QOS_SUCCESS_CHAR 's'
#define QOS_FAILURE_CHAR 'f'
#define QOS_ABANDON_CHAR 'a'
#define QOSRECS 5000
#define qosrecOffset(x) (long)((x) * QOSRECSIZE)
#define QOSRECSIZE (DNSIZE + 1 + 8 + 1 + 1 + 10 + 1 +  1 + 1 + 4 + 1)
/*                           &  8.2 " "  &   10 s/f/a " "  &   4   CR */


struct qosentry {
        int recnum;
        time_t finalTime;
        time_t startTime;
        char matchString[DNSIZE+1];
};

struct qosrec {
        char dn[DNSIZE+1];
        float avetime;
        int cnt;
        char success;
        time_t timeStamp;
	int noQueries;
};

void initQos();
void switchOffQos();
void bulkQosUpdateOn();
void setQosOffsetTime();
void bulkQosUpdateOff();
void startQosTime();
void updateStats();

#endif _qos_h_

