/* dehelp.c */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/dehelp.c,v 9.2 1993/03/19 22:53:56 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/dehelp.c,v 9.2 1993/03/19 22:53:56 isode Exp isode $
 *
 *
 * $Log: dehelp.c,v $
 * Revision 9.2  1993/03/19  22:53:56  isode
 * Add QOS and DOS-DE code
 *
 * Revision 8.1  1991/09/13  14:36:41  isode
 * PARADISE Upgrade release
 *
 * Revision 8.0  91/07/17  13:18:39  isode
 * Release 7.0
 *
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#define dehelp_c
#ifdef DOS
#include <stdlib.h>
#include "proto-de.h"
#include <graph.h>
#endif DOS
#define helpscreens
#include <ctype.h>
#include <signal.h>
#ifdef USELDAP
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "isomanifest.h"
#endif USELDAP
#include "messages.h"
#include "demanifest.h"
#include "util.h"
#ifndef USELDAP
#ifdef IC
#include "compat/tailor.h"
#else
#include "tailor.h"
#endif /* IC */
#include "quipu/util.h"
#ifdef IC
#include "compat/logger.h"
#else
#include "logger.h"
#endif /* IC */
#endif USELDAP

#ifdef USELDAP
#ifndef DOS
extern FILE * de_log;
#endif DOS
#else
extern LLog *de_log;
#endif USELDAP
extern int lines, cols;
#ifndef DOS
extern int preferInvVideo;
#endif DOS
extern int deLogLevel;
extern int controlCtoQuit;
#ifndef DOS
extern char term[];
#endif DOS
extern char * versionNo;
char *deTidyString();
#ifndef DOS
char *checkSetTerm();
#endif DOS
void displayCurrentSettings();
void soundBell();

static struct {
	char *topic;
	char *fullname;
	int unique;
} helpTopics[] = {
	BYEBYE, NULLCP, BYEBYELEN,
	COMMANDS, NULLCP, COMMANDSLEN,
	COUNTRY2, NULLCP, COUNTRY2LEN,
	DEPARTMENT, NULLCP, DEPARTMENTLEN,
	DEPT, DEPARTMENT, DEPTLEN,
	EX1, NULLCP, EX1LEN,
	EX2, NULLCP, EX2LEN,
	HELP, NULLCP, HELPLEN,
	INTRO, NULLCP, INTROLEN,
	LIST, NULLCP, LISTLEN,
	LOCALITY2, NULLCP, LOCALITY2LEN,
        MATCHING, NULLCP, MATCHINGLEN,
	MODES, NULLCP, MODESLEN,
	MULTI, NULLCP, MULTILEN,
	NAME, NULLCP, NAMELEN,
	ORGANISATION, NULLCP, ORGANISATIONLEN,
	ORGANIZATION, ORGANISATION, ORGANIZATIONLEN,
	ORGINFO, NULLCP, ORGINFOLEN,
	PERSON2, NAME, PERSON2LEN,
	POWER, MULTI, POWERLEN,
        PROBLEMS, NULLCP, PROBLEMSLEN,
        SETTINGS, NULLCP, SETTINGSLEN,
	SCREEN, NULLCP, SCREENLEN,
	SPECIAL, NULLCP, SPECIALLEN,
	TERMTYPES, NULLCP, TERMTYPESLEN,
	UFN, NULLCP, UFNLEN,
	VERSION, NULLCP, VERSIONLEN,
	WILDCARDS, NULLCP, WILDCARDSLEN,
	YELLOWHELP, NULLCP, YELLOWHELPLEN,
	NULLCP, NULLCP, 0
};

void
tailorHelp()
{
int i;

	if (controlCtoQuit)
	for (i = 0; helpTopics[i].unique != 0; i++)
	{
		if (strcmp(helpTopics[i].topic, INTRO) == 0)
			helpTopics[i].fullname = INTROCC;
		if (strcmp(helpTopics[i].topic, NAME) == 0)
			helpTopics[i].fullname = NAMECC;
		if (strcmp(helpTopics[i].topic, COMMANDS) == 0)
			helpTopics[i].fullname = COMMANDSCC;
	}
}

char *
findHelp(helpstr)
char * helpstr;
{
int i, n;
char * cp;

	for (cp = helpstr; *cp != '\0'; cp++)
		if (isupper(*cp))
			*cp = tolower(*cp);
	for (i = 0; helpTopics[i].unique != 0; i++)
	{
		if ((n = strlen(helpstr)) >= helpTopics[i].unique)
			if (strncmp(helpTopics[i].topic, helpstr, n) == 0)
				if (helpTopics[i].fullname == NULLCP)
					return(helpTopics[i].topic);
				else
					return(helpTopics[i].fullname);
	}
	return(helpstr);
}

#ifdef DOS
void
displayFile(filename, help, wanttoclear)
char * filename;
int help, wanttoclear;
#else
displayFile(filename, help)
char * filename;
int help;
#endif DOS
{
FILE *fname;
char linebuf[LINESIZE];
char str[LINESIZE];
#ifdef DOS
int printing;

  (void) strcpy(str, DOSHELPFILE);
#else
  (void) strcpy(str, HELPFILEPREFIX);
  (void) strcat(str, filename);
#endif DOS
  if ((fname = fopen(isodefile(str, 0), "r")) == (FILE *) NULL)
  {
#ifndef DOS
    if (help == TRUE)
    {
      if (deLogLevel)
#ifdef USELDAP
        (void) fprintf (de_log, "NoHelp: %s\n", str + 5);
#else
        (void) ll_log (de_log, LLOG_NOTICE, NULLCP, "NoHelp: %s", str + 5);
#endif USELDAP
#endif DOS
      (void) fprintf(stderr, NOHELP, filename);
      (void) fprintf(stderr, HELPHELP);
#ifndef DOS
    }
    else
      if (deLogLevel)
#ifdef USELDAP
        (void) fprintf (de_log, "No such file: %s\n", str + 5);
#else
        (void) ll_log (de_log, LLOG_NOTICE, NULLCP, "No such file: %s", str + 5);
#endif USELDAP
#endif DOS
  }
  else 
  {
    pagerOn(NUMBER_NOT_ALLOWED);
#ifndef DOS
    if (help == TRUE)
      if (deLogLevel)
#ifdef USELDAP
        (void) fprintf (de_log, "Help: %s\n", str + 5);
#else
        (void) ll_log (de_log, LLOG_NOTICE, NULLCP, "Help: %s", str + 5);
#endif USELDAP
#endif DOS
#ifdef DOS
    printing = 0;
    while(fgets(linebuf, sizeof(linebuf), fname) != NULLCP) {
      if (strncmp(linebuf, "**** ", 5) == 0)
        if (printing)
          break;
        else {
          if (strncmp(&linebuf[5], filename, strlen(filename)) == 0) {
            printing = 1;
            if (wanttoclear)
              _clearscreen(_GCLEARSCREEN);
            continue;
          }
        }
      if (printing)
        pageprint("%s",linebuf);
    }
#else
    while(fgets(linebuf, sizeof(linebuf), fname) != NULLCP)
      pageprint("%s",linebuf);
#endif DOS
    (void) fclose(fname);
    if (help == TRUE)
      pageprint(HELPHELP);
  }
}

#ifndef DOS
static struct {
	char *varname;
	int musttype;
	int vartype;
	char * varval;
	char *desc;
} settableVars[] = {
	TTYPE, TTYPELEN, 2, term, TTYPEDESC,
	INVVIDEO, INVVIDEOLEN, 3, (char *) & preferInvVideo, INVVIDEODESC,
	COLS, COLSLEN, 1,  (char *) & cols, COLSDESC,
	LINES, LINESLEN, 1, (char *) & lines, LINESDESC,
	NULLCP, 0, 0, NULLCP, NULLCP
};
#endif DOS

void
displayHelp(helpstr)
char * helpstr;
{
#ifdef DOS
  if (lexequ(helpstr, VERSION) == 0)
  {
    (void)printf(VERSSTR, versionNo);
    return;
  }
  displayFile(helpstr, TRUE, TRUE);
#else
SFD cleanupok();
void onint1();
int i, n, found;
char * cp, * cp1;
char buf[1024];
char varname[1024], varval[1024];
extern void turnInverseVideoOn(), turnInverseVideoOff();

  if (lexequ(helpstr, VERSION) == 0)
  {
    (void)printf(VERSSTR, versionNo);
    return;
  }
  else if (lexequ(helpstr, SETTINGS) == 0)
  {
    (void) printf(SET1);
    (void) printf(SET2);
    
    (void) displayCurrentSettings();

#ifdef DOS
    (void) signal(SIGINT, SIG_IGN);
#else
    if (signal(SIGINT, SIG_IGN) != SIG_IGN)
      (void) signal(SIGINT, onint1);
#endif
    for (;;)
    {
      (void) writeInverse(CHANGESET);
      (void) putchar(' ');
      if (gets(buf) == NULLCP)
      {
        clearerr(stdin);
        goto resetSignal;
      }
      cp = deTidyString(buf);
      if (strlen(cp) == 0) /* default of 'no' accepted */
        goto resetSignal;
      if (lexnequ(cp, NO, strlen(cp)) == 0)
        goto resetSignal;
      if (lexnequ(cp, YES, strlen(cp)) != 0)
        continue;
enterVarType:
      (void) writeInverse(ENTERVARNAME);
      (void) putchar(' ');
      if (gets(varname) == NULLCP) /* user obviously not interested */
      {
        clearerr(stdin);
	goto resetSignal;
      }
      cp = deTidyString(varname);
      if (strlen(cp) == 0) /* default of 'no' accepted */
        goto resetSignal;
      /* convert user input to lower case */
      for (cp1 = cp; *cp1 != '\0'; cp1++)
        if (isupper(*cp1))
          *cp1 = tolower(*cp1);
      /* try and find variable name within table */
      for (i = 0, found = 0; settableVars[i].varname != NULLCP; i++)
      {
        if ((n = strlen(cp)) >= settableVars[i].musttype)
	  if (strncmp(settableVars[i].varname, cp, n) == 0)
	  {
	    (void) strcpy(varname, settableVars[i].varname);
	    found = 1;
	    break;
	  }
      }
      if (found == 0)
      {
        (void) printf(NOSUCHVAR, varname);
	goto enterVarType;
      }
enterVarVal:
      (void) writeInverse(ENTERVARVAL);
      (void) putchar(' ');
      if (gets(varval) == NULLCP) /* retain old value */
      {
        clearerr(stdin);
	continue;
      }
      cp = deTidyString(varval);
      if (strlen(cp) == 0) /* retain old value */
        continue;
      if (validateSetting(settableVars[i].vartype, cp) != OK)
        goto enterVarVal; /* invalid input - have another go */

      /* treat termtype specially */
      if (lexequ(varname, TTYPE) == 0)
      {
        cp = checkSetTerm(cp, term);
	(void) printf(TTWARNING);
      }
      /* treat inv video specially */
      if (lexequ(varname, INVVIDEO) == 0)
      {
        if (strcmp(cp, ON) == 0)
	  turnInverseVideoOn();
	else
	  turnInverseVideoOff();
      }

      switch(settableVars[i].vartype)
      {
        case 1:
          *((int *)settableVars[i].varval) = atoi(cp);
	  break;
	case 2:
          (void) strcpy(settableVars[i].varval, cp);
	  break;
	case 3:
	  if (strcmp(cp, ON) == 0)
	    *((int *)settableVars[i].varval) = 1;
	  else if (strcmp(cp, OFF) == 0)
	    *((int *)settableVars[i].varval) = 0;
	  break;
      }
      (void) putchar('\n');
      displayCurrentSettings();
    }
resetSignal:
#ifdef DOS
    signal(SIGINT, SIG_IGN);
#else
    if (signal(SIGINT, SIG_IGN) != SIG_IGN)
      (void) signal(SIGINT, cleanupok);
#endif DOS
    return;
  }
  else
    displayFile(helpstr, TRUE); /* TRUE says this is a help file */
#endif DOS
}

#ifndef DOS
validateSetting(type, value)
int type;
char * value;
{
char * cp;
  switch (type)
  {
    case 1: /* look for non numeric chars */
      for (cp = value; *cp != '\0'; cp++)
        if (!(isdigit(*cp)))
          goto invalidinput;
      return OK;
    case 2: /* strings are OK */
      return OK;
    case 3: /* booleans are "on" or "off" */
      if ((strcmp(value, ON) == 0) || (strcmp(value, OFF) == 0))
        return OK;
      else
        goto invalidinput;
    default: /* what the hell's this?? */
      goto invalidinput;
  }
invalidinput:
  soundBell();
  return NOTOK;
}

void
displayCurrentSettings()
{
int i;

    (void) printf(CURRSET);
    for (i = 0; settableVars[i].varname != NULLCP; i++)
    {
      (void) printf("%-8s  ", settableVars[i].varname);
      switch (settableVars[i].vartype)
      {
        case 1: /* integer */
          (void) printf("%8d", *((int *)(settableVars[i].varval)));
	  break;
	case 2: /* string */
          (void) printf("%8s", settableVars[i].varval);
	  break;
	case 3: /* boolean */
	  if (*((int *)(settableVars[i].varval)) == 1)
	    (void) printf("%8s", ON);
	  else
	    (void) printf("%8s", OFF);
	  break;
      }
      (void) printf("  %s\n", settableVars[i].desc);
    }
}
#endif DOS
