/* util.c */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/util.c,v 9.3 1993/03/19 22:56:15 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/util.c,v 9.3 1993/03/19 22:56:15 isode Exp isode $
 *
 *
 * $Log: util.c,v $
 * Revision 9.3  1993/03/19  22:56:15  isode
 * Add QOS and DOS-DE code
 *
 * Revision 9.2  1992/12/15  07g:05:26  awy
 * Update and fixes
 *
 * Revision 8.1  1991/09/13  14:36:41  isode
 * PARADISE Upgrade release
 *
 * Revision 8.0  91/07/17  13:18:50  isode
 * Release 7.0
 *
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#define util_c
#ifdef DOS
#include <stdlib.h>
#include "proto-de.h"
#include <graph.h>
#endif DOS
#include "messages.h"
#include <signal.h>
#include <setjmp.h>
#ifndef DOS
#if defined(__osf__)
#include <sys/ioctl.h>
#else
#include <sys/termios.h>
#endif
#endif DOS
#ifdef USELDAP
#include <sys/types.h>
#ifndef DOS
#include <sys/time.h>
#endif DOS
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#ifdef IC
#include <ldap/lber.h>
#include <ldap/ldap.h>
#else
#include <lber.h>
#include <ldap.h>
#endif /* IC */
#include "isomanifest.h"
#endif USELDAP
/*#include "config.h"*/
#include "demanifest.h"
#include "destrings.h"
#include "types.h"
#include "util.h"
#include "namelist.h"
#include "cnamelist.h"
#ifndef USELDAP
#include "quipu/util.h"
#include "quipu/ds_search.h"
#ifdef IC
#include "compat/logger.h"
#else
#include "logger.h"
#endif /* IC */
#endif USELDAP
#include "query.h"

extern struct query qinfo[];
#ifdef USELDAP
#ifndef DOS
extern FILE * de_log;
extern int depid;
#endif DOS
#else
extern LLog *de_log;
#endif USELDAP
extern int boundToDSA;
extern int qosOn;
extern int limitProblem;
extern int notAllReached;
extern int localAlarmTime;
extern int remoteAlarmTime;
extern char origDefaultCo[], origDefaultOrg[];
extern char searchVal[];
extern int deLogLevel;
extern int alarmCount;
extern int bindTimeout;
extern int noActivityTimeout;
extern int gotFuzzyMatch;
extern char mode;
void onint1();
void clearDots();
char *logObjectString();

extern int dots;
extern int dotsPrinted;

extern jmp_buf sjbuf;

static int suppSrchMess;

#ifdef USELDAP
extern LDAP * ldap_ld;
#endif USELDAP

int
listlen(lp)
struct namelist * lp;
{
int len;

  for (len = 0; lp != NULLLIST; lp = lp->next, len++) {};
  return len;
}

unsigned int
alarmLen()
{
#ifdef QOS
  extern int qosAlarm;

  if( qosOn == TRUE )  
  {
    if (qosAlarm != 0)
      return qosAlarm;
  }
#endif QOS

  if ((lexequ(qinfo[ORG].entered, origDefaultOrg) == 0) && 
      (lexequ(qinfo[COUNTRY].entered, origDefaultCo) == 0))
  {
    return localAlarmTime;
  }
  else
  {
      return remoteAlarmTime;
  }
}

void initAlarm()
{
#ifdef USELDAP
/*
  ld->ld_timelimit = alarmLen();
 */
  ldap_ld->ld_timelimit = 180; /* 3 mins ??? */
#endif USELDAP
  dots = alarmLen() / 2;
  dotsPrinted = 0;
}

void
alarmCleanUp()
{
#ifdef QOS
extern int qosAlarm;
#endif QOS

	if (dotsPrinted > 0)
	{
	  if (dotsPrinted < dots)
	    clearDots();
	  else
	    (void) printf("\n\n");
	  dotsPrinted = 0;
	}
#ifdef QOS
	qosAlarm = 0;
#endif QOS
}

void
clearDots()
{
int i, len;
#ifdef DOS
struct _rccoord curpos;
#endif DOS

  if (testSuppressSearchMess())
    len = dotsPrinted;
  else if (strcmp(searchVal, "*") == 0)
    len = strlen(LISTMESS) + dotsPrinted;
  else /* 3 other chars - space and some quote marks */
    len = strlen(SEARCHMESS) + strlen(searchVal) + 3 + dotsPrinted;
#ifdef DOS

  curpos = _gettextposition();
  _settextposition(curpos.row, curpos.col - len);
  for (i = 1; i < len + 1; i++)
    _outtext(" ");
  _settextposition(curpos.row, curpos.col - len);
#else
  for (i = 0; i < len; i++)
    (void)printf("\b \b");
#endif DOS
}

void
exitTimeout()
{
#ifndef DOS
fd_set rfds, wfds;
int n, i;
extern void onint1();
#ifdef USELDAP
struct timeval  tvs;
#endif USELDAP

#ifdef USELDAP
  tvs.tv_sec = 2;
  tvs.tv_usec = 0;
#endif USELDAP
  (void)printf(MAINTAINCONN);
  for (i = 0, n = 0; i < 5; i++)
  {
    FD_ZERO (&rfds);
    FD_ZERO (&wfds);
    FD_SET(0, &rfds);
    soundBell();
    (void)fflush(stdout);
#ifdef USELDAP
    n = select(1, &rfds, &wfds, NULLFD, &tvs);
#else
    n = xselect(1, &rfds, &wfds, NULLFD, 2);
#endif USELDAP
    if (n == 1)
      break;
  }
  if (n == 1)
  {
    n = ioctl(0, TCFLSH, 0);
    longjmp(sjbuf, 0);
  }
  else
    de_exit(-1);
#endif DOS
}

void
handleTimeout()
{
#ifndef DOS
int to;
  de_unbind();
  /* optionally set up alarm to exit program if idle */
  if (noActivityTimeout == 0)
    (void) signal(SIGALRM, SIG_IGN);
  else
  {
    (void) signal(SIGALRM, (VFP) exitTimeout);
    if ((to = (noActivityTimeout - bindTimeout)) <= 0)
      to = 1; /* replace meaningless alarm periods with a very short one */
    (void) alarm((unsigned)to);
  }

#endif DOS
}

void startUnbindTimer()
{
#ifndef DOS
void handleTimeout();

  (void) signal(SIGALRM, (VFP) handleTimeout);
  if ((boundToDSA == FALSE) && (bindTimeout > 30))
    (void) alarm(30); /* 30 is intended to be short enough to avoid some
                         asynch bind problem which occurs if the entire bind
			 isn't completed snappily enough */
  else			 
    (void) alarm((unsigned)bindTimeout);
#endif DOS
}

void stopUnbindTimer()
{
#ifndef DOS
  (void) signal(SIGALRM, SIG_IGN);
  (void) alarm(0);
#endif DOS
}

char *
copy_string(string)
char *string;
{
  char *new_string;

  if (string == NULLCP) return NULLCP;

  new_string = (char *) smalloc((strlen(string) + 1));
  (void) strcpy(new_string, string);

  return new_string;
}


#ifndef USELDAP
static PS ps = NULLPS;

char   *dn2pstr (dn)
DN	dn;
{
    char       *cp;

    if (ps == NULL
	    && ((ps = ps_alloc (str_open)) == NULLPS)
		    || str_setup (ps, NULLCP, BUFSIZ, 0) == NOTOK) {
	if (ps)
	    ps_free (ps), ps = NULLPS;

	return NULLCP;
    }

    dn_print (ps, dn, RDNOUT);
    ps_print (ps, " "); 
    *--ps -> ps_ptr = NULL, ps -> ps_cnt++;

    cp = ps -> ps_base;

    ps -> ps_base = NULL, ps -> ps_cnt = 0;
    ps -> ps_ptr = NULL, ps -> ps_bufsiz = 0;

    removeLineFolds(cp);

    return cp;
}

char   *rdn2pstr (rdn)
RDN	rdn;
{
    char       *cp;

    if (ps == NULL
	    && ((ps = ps_alloc (str_open)) == NULLPS)
		    || str_setup (ps, NULLCP, BUFSIZ, 0) == NOTOK) {
	if (ps)
	    ps_free (ps), ps = NULLPS;

	return NULLCP;
    }

    rdn_print (ps, rdn, RDNOUT);
    ps_print (ps, " "); 
    *--ps -> ps_ptr = NULL, ps -> ps_cnt++;

    cp = ps -> ps_base;

    ps -> ps_base = NULL, ps -> ps_cnt = 0;
    ps -> ps_ptr = NULL, ps -> ps_bufsiz = 0;

    removeLineFolds(cp);
    return cp;
}

removeLineFolds(str)
char * str;
{
char * cp2, * cp3;

    /* this is horrible!
       get rid of any \\\n char pairs in the string
       which have put there by octprint if it gets long
       rdn values */
    for (cp2 = cp3 = str; *cp2 != '\0';)
    {
	if ((*cp2 == '\\') & (*(cp2 + 1) == '\n')) /* pattern matched */
	{
		cp2 += 2;
		continue;
	}
	if (cp2 != cp3)
		*cp3 = *cp2;
	cp2++; cp3++;
    }
    *cp3 = '\0';
}


#endif USELDAP


/* print last component of a dn string - optionally indented by type */
void printLastComponent(indent, dnstr, objectType, printNumber)
int indent;
char * dnstr;
int objectType;
int printNumber;
{
char * cp1, * cp2, * savestring;

  if (strcmp(dnstr, "root") == 0)
    return;
  savestring = copy_string(dnstr);
  cp1 = lastComponent(savestring, objectType);
  if (cp1 == NULLCP)
  {
    savestring = copy_string("Entry with no name!");
    cp2 = savestring;
  }
  else
  {
    if (objectType == COUNTRY)
      cp2 = mapCoName(cp1);
    else
      cp2 = cp1;
  }
  if (indent == INDENTON)
  {
    switch (objectType)
    {
      case COUNTRY:
        break;
      case LOCALITY:
        pageprint(" ");
	break;
      case ORG:
        pageprint("  ");
	break;
      case ORGUNIT:
        pageprint("    ");
	break;
      case PERSON:
        pageprint("      ");
	break;
      default:
        (void) fprintf(stderr, "WOT's THIS?  ");
	break;
    }
  }
  if (printNumber != 0)
    pageprint("%3d ", printNumber);
  pageprint("%s%s\n", cp2, 
                      (qinfo[objectType].fuzzy == TRUE) ? FUZZILYMATCHED : "");
/*  pageprint("%s\n", cp2); */
  free(cp1);
  free(savestring);
}

char *
lastComponent(dnstr, objectType)
char * dnstr;
int objectType;
{
char * cp, * cp2, *cp3, * savestring;
int gotmatch;

  if (dnstr == NULLCP)
    return NULLCP;
  if (*dnstr == '\0')
    return NULLCP;
  savestring = copy_string(dnstr);
#ifdef USELDAP
  cp = index(savestring, ',');
  if (cp != NULLCP)
    *cp = '\0';
  cp = index(savestring, '=');
  if (cp != NULLCP)
    cp++;
  else
    cp = savestring;
  cp = copy_string(cp);
#else
  cp = cp3 = rindex(savestring, '@');
  if (cp == NULLCP)
/*    cp = dnstr;*/
    cp = cp3 = dnstr;
  else
    cp++;
  for (;;)
  {
    gotmatch = FALSE;
    switch (objectType)
    {
      case PERSON:
        if (strncmp(cp, SHORT_CN, strlen(SHORT_CN)) == 0)
	{
          cp += strlen(SHORT_CN) + 1;
	  gotmatch = TRUE;
	}
        break;
      case ORGUNIT:
        if (strncmp(cp, SHORT_OU, strlen(SHORT_OU)) == 0)
	{
	  cp += strlen(SHORT_OU) + 1;
	  gotmatch = TRUE;
	}
	break;
      case ORG:
        if (strncmp(cp, SHORT_ORG, strlen(SHORT_ORG)) == 0)
	{
	  cp += strlen(SHORT_ORG) + 1;
	  gotmatch = TRUE;
	}
	break;
      case LOCALITY:
        if (strncmp(cp, SHORT_LOC, strlen(SHORT_LOC)) == 0)
	{
	  cp += strlen(SHORT_LOC) + 1;
	  gotmatch = TRUE;
	}
	break;
      case COUNTRY:
        if (strncmp(cp, SHORT_CO, strlen(SHORT_CO)) == 0)
	{
	  cp += strlen(SHORT_CO) + 1;
	  gotmatch = TRUE;
	}
	else if (strncmp(cp, SHORT_LOC, strlen(SHORT_LOC)) == 0)
	{
	  cp += strlen(SHORT_LOC) + 1;
	  gotmatch = TRUE;
	}
	break;
    }
    cp2 = index(cp, '%');
    if (gotmatch == TRUE)
    {
      if (cp2 != NULLCP)
        *cp2 = '\0';
      break;
    }
    else 
    {
      if (cp2 != NULLCP)
        cp = cp2 + 1;
      else
        break;
    }
  }
  if (gotmatch == FALSE)
  {
    cp = index(cp3, '%');
    if (cp != NULLCP)
      *cp = '\0';
    cp = index(cp3, '=') + 1;
  }
  cp = copy_string(cp);
#endif USELDAP
  free (savestring);
  return cp;
}

char *
orgNameFromDN(dnstr, nameType)
char * dnstr;
int nameType;
{
char * cp, * cp2, * cp3;
char tmp[100];

  (void)sprintf(tmp, "%s=", SHORT_ORG);
  cp = copy_string(dnstr);
  for (;;)
  {
    if (strncmp(tmp, (cp3 = lastRDN(cp)), strlen(tmp)) == 0)
    {
#ifdef USELDAP
      free(cp3);
#endif
      if (nameType == 0)
        return cp; /* return DN */
      else
      {
        cp2 = copy_string((cp3 = lastRDN(cp)) + strlen(tmp));
#ifdef USELDAP
        free(cp3);
#endif
	free (cp);
        return (cp2); /* just name part */
      }
    }
#ifdef USELDAP
    else
      free(cp3);
#endif
    cp2 = removeLastRDN(cp);
    free(cp);
    if (cp2 == NULLCP)
      return NULLCP;
    cp = cp2;
  }
}


char *
removeLastRDN(dnstr)
char * dnstr;
{
char * cp, * cp2;

	cp = copy_string(dnstr);
#ifdef USELDAP
        cp2 = index(cp, ',');
        if (cp2 == NULLCP)
	{
		free(cp);
		return copy_string("");
	}
        else {
                while (*cp2 == ',' || *cp2 == ' ') cp2++;
                (void)strcpy(cp, cp2);
        }
#else
	if ((cp2 = rindex(cp, '@')) == NULLCP)
	{
	  free(cp);
	  return NULLCP;
	}
	else
	  *cp2 = '\0';
#endif USELDAP
	return cp;
}

char *
lastRDN(dnstr)
char * dnstr;
{
char * cp;

#ifdef USELDAP
char * savestring;

        savestring = copy_string(dnstr);
        cp = index(savestring, ',');
        if (cp == NULLCP)
                return savestring;
        else
        {
                *cp = '\0';
                cp = copy_string(savestring);
                free(savestring);
                return cp;
        }
#else
	cp = rindex(dnstr, '@');
	if (cp == NULLCP)
		return dnstr;
/*		return NULLCP; */
	else
		return (++cp);
#endif USELDAP
}

void
clearProblemFlags()
{
	limitProblem = notAllReached = suppSrchMess = FALSE;
}

void
suppressSearchMess()
{
	suppSrchMess = TRUE;
}

testSuppressSearchMess()
{
	return (suppSrchMess);
}

#ifdef USELDAP
void
setProblemFlags(errno)
int errno;
{
        if (errno == LDAP_SIZELIMIT_EXCEEDED)
                limitProblem = TRUE;
        else if (errno == LDAP_TIMELIMIT_EXCEEDED)
                notAllReached = TRUE;
}
#else
void
setProblemFlags(sresult)
struct ds_search_result sresult;
{
	if ((sresult.CSR_limitproblem == LSR_SIZELIMITEXCEEDED) ||
	    (sresult.CSR_limitproblem == LSR_ADMINSIZEEXCEEDED))
		limitProblem = TRUE;
	if ((sresult.CSR_cr != NULLCONTINUATIONREF) ||
	    (sresult.CSR_limitproblem == LSR_TIMELIMITEXCEEDED))
		notAllReached = TRUE;
}
#endif USELDAP


void
showAnyProblems(str)
char * str;
{
    if (limitProblem == TRUE)
    {
      pageprint(LIMIT);
      if (strcmp(str, "*") == 0)
      {
	pageprint(GUESS);
      }
      else
        pageprint(BEPRECISE);
      pageprint(REFER);
    }
    else
    {
      if (notAllReached == TRUE)
      {
        pageprint(NOTALL1);
  	pageprint(NOTALL2);
      }
    }
}

void
logSearchSuccess2(outcome, objecttype, string, searchNumber, noMatches)
char * outcome;
int objecttype;
char * string;
int searchNumber;
int noMatches;
{
char filterNumberString[20];

	if (deLogLevel > 1)
	{
		if (searchNumber == 0)
			(void) strcpy(filterNumberString, "explicit");
		else
			(void) sprintf(filterNumberString, "%d", searchNumber);
		
#ifndef DOS
#ifdef USELDAP
		(void) fprintf (de_log,	"%5d:searchOutcome:%s:%s:%s:%s:%d\n", 
			depid, logObjectString(objecttype),
#else
		(void) ll_log (de_log, LLOG_NOTICE, NULLCP,
			"searchOutcome:%s:%s:%s:%s:%d", logObjectString(objecttype),
#endif USELDAP
			outcome, string, filterNumberString, noMatches);
#endif DOS
	}
}

void logListSuccess2(outcome, objecttype, noMatches)
char * outcome;
int objecttype;
int noMatches;
{
    if (deLogLevel > 1)
    {
#ifndef DOS
#ifdef USELDAP
	(void) fprintf (de_log, "%5d:listOutcome:%s:%s:%d\n", 
                       depid, logObjectString(objecttype), outcome, noMatches);
#else
	(void) ll_log (de_log, LLOG_NOTICE, NULLCP, "listOutcome:%s:%s:%d", 
                             logObjectString(objecttype), outcome, noMatches);
#endif USELDAP
#endif DOS
    }
}

void logReadSuccess2(outcome, objecttype)
char * outcome;
int objecttype;
{
    if (deLogLevel > 1)
    {
#ifndef DOS
#ifdef USELDAP
        (void) fprintf (de_log, "%5d:readOutcome:%s:%s\n", 
                              depid, logObjectString(objecttype), outcome);
#else
	(void) ll_log (de_log, LLOG_NOTICE, NULLCP, "readOutcome:%s:%s", 
                              logObjectString(objecttype), outcome);
#endif USELDAP
#endif DOS
    }
}

char *
logObjectString(objecttype)
int objecttype;
{
    switch(objecttype)
    {
        case COUNTRY:
            return "co";
        case LOCALITY:
            return "lo";
        case ORG:
            return "org";
        case ORGUNIT:
            return "ou";
        case PERSON:
            return "prr";
        default:
            return "unknown";
    }
}

char *
shortString(objecttype)
int objecttype;
{
    switch(objecttype)
    {
	case COUNTRY:
		return SHORT_CO;
	case LOCALITY:
		return SHORT_LOC;
	case ORG:
		return SHORT_ORG;
	case ORGUNIT:
		return SHORT_OU;
	case PERSON:
		return SHORT_CN;
	default:
		return "unknown";
    }
}

char *
ocString(objectType)
{
    switch(objectType)
    {
	case COUNTRY:
		return NULLCP;
	case LOCALITY:
		return DE_LOCALITY;
	case ORG:
		return DE_ORGANISATION;
	case ORGUNIT:
		return DE_ORGANISATIONAL_UNIT;
	case PERSON:
		return NULLCP;
	default:
		return NULLCP;
    }
}

char *
atString(objectType)
{
    switch(objectType)
    {
	case COUNTRY:
		return NULLCP;
	case LOCALITY:
		return DE_LOCALITY_NAME;
	case ORG:
		return DE_ORGANISATION_NAME;
	case ORGUNIT:
		return DE_ORGANISATIONAL_UNIT_NAME;
	case PERSON:
		return NULLCP;
	default:
		return NULLCP;
    }
}

int
rightObjectType(objectType, str)
int objectType; 
char * str;
{
	switch(objectType)
	{
		case COUNTRY:
#ifdef USELDAP
			return((strncmp(str, SHORT_CO,
				strlen(SHORT_CO)) == 0) ||
				(strncmp(str, SHORT_LOC,
				strlen(SHORT_LOC)) == 0));
#else
			return((strcmp(str, DE_COUNTRY_NAME) == 0) ||
	                    (strcmp(str, DE_LOCALITY_NAME) == 0));
#endif
		case LOCALITY:
#ifdef USELDAP
			return (strncmp(str, SHORT_LOC,
				strlen(SHORT_LOC)) == 0);
#else
			return (strcmp(str, DE_LOCALITY_NAME) == 0);
#endif
		case ORG:
#ifdef USELDAP
			return (strncmp(str, SHORT_ORG,
                                strlen(SHORT_ORG)) == 0);
#else
			return (strcmp(str, DE_ORGANISATION_NAME) == 0);
#endif USELDAP
		case ORGUNIT:
#ifdef USELDAP
			return (strncmp(str, SHORT_OU,
                                strlen(SHORT_OU)) == 0);
#else
			return (strcmp(str, DE_ORGANISATIONAL_UNIT_NAME) == 0);
#endif USELDAP
		default:
			(void)printf("WANT SOME MORE CODE IN rightObjectType()\n");
			return TRUE;
	}
}

void
logSearchSuccess(outcome, objecttype, string, searchNumber, noMatches)
char * outcome;
char * objecttype;
char * string;
int searchNumber;
int noMatches;
{
char filterNumberString[20];

	if (deLogLevel > 1)
	{
		if (searchNumber == 0)
			(void) strcpy(filterNumberString, "explicit");
		else
			(void) sprintf(filterNumberString, "%d", searchNumber);
		
#ifndef DOS
#ifdef USELDAP
		(void) fprintf (de_log,
			"%5d:searchOutcome:%s:%s:%s:%s:%d\n", depid, objecttype,
#else
		(void) ll_log (de_log, LLOG_NOTICE, NULLCP,
			"searchOutcome:%s:%s:%s:%s:%d", objecttype,
#endif USELDAP
			outcome, string, filterNumberString, noMatches);
#endif DOS
	}
}

void logListSuccess(outcome, objecttype, noMatches)
char * outcome;
char * objecttype;
int noMatches;
{
	if (deLogLevel > 1)
	{
#ifndef DOS
#ifdef USELDAP
		(void) fprintf (de_log,
			"%5d:listOutcome:%s:%s:%d\n", depid, objecttype, 
			outcome, noMatches);
#else
		(void) ll_log (de_log, LLOG_NOTICE, NULLCP,
			"listOutcome:%s:%s:%d", objecttype, outcome, noMatches);
#endif USELDAP
#endif DOS
	}
}

void logReadSuccess(outcome, objecttype)
char * outcome;
char * objecttype;
{
	if (deLogLevel > 1)
	{
#ifndef DOS
#ifdef USELDAP
		(void) fprintf (de_log,
			"%5d:readOutcome:%s:%s\n", depid, objecttype, outcome);
#else
		(void) ll_log (de_log, LLOG_NOTICE, NULLCP,
			"readOutcome:%s:%s", objecttype, outcome);
#endif USELDAP
#endif DOS
	}
}

void
printOrgOUDetails(objectType)
int objectType;
{
  
  if (mode == UFNLETTER)
    return;
  if (!((objectType == ORGUNIT) || (objectType == PERSON)))
    return;
  if (objectType == ORGUNIT)
    resetprint(SHOWORG);
  else /* person */
  {
    if (qinfo[PERSON].listlen > 1)
      return;
    if (qinfo[ORGUNIT].lp == NULLLIST)
      resetprint(SHOWORG);
    else
      resetprint(SHOWDEPT);
  }
  if (objectType == ORGUNIT)
  {
    printNames(ORG);
    printDetails(ORG, qinfo[ORG].lp);
    return;
  }
  else /* person */
  {
    if (qinfo[ORGUNIT].lp != NULLLIST)
    {
       printNames(ORGUNIT);
       printDetails(ORGUNIT, qinfo[ORGUNIT].lp);
    }
    else
    {
       printNames(ORG);
       printDetails(ORG, qinfo[ORG].lp);
    }
    return;
  }
}
/* Is str2 a sub-string of str1 */
issub_string(str1, str2)
char * str1, * str2;
{
        int i, len1, len2;
        char * cp;

        if (str1 == NULLCP || str2 == NULLCP)
                return -1;
        if ((len1 = strlen(str1)) <= (len2 = strlen(str2)))
                return -1;
        len1 = len1 - len2 + 1;
        cp = str1;
        for (i = 0, cp = str1;i < len1;i++, cp++)
                if (lexnequ(cp, str2, len2) == 0)
                        return 0;
        return -1;
}

char * deTidyString (a)
register char * a;
{
register char * b;
char * c;
register int i = 0;

	if (!*a)
		return (a);

	/* remove white space from front of string */
	while (isascii(*a) && isspace (*a))
		a++;

	/* removing multiple and trailing spaces */
	c = a, b = a;
	while (*a) {
		if (isascii(*a) && isspace (*a)) {
			*b = ' ';       /* make sure not a tab etc */
			a++;
			while (isascii(*a) && isspace (*a)) {
				a++;
				i = 1;
			}

			if (*a)
				b++;
			else
				break;
		}
		if (*a == '\b')
		{
			a++;
			if (b > c)
				b--;
			i = 1;
			continue;
		}
		if (i)
			*b = *a;

		a++, b++;
	}

	*b = 0;

	if (*--b == '\n')
		*b-- = 0;

	if (*b == ' ')
		*b = 0;

	return (c);
}
