/* video.c */

#ifndef lint
static char *rcsid = "$Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/video.c,v 9.2 1993/03/19 22:56:23 isode Exp isode $";
#endif

/*
 * $Header: /u1/home/isode/src/IC/IC-1/de/de/RCS/video.c,v 9.2 1993/03/19 22:56:23 isode Exp isode $
 *
 *
 * $Log: video.c,v $
 * Revision 9.2  1993/03/19  22:56:23  isode
 * Add QOS and DOS-DE code
 *
 * Revision 8.1  1991/09/13  14:36:41  isode
 * PARADISE Upgrade release
 *
 * Revision 8.0  91/07/17  13:18:51  isode
 * Release 7.0
 *
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#define video_c

#ifdef DOS
#include <stdlib.h>
#include <string.h>
#include "proto-de.h"
#include <varargs.h>
#include <signal.h>
#include <ctype.h>
#endif DOS
#include <stdio.h>
#include "messages.h"
#include "util.h"
#ifdef USELDAP
#include "isomanifest.h"
#include "demanifest.h"
#else
#include "quipu/util.h"
#endif USELDAP
#ifdef DOS
#undef putchar
#define putchar(c) gputchar(c)
extern int goneAsync;
#endif

#define LINES 24
#define COLS  80

static char *revVideoOn;
static char *resetVideo;
static char *cursorMotion = NULLCP;
static char *clLine = NULLCP;
static char *startLine = NULLCP;
static char *bellCode = NULLCP;
static char bp[1024];
static char buffer[1024];

#ifndef DOS
extern int wanAccess;

char term[80];
int preferInvVideo = TRUE;
#endif DOS
int inverseVideo;
int lines = LINES, cols = COLS;
#ifdef DOS
#include <graph.h>
#include <dos.h>
#include <bios.h>
#define DEFFGCOL (short) 8 /* Dark Grey */
#define DEFREVFGCOL (short) 0 /* Black */
#define DEFBGCOL (long) 11 /* Light Cyan */
#define NOFGCOL (short) 32
#define NOBGCOL (long) 32
short fgcol=NOFGCOL, revfgcol=NOFGCOL;
long bgcol=NOBGCOL;
extern int controlCtoQuit;
#endif DOS

char * getenv();
char * tgetstr();
char * tgoto();
char *deTidyString();
#ifndef DOS
char *checkSetTerm();
int output();
#endif DOS
void turnInverseVideoOn();

#ifdef DOS
void
oldVideo( void )
{
  _setvideomode(_DEFAULTMODE);
}
#endif DOS

void
initVideo()
{
#ifdef DOS
  if (fgcol == NOFGCOL)
    fgcol = DEFFGCOL;
  if (revfgcol == NOFGCOL)
    revfgcol = DEFREVFGCOL;
  if (bgcol == NOBGCOL)
    bgcol = DEFBGCOL;
  _settextcolor(fgcol);
  _setbkcolor(bgcol);
/*
  _settextrows((short)43);
 */
  _clearscreen(_GCLEARSCREEN);
  _wrapon(_GWRAPOFF);
  atexit( oldVideo );
  lines = 25;
  cols = 80;
#else
char * cp;

  inverseVideo = FALSE;
  cp = getenv("TERM");
  if (cp == (char *)NULL)
    cp = "network";
  cp = checkSetTerm(cp, "network");
  (void) strcpy(term, cp);
#endif DOS
}

#ifndef DOS
char *
checkSetTerm(termtype, defterm)
char * termtype, * defterm;
{
char * cp;
char buf[1024];
int n, ret;

  for (;;)
  {
    if (lexequ(termtype, LISTTERMCHAR) == 0)
    {
      displayHelp("termtypes");
      (void) strcpy(termtype, defterm);
    }
    else
    {
      ret = tgetent(bp, termtype);
      if (ret == 1)
        break; /* got a valid terminal type */
      (void) fprintf(stdout, DONTKNOWTERMTYPE, termtype);
    }
    (void) fprintf(stdout, ENTERTERMTYPE);
    if (gets(buf) == NULLCP)
    {
      clearerr(stdin);
      if (lines == 0) /* if no term size, set suitable defaults */
      {
	lines = LINES;
	cols = COLS;
      }
      return defterm;
    }
    termtype = deTidyString(buf);
    if (strlen(termtype) == 0) /* default accepted */
    {
      if (lines == 0) /* if no term size, set suitable defaults */
      {
	lines = LINES;
	cols = COLS;
      }
      return defterm;
    }
  }

  cp = buffer;
  revVideoOn = tgetstr("mr", &cp);
  resetVideo = tgetstr("me", &cp);
  if (preferInvVideo == TRUE)
    turnInverseVideoOn();

  lines = tgetnum("li");
  if (lines < 1)
    lines = LINES;
  if (wanAccess == TRUE)
    if (lines > LINES)
    {
      (void) fprintf(stdout, SCREENSIZE, lines);
      (void) fprintf(stdout, SCREENOK);
      for (;;)
      {
        (void) fprintf(stdout, SCREENLEN);
        if (gets(buf) == NULLCP)
          clearerr(stdin);
        else if (strlen(buf) != 0)
        {
          n = atoi(buf);
	  if (n > 0)
	  {
	    lines = n;
	    break;
	  }
	  else
	    continue;
	}
        break; /* default screen length accepted */
      }
    }
  cols = tgetnum("co");
  if (cols == 0)
    cols = COLS;

  cursorMotion = tgetstr("cm", &cp);
  if (cursorMotion != NULLCP)
    startLine = tgoto(cursorMotion, 0, lines - 1);
  clLine = tgetstr("ce", &cp);
  bellCode = tgetstr("bl", &cp);
  return termtype;
}
#endif DOS

void
soundBell()
{
#ifndef DOS
  if (bellCode != NULLCP)
    tputs(bellCode, 1, output);
  else
#endif
    (void) putchar(7);
}

#ifdef DOS
void
#endif
output(c)
char c;
{
#ifdef DOS
char str[2];

  (void)sprintf(str, "%c", c);
  _outtext(str);
#else
  (void) putchar(c);
#endif DOS
}

void
turnInverseVideoOn()
{
#ifdef DOS
 inverseVideo = TRUE;
#else
 if ((revVideoOn == (char *)NULL) || (resetVideo == (char *)NULL))
   inverseVideo = FALSE;
 else
   inverseVideo = TRUE;
#endif DOS
}

void
turnInverseVideoOff()
{
   inverseVideo = FALSE;
}

#ifdef DOS
void
#endif DOS
writeInverse(str)
char * str;
{
#ifdef DOS
  _settextcolor(revfgcol);
  _outtext(str);
  _settextcolor(fgcol);
#else
  if (inverseVideo == TRUE)
    tputs(revVideoOn, 1, output);
  (void) fputs(str, stdout);
  if (inverseVideo == TRUE)
    tputs(resetVideo, 1, output);
#endif DOS
}

#ifdef DOS
void
#endif DOS
clearLine()
{
int i;
#ifdef DOS
struct _rccoord curpos;

  curpos = _gettextposition();
  _settextposition(curpos.row, (short)0);
  for (i = 1; i < 80; i++)
    _outtext(" ");
  _settextposition(curpos.row, (short)0);
#else

  if (startLine != NULLCP)
  {
    tputs(startLine, 1, output);
    if (clLine != NULLCP)
      tputs(clLine, 1, output);
    else
      for (i = 1; i < 80; i++)
        (void) putchar(' ');
    tputs(startLine, 1, output);
  }
  else
    (void) putchar('\n');
#endif DOS
}

#ifdef DOS
printf(va_alist)
va_dcl
{
va_list ap;
char buf[BUFSIZ];
char *fmt;
int ret;

  va_start (ap);
  fmt = va_arg(ap, char *);
  ret = vsprintf (buf, fmt, ap);
  _outtext(buf);
  va_end(ap);
  return(ret);
}

fprintf(va_alist)
va_dcl
{
va_list ap;
char buf[BUFSIZ];
char *fmt;
FILE * stream;
int ret;

  va_start (ap);
  stream = va_arg(ap, FILE *);
  fmt = va_arg(ap, char *);
  ret = vsprintf (buf, fmt, ap);
  _outtext(buf);
  va_end(ap);
  return(ret);
}

int
fputs(str, stream)
char * str;
FILE * stream;
{
  _outtext(str);
  return(0);
}

int
gputchar(c)
int c;
{
char str[2];

  (void)sprintf(str, "%c", (char)c);
  _outtext(str);
  return(c);
}

void
goToStartOfLine()
{
struct _rccoord pos;

  pos = _gettextposition();
  _settextposition(pos.row + 1, (short)0);
}

char *
gets(buffer)
char * buffer;
{
char * p1 = buffer;
char c;
struct _rccoord pos;


  while ((c = (char)(_bios_keybrd(_KEYBRD_READ) & 0xff)) != '\r')
    switch(c)
    {
      case '\b': /* Backspace */
	pos = _gettextposition();
	if (p1 > buffer) {
	  _settextposition(pos.row, pos.col - 1);
	  gputchar(' ');
	  _settextposition(pos.row, pos.col - 1);
	  p1--;
	  *p1 = '\0';
	}
	break;
      case '\003': /* CTRL-C */
	writeInverse("^C");
	cleanupok(0);
	break;
      case '\033': /* ESCAPE */
	if (p1 == buffer) {
	  writeInverse("ESC");
	  if (controlCtoQuit == TRUE)
	    cleanupok(0);
	  else
	    onint1(0);
	}
	else while (p1 > buffer) {
	  pos = _gettextposition();
	  _settextposition(pos.row, pos.col - 1);
	  gputchar(' ');
	  _settextposition(pos.row, pos.col - 1);
	  p1--;
	  *p1 = '\0';
	}
	break;
      default:
	if (isprint(c)) {
	  gputchar(c);
	  *p1++ = c;
	}
	break;
    }
  *p1 = '\0';
  gputchar('\n');
  return buffer;
}

void
sleep(secs)
int secs;
{
long int start;

  start = getTicks();
  while (difference(start) < 18 * secs);
}

long int
getTicks()
{
union _REGS in, out;

  in.x.ax = 0x0000;
  int86(0x1A, &in, &out);
  return((long int)(((long int)out.x.cx)*0x10000 + out.x.dx));
}

int difference(t1)
long int t1;
{
long int t2;

  t2 = getTicks();
  if (t1 <= t2)
    return(t2 - t1);
  else
    return((long int)0x1800B0 - t1 + t2);
}

void
checkCtrlC()
{
  char c;

  while (_bios_keybrd(_KEYBRD_READY) != 0) {
    c = (char)(_bios_keybrd(_KEYBRD_READ) & 0xff);
    switch(c) {
    case '\003':
      abandonops(0);
      cleanupok(0);
      break;
    case '\033':
      writeInverse("\nESC\n");
      if (goneAsync)
	abandonops(0);
      else
	onint1(0);
      break;
    }
  }
}

int
_getch()
{
char c;

  c = (char)(_bios_keybrd(_KEYBRD_READ) & 0xff);
  switch(c) {
  case '\003':
    writeInverse("^C");
    cleanupok(0);
    break;
  case '\033':
    writeInverse("ESC");
    if (controlCtoQuit == TRUE)
      cleanupok(0);
    else
      onint1(0);
    break;
  }
  return (int)c;
}
#endif DOS
