/* yp.c 
 *
 *  Yellowish pages
 */

#ifndef lint
static char *rcsid = "$Header$";
#endif

/*
 * $Header$
 *
 *
 * $Log$
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#define yp_c
#ifdef DOS
#include <stdlib.h>
#include "proto-de.h"
#include <graph.h>
#endif DOS
#define helpscreens
#include <ctype.h>
#include <signal.h>
#ifdef USELDAP
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "isomanifest.h"
#endif USELDAP
#include "query.h"
#include "messages.h"
#include "demanifest.h"
#include "namelist.h"
#ifndef USELDAP
#ifdef IC
#include "compat/tailor.h"
#else
#include "tailor.h"
#endif /* IC */
#include "quipu/util.h"
#include "quipu/attr.h"
#ifdef IC
#include "compat/logger.h"
#else
#include "logger.h"
#endif /* IC */
#endif USELDAP

#ifdef USELDAP
#ifndef DOS
extern FILE * de_log;
#endif DOS
#else
extern LLog *de_log;
#endif USELDAP
#ifndef DOS
#endif DOS
extern struct query qinfo[];
char *deTidyString();
void displayCurrentSettings();
void soundBell();

extern struct namelist * ypatts;

/* returns number of yp atts in list */
int
displayYpatts()
{
int i;
struct namelist * x;
char * mapAttName();

  pageprint(YPSELECTED);
  for (i = 1, x = ypatts; x != NULLLIST; i++, x = x->next)
    pageprint("%3d: %s\n", i, mapAttName(x->name));
  pageprint("\n");
  return i - 1;
}

char * 
enterYPString(str)
char * str;
{
char buf[BUFSIZ];
char * cp;

  startUnbindTimer();
  if ((cp = gets(buf)) == NULLCP)
    clearerr(stdin);
  stopUnbindTimer();
  if (cp != NULLCP)
  {
    cp = deTidyString(buf);
    (void)strcpy(str, cp);
  }
  return cp;
}

void
doYellow()
{
SFD cleanupok();
void onint1();
int i, n, noypatts = 0;
char buf[1024];
char atttype[1024], attval[1024];
struct namelist * x;
extern void turnInverseVideoOn(), turnInverseVideoOff();

#ifdef DOS
    (void) signal(SIGINT, SIG_IGN);
#else
    if (signal(SIGINT, SIG_IGN) != SIG_IGN)
      (void) signal(SIGINT, onint1);
#endif
    (void) sprintf(qinfo[PERSON].entered, "%c", MENULETTER);
    (void) strcpy(qinfo[PERSON].defvalue, "");
    for (;;)
    {
      noypatts = displayYpatts();
      initPage();
      (void) writeInverse(ENTERATTTYPE);
      (void) putchar(' ');
      if (enterYPString(atttype) == NULLCP) /* user obviously not interested */
      {
	goto resetSignal;
      }
      if (strcmp(atttype, "") == 0)
      {
        goto resetSignal;
      }
      if (lexnequ(atttype, QUITWORD, strlen(atttype)) == 0)
      {
        goto resetSignal;
      }
      if (*atttype == QUESTIONMARK)
      {
        displayHelp(findHelp(YELLOWHELP));
        continue;
      }
      if ((n = atoi(atttype)) != 0)
      {
        if (n > noypatts)
        {
          soundBell();
          (void) printf(ATTNORANGEPROB);
          continue;
	}
        for (i = 1, x = ypatts; i < n; i++, x = x->next) {};
        (void) strcpy(atttype, x->name);
      }
#ifndef USELDAP
      if (str2AttrT(atttype) == NULLAttrT)
      {
        soundBell();
        (void) printf(NOSUCHATTT);
        continue;
      }
#endif
      (void) writeInverse(ENTERATTVAL);
      (void) putchar(' ');
      if (enterYPString(attval) == NULLCP)
      {
        continue; /* re-enter att type */
      }
      if (strcmp(attval, "") == 0)
        continue;
      if (index(attval, '*') != 0)
        n = 1; /* force equality matching if wildcard entered in value string */
      else
      {
        for (;;)
        {
          (void) pageprint(MATCHTYPES);
          (void) writeInverse(ENTERMATCHTYPE);
          (void) putchar(' ');
          if (enterYPString(buf) == NULLCP)
          {
            n = 0;
            break;
          }
          n = atoi(buf);
          if (n == 0)
            break;
          if (n > 3)
          {
            soundBell();
            continue;
	  }
          break; /* valid match type */
        }
        if (n == 0)
          continue; /* re-enter att type */
      }
      switch (n)
      {
        case 1: (void)sprintf(qinfo[PERSON].entered, "%s=%s", atttype, attval);
                break;
        case 2: (void)sprintf(qinfo[PERSON].entered, "%s=*%s*", atttype, attval);
                break;
        case 3: (void)sprintf(qinfo[PERSON].entered, "%s~=%s", atttype, attval);
                break;
      }
      pageprint(SEARCHSCOPE);
      break;
    }
resetSignal:
#ifdef DOS
    signal(SIGINT, SIG_IGN);
#else
    if (signal(SIGINT, SIG_IGN) != SIG_IGN)
      (void) signal(SIGINT, cleanupok);
#endif DOS
    initPage();
    return;
}

